(* --------------------------------------------------------------------------------
   Autogenerated by the happy scrappy WHIZARD model file generator on 12/12/2011 , 22:22:51
   WHIZARD interface svn revision info: $Id: WOMathematicaInterface.m 3583 2011-11-16 17:21:25Z cnspeckn $
   Code generated for WHIZARD / O'Mega version 2.0.3
   Model name: fr_mssm
   Gauge: Unitarity
   Maximum number of couplings per FORTRAN module: 500
   --------------------------------------------------------------------------------
   FeynRules model: MSSM
   FeynRules version: $Revision: 742 $
   -------------------------------------------------------------------------------- *)

type gauge = Unitarity | Feynman | Rxi

module type Frules_options =
sig
   val gauge: gauge
   val color: bool
end

module Implementation (Opts: Frules_options) =
struct

   open Coupling

   (* Classes with their members *)

   type v1_A =
      | A_1
   type v2_Z =
      | Z_1
   type v3_W =
      | W_plus | W_minus
   type v4_G =
      | G_1
   type f1_Neu =
      | N1 | N2 | N3 | N4
   type f2_Ch =
      | X1_plus | X1_minus | X2_plus | X2_minus
   type f3_Go =
      | Go_1
   type s1_H0 =
      | H01
   type s2_H0_1 =
      | H02
   type s3_A0 =
      | A0_1
   type s4_H =
      | H_plus | H_minus
   type s5_G0 =
      | G0_1
   type s6_GP =
      | G_plus | G_minus
   type f4_Vl =
      | Ve | Ve_bar | Vm | Vm_bar | Vt | Vt_bar
   type f5_L =
      | E_minus | E_plus | Mu_minus | Mu_plus | Tau_minus | Tau_plus
   type f6_Uq =
      | U | U_bar | C | C_bar | T | T_bar
   type f7_Dq =
      | D | D_bar | S | S_bar | B | B_bar
   type s7_Sn =
      | Sv1 | Sv1_bar | Sv2 | Sv2_bar | Sv3 | Sv3_bar
   type s8_Sl =
      | Sl1_minus | Sl1_plus | Sl2_minus | Sl2_plus | Sl3_minus | Sl3_plus
      | Sl4_minus | Sl4_plus | Sl5_minus | Sl5_plus | Sl6_minus | Sl6_plus
   type s9_Su =
      | Su1 | Su1_bar | Su2 | Su2_bar | Su3 | Su3_bar | Su4 | Su4_bar | Su5 | Su5_bar
      | Su6 | Su6_bar
   type s10_Sd =
      | Sd1 | Sd1_bar | Sd2 | Sd2_bar | Sd3 | Sd3_bar | Sd4 | Sd4_bar | Sd5 | Sd5_bar
      | Sd6 | Sd6_bar

   (* Lorentz types with the corresponding classes *)

   type scalar =
      | S1_H0 of s1_H0 | S2_H0_1 of s2_H0_1 | S3_A0 of s3_A0 | S4_H of s4_H
      | S5_G0 of s5_G0 | S6_GP of s6_GP | S7_Sn of s7_Sn | S8_Sl of s8_Sl
      | S9_Su of s9_Su | S10_Sd of s10_Sd
   type fermion =
      | F1_Neu of f1_Neu | F2_Ch of f2_Ch | F3_Go of f3_Go | F4_Vl of f4_Vl
      | F5_L of f5_L | F6_Uq of f6_Uq | F7_Dq of f7_Dq
   type vector =
      | V1_A of v1_A | V2_Z of v2_Z | V3_W of v3_W | V4_G of v4_G

   (* The actual flavor type *)

   type flavor =
      | FRS of scalar | FRF of fermion | FRV of vector

   (* Trampoline functions *)

   let vector_of_v1_A c = V1_A c
   let vector_of_v2_Z c = V2_Z c
   let vector_of_v3_W c = V3_W c
   let vector_of_v4_G c = V4_G c
   let fermion_of_f1_Neu c = F1_Neu c
   let fermion_of_f2_Ch c = F2_Ch c
   let fermion_of_f3_Go c = F3_Go c
   let scalar_of_s1_H0 c = S1_H0 c
   let scalar_of_s2_H0_1 c = S2_H0_1 c
   let scalar_of_s3_A0 c = S3_A0 c
   let scalar_of_s4_H c = S4_H c
   let scalar_of_s5_G0 c = S5_G0 c
   let scalar_of_s6_GP c = S6_GP c
   let fermion_of_f4_Vl c = F4_Vl c
   let fermion_of_f5_L c = F5_L c
   let fermion_of_f6_Uq c = F6_Uq c
   let fermion_of_f7_Dq c = F7_Dq c
   let scalar_of_s7_Sn c = S7_Sn c
   let scalar_of_s8_Sl c = S8_Sl c
   let scalar_of_s9_Su c = S9_Su c
   let scalar_of_s10_Sd c = S10_Sd c
   let flavor_of_scalar lt = FRS lt
   let flavor_of_fermion lt = FRF lt
   let flavor_of_vector lt = FRV lt

   (* Particle lists *)

   let v1_A_members =
      [A_1;]
   let v2_Z_members =
      [Z_1;]
   let v3_W_members =
      [W_plus; W_minus;]
   let v4_G_members =
      [G_1;]
   let f1_Neu_members =
      [N1; N2; N3; N4;]
   let f2_Ch_members =
      [X1_plus; X1_minus; X2_plus; X2_minus;]
   let f3_Go_members =
      [Go_1;]
   let s1_H0_members =
      [H01;]
   let s2_H0_1_members =
      [H02;]
   let s3_A0_members =
      [A0_1;]
   let s4_H_members =
      [H_plus; H_minus;]
   let s5_G0_members =
      [G0_1;]
   let s6_GP_members =
      [G_plus; G_minus;]
   let f4_Vl_members =
      [Ve; Ve_bar; Vm; Vm_bar; Vt; Vt_bar;]
   let f5_L_members =
      [E_minus; E_plus; Mu_minus; Mu_plus; Tau_minus; Tau_plus;]
   let f6_Uq_members =
      [U; U_bar; C; C_bar; T; T_bar;]
   let f7_Dq_members =
      [D; D_bar; S; S_bar; B; B_bar;]
   let s7_Sn_members =
      [Sv1; Sv1_bar; Sv2; Sv2_bar; Sv3; Sv3_bar;]
   let s8_Sl_members =
      [Sl1_minus; Sl1_plus; Sl2_minus; Sl2_plus; Sl3_minus; Sl3_plus; Sl4_minus;
       Sl4_plus; Sl5_minus; Sl5_plus; Sl6_minus; Sl6_plus;]
   let s9_Su_members =
      [Su1; Su1_bar; Su2; Su2_bar; Su3; Su3_bar; Su4; Su4_bar; Su5; Su5_bar; Su6;
       Su6_bar;]
   let s10_Sd_members =
      [Sd1; Sd1_bar; Sd2; Sd2_bar; Sd3; Sd3_bar; Sd4; Sd4_bar; Sd5; Sd5_bar; Sd6;
       Sd6_bar;]
   let all_scalars = []
      @ (List.map scalar_of_s1_H0 s1_H0_members)
      @ (List.map scalar_of_s2_H0_1 s2_H0_1_members)
      @ (List.map scalar_of_s3_A0 s3_A0_members)
      @ (List.map scalar_of_s4_H s4_H_members)
      @ (List.map scalar_of_s5_G0 s5_G0_members)
      @ (List.map scalar_of_s6_GP s6_GP_members)
      @ (List.map scalar_of_s7_Sn s7_Sn_members)
      @ (List.map scalar_of_s8_Sl s8_Sl_members)
      @ (List.map scalar_of_s9_Su s9_Su_members)
      @ (List.map scalar_of_s10_Sd s10_Sd_members)
   let all_fermions = []
      @ (List.map fermion_of_f1_Neu f1_Neu_members)
      @ (List.map fermion_of_f2_Ch f2_Ch_members)
      @ (List.map fermion_of_f3_Go f3_Go_members)
      @ (List.map fermion_of_f4_Vl f4_Vl_members)
      @ (List.map fermion_of_f5_L f5_L_members)
      @ (List.map fermion_of_f6_Uq f6_Uq_members)
      @ (List.map fermion_of_f7_Dq f7_Dq_members)
   let all_vectors = []
      @ (List.map vector_of_v1_A v1_A_members)
      @ (List.map vector_of_v2_Z v2_Z_members)
      @ (List.map vector_of_v3_W v3_W_members)
      @ (List.map vector_of_v4_G v4_G_members)

   (* The conjugation operation on a single class *)

   let conjugate_v1_A = function 
      | x -> x
   let conjugate_v2_Z = function 
      | x -> x
   let conjugate_v3_W = function 
      | W_plus -> W_minus | W_minus -> W_plus
   let conjugate_v4_G = function 
      | x -> x
   let conjugate_f1_Neu = function 
      | x -> x
   let conjugate_f2_Ch = function 
      | X1_plus -> X1_minus | X1_minus -> X1_plus | X2_plus -> X2_minus
      | X2_minus -> X2_plus
   let conjugate_f3_Go = function 
      | x -> x
   let conjugate_s1_H0 = function 
      | x -> x
   let conjugate_s2_H0_1 = function 
      | x -> x
   let conjugate_s3_A0 = function 
      | x -> x
   let conjugate_s4_H = function 
      | H_plus -> H_minus | H_minus -> H_plus
   let conjugate_s5_G0 = function 
      | x -> x
   let conjugate_s6_GP = function 
      | G_plus -> G_minus | G_minus -> G_plus
   let conjugate_f4_Vl = function 
      | Ve -> Ve_bar | Ve_bar -> Ve | Vm -> Vm_bar | Vm_bar -> Vm | Vt -> Vt_bar
      | Vt_bar -> Vt
   let conjugate_f5_L = function 
      | E_minus -> E_plus | E_plus -> E_minus | Mu_minus -> Mu_plus
      | Mu_plus -> Mu_minus | Tau_minus -> Tau_plus | Tau_plus -> Tau_minus
   let conjugate_f6_Uq = function 
      | U -> U_bar | U_bar -> U | C -> C_bar | C_bar -> C | T -> T_bar | T_bar -> T
   let conjugate_f7_Dq = function 
      | D -> D_bar | D_bar -> D | S -> S_bar | S_bar -> S | B -> B_bar | B_bar -> B
   let conjugate_s7_Sn = function 
      | Sv1 -> Sv1_bar | Sv1_bar -> Sv1 | Sv2 -> Sv2_bar | Sv2_bar -> Sv2
      | Sv3 -> Sv3_bar | Sv3_bar -> Sv3
   let conjugate_s8_Sl = function 
      | Sl1_minus -> Sl1_plus | Sl1_plus -> Sl1_minus | Sl2_minus -> Sl2_plus
      | Sl2_plus -> Sl2_minus | Sl3_minus -> Sl3_plus | Sl3_plus -> Sl3_minus
      | Sl4_minus -> Sl4_plus | Sl4_plus -> Sl4_minus | Sl5_minus -> Sl5_plus
      | Sl5_plus -> Sl5_minus | Sl6_minus -> Sl6_plus | Sl6_plus -> Sl6_minus
   let conjugate_s9_Su = function 
      | Su1 -> Su1_bar | Su1_bar -> Su1 | Su2 -> Su2_bar | Su2_bar -> Su2
      | Su3 -> Su3_bar | Su3_bar -> Su3 | Su4 -> Su4_bar | Su4_bar -> Su4
      | Su5 -> Su5_bar | Su5_bar -> Su5 | Su6 -> Su6_bar | Su6_bar -> Su6
   let conjugate_s10_Sd = function 
      | Sd1 -> Sd1_bar | Sd1_bar -> Sd1 | Sd2 -> Sd2_bar | Sd2_bar -> Sd2
      | Sd3 -> Sd3_bar | Sd3_bar -> Sd3 | Sd4 -> Sd4_bar | Sd4_bar -> Sd4
      | Sd5 -> Sd5_bar | Sd5_bar -> Sd5 | Sd6 -> Sd6_bar | Sd6_bar -> Sd6

   (* The conjugation operation on a lorentz type *)

   let conjugate_scalar = function 
      | S1_H0 x -> S1_H0 (conjugate_s1_H0 x)
      | S2_H0_1 x -> S2_H0_1 (conjugate_s2_H0_1 x)
      | S3_A0 x -> S3_A0 (conjugate_s3_A0 x)
      | S4_H x -> S4_H (conjugate_s4_H x)
      | S5_G0 x -> S5_G0 (conjugate_s5_G0 x)
      | S6_GP x -> S6_GP (conjugate_s6_GP x)
      | S7_Sn x -> S7_Sn (conjugate_s7_Sn x)
      | S8_Sl x -> S8_Sl (conjugate_s8_Sl x)
      | S9_Su x -> S9_Su (conjugate_s9_Su x)
      | S10_Sd x -> S10_Sd (conjugate_s10_Sd x)
   let conjugate_fermion = function 
      | F1_Neu x -> F1_Neu (conjugate_f1_Neu x)
      | F2_Ch x -> F2_Ch (conjugate_f2_Ch x)
      | F3_Go x -> F3_Go (conjugate_f3_Go x)
      | F4_Vl x -> F4_Vl (conjugate_f4_Vl x)
      | F5_L x -> F5_L (conjugate_f5_L x)
      | F6_Uq x -> F6_Uq (conjugate_f6_Uq x)
      | F7_Dq x -> F7_Dq (conjugate_f7_Dq x)
   let conjugate_vector = function 
      | V1_A x -> V1_A (conjugate_v1_A x)
      | V2_Z x -> V2_Z (conjugate_v2_Z x)
      | V3_W x -> V3_W (conjugate_v3_W x)
      | V4_G x -> V4_G (conjugate_v4_G x)

   (* Conjugation for the masses *)

   let conjugate = function
      | FRS x -> FRS (conjugate_scalar x)
      | FRF x -> FRF (conjugate_fermion x)
      | FRV x -> FRV (conjugate_vector x)

   let color = function
      | FRS x -> (match x with 
         | S1_H0 _ -> Color.Singlet
         | S2_H0_1 _ -> Color.Singlet
         | S3_A0 _ -> Color.Singlet
         | S4_H _ -> Color.Singlet
         | S5_G0 _ -> Color.Singlet
         | S6_GP _ -> Color.Singlet
         | S7_Sn _ -> Color.Singlet
         | S8_Sl _ -> Color.Singlet
         | S9_Su x -> (match x with 
            | Su1 | Su2 | Su3 | Su4 | Su5 | Su6 -> Color.SUN 3
            | Su1_bar | Su2_bar | Su3_bar | Su4_bar | Su5_bar | Su6_bar -> Color.SUN (-3))

         | S10_Sd x -> (match x with 
            | Sd1 | Sd2 | Sd3 | Sd4 | Sd5 | Sd6 -> Color.SUN 3
            | Sd1_bar | Sd2_bar | Sd3_bar | Sd4_bar | Sd5_bar | Sd6_bar -> Color.SUN (-3)))
      | FRF x -> (match x with 
         | F1_Neu _ -> Color.Singlet
         | F2_Ch _ -> Color.Singlet
         | F3_Go Go_1 -> Color.AdjSUN 3
         | F4_Vl _ -> Color.Singlet
         | F5_L _ -> Color.Singlet
         | F6_Uq x -> (match x with 
            | U | C | T -> Color.SUN 3 | U_bar | C_bar | T_bar -> Color.SUN (-3))
         | F7_Dq x -> (match x with 
            | D | S | B -> Color.SUN 3 | D_bar | S_bar | B_bar -> Color.SUN (-3)))
      | FRV x -> (match x with 
         | V1_A _ -> Color.Singlet
         | V2_Z _ -> Color.Singlet
         | V3_W _ -> Color.Singlet
         | V4_G G_1 -> Color.AdjSUN 3)

   let pdg = function
      | FRS x -> (match x with 
         | S1_H0 H01 -> 25
         | S2_H0_1 H02 -> 35
         | S3_A0 A0_1 -> 36
         | S4_H x -> (match x with 
            | H_plus -> 37 | H_minus -> -37)
         | S5_G0 G0_1 -> 250
         | S6_GP x -> (match x with 
            | G_plus -> 251 | G_minus -> -251)
         | S7_Sn x -> (match x with 
            | Sv1 -> 1000012 | Sv1_bar -> -1000012 | Sv2 -> 1000014 | Sv2_bar -> -1000014
            | Sv3 -> 1000016 | Sv3_bar -> -1000016)
         | S8_Sl x -> (match x with 
            | Sl1_minus -> 1000011 | Sl1_plus -> -1000011 | Sl2_minus -> 1000013
            | Sl2_plus -> -1000013 | Sl3_minus -> 1000015 | Sl3_plus -> -1000015
            | Sl4_minus -> 2000011 | Sl4_plus -> -2000011 | Sl5_minus -> 2000013
            | Sl5_plus -> -2000013 | Sl6_minus -> 2000015 | Sl6_plus -> -2000015)
         | S9_Su x -> (match x with 
            | Su1 -> 1000002 | Su1_bar -> -1000002 | Su2 -> 1000004 | Su2_bar -> -1000004
            | Su3 -> 1000006 | Su3_bar -> -1000006 | Su4 -> 2000002 | Su4_bar -> -2000002
            | Su5 -> 2000004 | Su5_bar -> -2000004 | Su6 -> 2000006 | Su6_bar -> -2000006)

         | S10_Sd x -> (match x with 
            | Sd1 -> 1000001 | Sd1_bar -> -1000001 | Sd2 -> 1000003 | Sd2_bar -> -1000003
            | Sd3 -> 1000005 | Sd3_bar -> -1000005 | Sd4 -> 2000001 | Sd4_bar -> -2000001
            | Sd5 -> 2000003 | Sd5_bar -> -2000003 | Sd6 -> 2000005 | Sd6_bar -> -2000005))
      | FRF x -> (match x with 
         | F1_Neu x -> (match x with 
            | N1 -> 1000022 | N2 -> 1000023 | N3 -> 1000025 | N4 -> 1000035)
         | F2_Ch x -> (match x with 
            | X1_plus -> 1000024 | X1_minus -> -1000024 | X2_plus -> 1000037
            | X2_minus -> -1000037)
         | F3_Go Go_1 -> 1000021
         | F4_Vl x -> (match x with 
            | Ve -> 12 | Ve_bar -> -12 | Vm -> 14 | Vm_bar -> -14 | Vt -> 16 | Vt_bar -> -16)

         | F5_L x -> (match x with 
            | E_minus -> 11 | E_plus -> -11 | Mu_minus -> 13 | Mu_plus -> -13
            | Tau_minus -> 15 | Tau_plus -> -15)
         | F6_Uq x -> (match x with 
            | U -> 2 | U_bar -> -2 | C -> 4 | C_bar -> -4 | T -> 6 | T_bar -> -6)
         | F7_Dq x -> (match x with 
            | D -> 1 | D_bar -> -1 | S -> 3 | S_bar -> -3 | B -> 5 | B_bar -> -5))
      | FRV x -> (match x with 
         | V1_A A_1 -> 22
         | V2_Z Z_1 -> 23
         | V3_W x -> (match x with 
            | W_plus -> 24 | W_minus -> -24)
         | V4_G G_1 -> 21)

   let lorentz = function
      | FRF x -> (match x with 
         | F1_Neu x -> (match x with 
            | N1 | N2 | N3 | N4 -> Majorana)
         | F2_Ch x -> (match x with 
            | X1_plus | X2_plus -> Spinor | X1_minus | X2_minus -> ConjSpinor)
         | F3_Go Go_1 -> Majorana
         | F4_Vl x -> (match x with 
            | Ve | Vm | Vt -> Spinor | Ve_bar | Vm_bar | Vt_bar -> ConjSpinor)
         | F5_L x -> (match x with 
            | E_minus | Mu_minus | Tau_minus -> Spinor
            | E_plus | Mu_plus | Tau_plus -> ConjSpinor)
         | F6_Uq x -> (match x with 
            | U | C | T -> Spinor | U_bar | C_bar | T_bar -> ConjSpinor)
         | F7_Dq x -> (match x with 
            | D | S | B -> Spinor | D_bar | S_bar | B_bar -> ConjSpinor))
      | FRV x -> (match x with 
         | V1_A A_1 -> Vector
         | V2_Z Z_1 -> Massive_Vector
         | V3_W x -> (match x with 
            | W_plus | W_minus -> Massive_Vector)
         | V4_G G_1 -> Vector)
      | FRS _ -> Scalar

   type gauge = Xi

   let propagator = 
      let msg = "fr_mssm.Implementation: invalid lorentz rep in propagator" in function
      | FRS _ -> Prop_Scalar
      | FRF x -> (match lorentz (FRF x) with
         | Spinor -> Prop_Spinor
         | ConjSpinor -> Prop_ConjSpinor
         | Majorana -> Prop_Majorana
         | _ -> invalid_arg msg)
      | FRV x -> (match Opts.gauge with
         | Unitarity -> (match lorentz (FRV x) with
            | Vector -> Prop_Feynman
            | Massive_Vector -> Prop_Unitarity
            | _ -> invalid_arg msg)
         | Feynman -> (match lorentz (FRV x) with
            | Vector -> Prop_Feynman
            | Massive_Vector -> Prop_Rxi Xi
            | _ -> invalid_arg msg)
         | Rxi -> (match lorentz (FRV x) with
            | Vector -> Prop_Gauge Xi
            | Massive_Vector -> Prop_Rxi Xi
            | _ -> invalid_arg msg))

   let width_symbol = function
      | FRS x -> (match x with 
         | S1_H0 H01 -> "wh01"
         | S2_H0_1 H02 -> "wh02"
         | S3_A0 A0_1 -> "wa0"
         | S4_H x -> (match x with 
            | H_plus -> "wh" | H_minus -> "wh")
         | S5_G0 G0_1 -> "wg0"
         | S6_GP x -> (match x with 
            | G_plus -> "wgp" | G_minus -> "wgp")
         | S7_Sn x -> (match x with 
            | Sv1 -> "wsn1" | Sv1_bar -> "wsn1" | Sv2 -> "wsn2" | Sv2_bar -> "wsn2"
            | Sv3 -> "wsn3" | Sv3_bar -> "wsn3")
         | S8_Sl x -> (match x with 
            | Sl1_minus -> "wsl1" | Sl1_plus -> "wsl1" | Sl2_minus -> "wsl2"
            | Sl2_plus -> "wsl2" | Sl3_minus -> "wsl3" | Sl3_plus -> "wsl3"
            | Sl4_minus -> "wsl4" | Sl4_plus -> "wsl4" | Sl5_minus -> "wsl5"
            | Sl5_plus -> "wsl5" | Sl6_minus -> "wsl6" | Sl6_plus -> "wsl6")
         | S9_Su x -> (match x with 
            | Su1 -> "wsu1" | Su1_bar -> "wsu1" | Su2 -> "wsu2" | Su2_bar -> "wsu2"
            | Su3 -> "wsu3" | Su3_bar -> "wsu3" | Su4 -> "wsu4" | Su4_bar -> "wsu4"
            | Su5 -> "wsu5" | Su5_bar -> "wsu5" | Su6 -> "wsu6" | Su6_bar -> "wsu6")
         | S10_Sd x -> (match x with 
            | Sd1 -> "wsd1" | Sd1_bar -> "wsd1" | Sd2 -> "wsd2" | Sd2_bar -> "wsd2"
            | Sd3 -> "wsd3" | Sd3_bar -> "wsd3" | Sd4 -> "wsd4" | Sd4_bar -> "wsd4"
            | Sd5 -> "wsd5" | Sd5_bar -> "wsd5" | Sd6 -> "wsd6" | Sd6_bar -> "wsd6"))
      | FRF x -> (match x with 
         | F1_Neu x -> (match x with 
            | N2 -> "wneu2" | N3 -> "wneu3" | N4 -> "wneu4" | _ -> "fr_zero")
         | F2_Ch x -> (match x with 
            | X1_plus -> "wch1" | X1_minus -> "wch1" | X2_plus -> "wch2" | X2_minus -> "wch2")

         | F3_Go Go_1 -> "wgo"
         | F4_Vl _ -> "fr_zero"
         | F5_L _ -> "fr_zero"
         | F6_Uq x -> (match x with 
            | T -> "wt" | T_bar -> "wt" | _ -> "fr_zero")
         | F7_Dq _ -> "fr_zero")
      | FRV x -> (match x with 
         | V1_A _ -> "fr_zero"
         | V2_Z Z_1 -> "wz"
         | V3_W x -> (match x with 
            | W_plus -> "ww" | W_minus -> "ww")
         | V4_G _ -> "fr_zero")

   let width x = match width_symbol x with 
      | "fr_zero" -> Vanishing
      | _ -> Timelike

   let fermion x = (match lorentz x with
      | Spinor -> 1 | ConjSpinor -> -1 | Majorana -> 2 | _ -> 0)

   let colsymm _ = (0, false), (0, false)

   let flavors () = []
      @ (List.map flavor_of_scalar all_scalars)
      @ (List.map flavor_of_fermion all_fermions)
      @ (List.map flavor_of_vector all_vectors)

   let external_flavors () = ["Autogenerated flavors", flavors ()]

   let goldstone _ = None

   let flavor_to_string = function
      | FRS x -> (match x with 
         | S1_H0 H01 -> "h01"
         | S2_H0_1 H02 -> "h02"
         | S3_A0 A0_1 -> "A0"
         | S4_H x -> (match x with 
            | H_plus -> "H+" | H_minus -> "H-")
         | S5_G0 G0_1 -> "G0"
         | S6_GP x -> (match x with 
            | G_plus -> "G+" | G_minus -> "G-")
         | S7_Sn x -> (match x with 
            | Sv1 -> "sv1" | Sv1_bar -> "sv1~" | Sv2 -> "sv2" | Sv2_bar -> "sv2~"
            | Sv3 -> "sv3" | Sv3_bar -> "sv3~")
         | S8_Sl x -> (match x with 
            | Sl1_minus -> "sl1-" | Sl1_plus -> "sl1+" | Sl2_minus -> "sl2-"
            | Sl2_plus -> "sl2+" | Sl3_minus -> "sl3-" | Sl3_plus -> "sl3+"
            | Sl4_minus -> "sl4-" | Sl4_plus -> "sl4+" | Sl5_minus -> "sl5-"
            | Sl5_plus -> "sl5+" | Sl6_minus -> "sl6-" | Sl6_plus -> "sl6+")
         | S9_Su x -> (match x with 
            | Su1 -> "su1" | Su1_bar -> "su1~" | Su2 -> "su2" | Su2_bar -> "su2~"
            | Su3 -> "su3" | Su3_bar -> "su3~" | Su4 -> "su4" | Su4_bar -> "su4~"
            | Su5 -> "su5" | Su5_bar -> "su5~" | Su6 -> "su6" | Su6_bar -> "su6~")
         | S10_Sd x -> (match x with 
            | Sd1 -> "sd1" | Sd1_bar -> "sd1~" | Sd2 -> "sd2" | Sd2_bar -> "sd2~"
            | Sd3 -> "sd3" | Sd3_bar -> "sd3~" | Sd4 -> "sd4" | Sd4_bar -> "sd4~"
            | Sd5 -> "sd5" | Sd5_bar -> "sd5~" | Sd6 -> "sd6" | Sd6_bar -> "sd6~"))
      | FRF x -> (match x with 
         | F1_Neu x -> (match x with 
            | N1 -> "n1" | N2 -> "n2" | N3 -> "n3" | N4 -> "n4")
         | F2_Ch x -> (match x with 
            | X1_plus -> "x1+" | X1_minus -> "x1-" | X2_plus -> "x2+" | X2_minus -> "x2-")

         | F3_Go Go_1 -> "go"
         | F4_Vl x -> (match x with 
            | Ve -> "ve" | Ve_bar -> "ve~" | Vm -> "vm" | Vm_bar -> "vm~" | Vt -> "vt"
            | Vt_bar -> "vt~")
         | F5_L x -> (match x with 
            | E_minus -> "e-" | E_plus -> "e+" | Mu_minus -> "mu-" | Mu_plus -> "mu+"
            | Tau_minus -> "tau-" | Tau_plus -> "tau+")
         | F6_Uq x -> (match x with 
            | U -> "u" | U_bar -> "u~" | C -> "c" | C_bar -> "c~" | T -> "t" | T_bar -> "t~")

         | F7_Dq x -> (match x with 
            | D -> "d" | D_bar -> "d~" | S -> "s" | S_bar -> "s~" | B -> "b" | B_bar -> "b~"))
      | FRV x -> (match x with 
         | V1_A A_1 -> "a"
         | V2_Z Z_1 -> "Z"
         | V3_W x -> (match x with 
            | W_plus -> "W+" | W_minus -> "W-")
         | V4_G G_1 -> "g")

   let flavor_to_TeX = function
      | FRS x -> (match x with 
         | S1_H0 H01 -> "h01"
         | S2_H0_1 H02 -> "h02"
         | S3_A0 A0_1 -> "A0"
         | S4_H x -> (match x with 
            | H_plus -> "H+" | H_minus -> "H-")
         | S5_G0 G0_1 -> "G0"
         | S6_GP x -> (match x with 
            | G_plus -> "G+" | G_minus -> "G-")
         | S7_Sn x -> (match x with 
            | Sv1 -> "sv1" | Sv1_bar -> "sv1~" | Sv2 -> "sv2" | Sv2_bar -> "sv2~"
            | Sv3 -> "sv3" | Sv3_bar -> "sv3~")
         | S8_Sl x -> (match x with 
            | Sl1_minus -> "sl1-" | Sl1_plus -> "sl1+" | Sl2_minus -> "sl2-"
            | Sl2_plus -> "sl2+" | Sl3_minus -> "sl3-" | Sl3_plus -> "sl3+"
            | Sl4_minus -> "sl4-" | Sl4_plus -> "sl4+" | Sl5_minus -> "sl5-"
            | Sl5_plus -> "sl5+" | Sl6_minus -> "sl6-" | Sl6_plus -> "sl6+")
         | S9_Su x -> (match x with 
            | Su1 -> "su1" | Su1_bar -> "su1~" | Su2 -> "su2" | Su2_bar -> "su2~"
            | Su3 -> "su3" | Su3_bar -> "su3~" | Su4 -> "su4" | Su4_bar -> "su4~"
            | Su5 -> "su5" | Su5_bar -> "su5~" | Su6 -> "su6" | Su6_bar -> "su6~")
         | S10_Sd x -> (match x with 
            | Sd1 -> "sd1" | Sd1_bar -> "sd1~" | Sd2 -> "sd2" | Sd2_bar -> "sd2~"
            | Sd3 -> "sd3" | Sd3_bar -> "sd3~" | Sd4 -> "sd4" | Sd4_bar -> "sd4~"
            | Sd5 -> "sd5" | Sd5_bar -> "sd5~" | Sd6 -> "sd6" | Sd6_bar -> "sd6~"))
      | FRF x -> (match x with 
         | F1_Neu x -> (match x with 
            | N1 -> "n1" | N2 -> "n2" | N3 -> "n3" | N4 -> "n4")
         | F2_Ch x -> (match x with 
            | X1_plus -> "x1+" | X1_minus -> "x1-" | X2_plus -> "x2+" | X2_minus -> "x2-")

         | F3_Go Go_1 -> "go"
         | F4_Vl x -> (match x with 
            | Ve -> "ve" | Ve_bar -> "ve~" | Vm -> "vm" | Vm_bar -> "vm~" | Vt -> "vt"
            | Vt_bar -> "vt~")
         | F5_L x -> (match x with 
            | E_minus -> "e-" | E_plus -> "e+" | Mu_minus -> "mu-" | Mu_plus -> "mu+"
            | Tau_minus -> "tau-" | Tau_plus -> "tau+")
         | F6_Uq x -> (match x with 
            | U -> "u" | U_bar -> "u~" | C -> "c" | C_bar -> "c~" | T -> "t" | T_bar -> "t~")

         | F7_Dq x -> (match x with 
            | D -> "d" | D_bar -> "d~" | S -> "s" | S_bar -> "s~" | B -> "b" | B_bar -> "b~"))
      | FRV x -> (match x with 
         | V1_A A_1 -> "a"
         | V2_Z Z_1 -> "Z"
         | V3_W x -> (match x with 
            | W_plus -> "W+" | W_minus -> "W-")
         | V4_G G_1 -> "g")

   let flavor_of_string x =
      let dict = List.map (fun x -> (x, flavor_to_string x)) (flavors ())
      in try
         fst (List.find (fun (_, y) -> (x = y)) dict)
      with
         Not_found -> invalid_arg "fr_mssm.Implementation: flavor_of_string: invalid particle?"

   let flavor_symbol = function
      | FRS x -> (match x with 
         | S1_H0 H01 -> "h01"
         | S2_H0_1 H02 -> "h02"
         | S3_A0 A0_1 -> "a0_1"
         | S4_H x -> (match x with 
            | H_plus -> "h_plus" | H_minus -> "h_minus")
         | S5_G0 G0_1 -> "g0_1"
         | S6_GP x -> (match x with 
            | G_plus -> "g_plus" | G_minus -> "g_minus")
         | S7_Sn x -> (match x with 
            | Sv1 -> "sv1" | Sv1_bar -> "sv1_bar" | Sv2 -> "sv2" | Sv2_bar -> "sv2_bar"
            | Sv3 -> "sv3" | Sv3_bar -> "sv3_bar")
         | S8_Sl x -> (match x with 
            | Sl1_minus -> "sl1_minus" | Sl1_plus -> "sl1_plus" | Sl2_minus -> "sl2_minus"
            | Sl2_plus -> "sl2_plus" | Sl3_minus -> "sl3_minus" | Sl3_plus -> "sl3_plus"
            | Sl4_minus -> "sl4_minus" | Sl4_plus -> "sl4_plus" | Sl5_minus -> "sl5_minus"
            | Sl5_plus -> "sl5_plus" | Sl6_minus -> "sl6_minus" | Sl6_plus -> "sl6_plus")
         | S9_Su x -> (match x with 
            | Su1 -> "su1" | Su1_bar -> "su1_bar" | Su2 -> "su2" | Su2_bar -> "su2_bar"
            | Su3 -> "su3" | Su3_bar -> "su3_bar" | Su4 -> "su4" | Su4_bar -> "su4_bar"
            | Su5 -> "su5" | Su5_bar -> "su5_bar" | Su6 -> "su6" | Su6_bar -> "su6_bar")
         | S10_Sd x -> (match x with 
            | Sd1 -> "sd1" | Sd1_bar -> "sd1_bar" | Sd2 -> "sd2" | Sd2_bar -> "sd2_bar"
            | Sd3 -> "sd3" | Sd3_bar -> "sd3_bar" | Sd4 -> "sd4" | Sd4_bar -> "sd4_bar"
            | Sd5 -> "sd5" | Sd5_bar -> "sd5_bar" | Sd6 -> "sd6" | Sd6_bar -> "sd6_bar"))
      | FRF x -> (match x with 
         | F1_Neu x -> (match x with 
            | N1 -> "n1" | N2 -> "n2" | N3 -> "n3" | N4 -> "n4")
         | F2_Ch x -> (match x with 
            | X1_plus -> "x1_plus" | X1_minus -> "x1_minus" | X2_plus -> "x2_plus"
            | X2_minus -> "x2_minus")
         | F3_Go Go_1 -> "go_1"
         | F4_Vl x -> (match x with 
            | Ve -> "ve" | Ve_bar -> "ve_bar" | Vm -> "vm" | Vm_bar -> "vm_bar" | Vt -> "vt"
            | Vt_bar -> "vt_bar")
         | F5_L x -> (match x with 
            | E_minus -> "e_minus" | E_plus -> "e_plus" | Mu_minus -> "mu_minus"
            | Mu_plus -> "mu_plus" | Tau_minus -> "tau_minus" | Tau_plus -> "tau_plus")
         | F6_Uq x -> (match x with 
            | U -> "u" | U_bar -> "u_bar" | C -> "c" | C_bar -> "c_bar" | T -> "t"
            | T_bar -> "t_bar")
         | F7_Dq x -> (match x with 
            | D -> "d" | D_bar -> "d_bar" | S -> "s" | S_bar -> "s_bar" | B -> "b"
            | B_bar -> "b_bar"))
      | FRV x -> (match x with 
         | V1_A A_1 -> "a_1"
         | V2_Z Z_1 -> "z_1"
         | V3_W x -> (match x with 
            | W_plus -> "w_plus" | W_minus -> "w_minus")
         | V4_G G_1 -> "g_1")

   let gauge_symbol = function
      Xi -> (match Opts.gauge with
         | Unitarity -> invalid_arg
            "fr_mssm.Implementation: requesting gauge symbol in unitarity gauge!"
         | Feynman -> "one"
         | Rxi -> "Rxi")

   let mass_symbol = function
      | FRS x -> (match x with 
         | S1_H0 H01 -> "mh01"
         | S2_H0_1 H02 -> "mh02"
         | S3_A0 A0_1 -> "ma0"
         | S4_H x -> (match x with 
            | H_plus -> "mh" | H_minus -> "mh")
         | S5_G0 G0_1 -> "mz"
         | S6_GP x -> (match x with 
            | G_plus -> "mw" | G_minus -> "mw")
         | S7_Sn x -> (match x with 
            | Sv1 -> "msn1" | Sv1_bar -> "msn1" | Sv2 -> "msn2" | Sv2_bar -> "msn2"
            | Sv3 -> "msn3" | Sv3_bar -> "msn3")
         | S8_Sl x -> (match x with 
            | Sl1_minus -> "msl1" | Sl1_plus -> "msl1" | Sl2_minus -> "msl2"
            | Sl2_plus -> "msl2" | Sl3_minus -> "msl3" | Sl3_plus -> "msl3"
            | Sl4_minus -> "msl4" | Sl4_plus -> "msl4" | Sl5_minus -> "msl5"
            | Sl5_plus -> "msl5" | Sl6_minus -> "msl6" | Sl6_plus -> "msl6")
         | S9_Su x -> (match x with 
            | Su1 -> "msu1" | Su1_bar -> "msu1" | Su2 -> "msu2" | Su2_bar -> "msu2"
            | Su3 -> "msu3" | Su3_bar -> "msu3" | Su4 -> "msu4" | Su4_bar -> "msu4"
            | Su5 -> "msu5" | Su5_bar -> "msu5" | Su6 -> "msu6" | Su6_bar -> "msu6")
         | S10_Sd x -> (match x with 
            | Sd1 -> "msd1" | Sd1_bar -> "msd1" | Sd2 -> "msd2" | Sd2_bar -> "msd2"
            | Sd3 -> "msd3" | Sd3_bar -> "msd3" | Sd4 -> "msd4" | Sd4_bar -> "msd4"
            | Sd5 -> "msd5" | Sd5_bar -> "msd5" | Sd6 -> "msd6" | Sd6_bar -> "msd6"))
      | FRF x -> (match x with 
         | F1_Neu x -> (match x with 
            | N1 -> "mneu1" | N2 -> "mneu2" | N3 -> "mneu3" | N4 -> "mneu4")
         | F2_Ch x -> (match x with 
            | X1_plus -> "mch1" | X1_minus -> "mch1" | X2_plus -> "mch2" | X2_minus -> "mch2")

         | F3_Go Go_1 -> "mgo"
         | F4_Vl _ -> "fr_zero"
         | F5_L x -> (match x with 
            | Tau_minus -> "mta" | Tau_plus -> "mta" | _ -> "fr_zero")
         | F6_Uq x -> (match x with 
            | T -> "mt" | T_bar -> "mt" | _ -> "fr_zero")
         | F7_Dq x -> (match x with 
            | B -> "mb" | B_bar -> "mb" | _ -> "fr_zero"))
      | FRV x -> (match x with 
         | V1_A _ -> "fr_zero"
         | V2_Z Z_1 -> "mz"
         | V3_W x -> (match x with 
            | W_plus -> "mw" | W_minus -> "mw")
         | V4_G _ -> "fr_zero")

   (* Coupling constants and parameters *)

   type constant =
      | G_h01_h01_h02 | G_h02_h02_h02 | G_h01_h01_h01 | G_h01_h02_h02
      | G_h_plus_h_minus_a_1_a_1 | G_a0_1_a0_1_h02 | G_h_plus_h02_h_minus
      | G_a0_1_a0_1_h01 | G_h_plus_h01_h_minus | G_a_1_h_plus_h_minus | G_g_1_g_1_g_1
      | G_g_1_g_1_g_1_g_1 | G_h_minus_a_1_w_plus | G_h01_h_minus_a_1_w_plus
      | G_a0_1_h_minus_a_1_w_plus | G_w_plus_a0_1_h_minus | G_w_plus_h01_h_minus
      | G_h02_h_minus_a_1_w_plus | G_w_plus_h02_h_minus | G_a_1_w_plus_w_minus
      | G_a0_1_h_plus_a_1_w_minus | G_h02_w_plus_w_minus | G_h01_w_plus_w_minus
      | G_h01_h01_w_plus_w_minus | G_a0_1_a0_1_w_plus_w_minus
      | G_a_1_a_1_w_plus_w_minus | G_w_plus_w_minus_z_1
      | G_w_plus_w_plus_w_minus_w_minus | G_h_plus_h_minus_a_1_z_1 | G_z_1_a0_1_h01
      | G_z_1_h_plus_h_minus | G_z_1_a0_1_h02 | G_h_minus_w_plus_z_1
      | G_h01_h_minus_w_plus_z_1 | G_a0_1_h_minus_w_plus_z_1
      | G_h02_h_minus_w_plus_z_1 | G_a0_1_h_plus_w_minus_z_1
      | G_a_1_w_plus_w_minus_z_1 | G_h02_z_1_z_1 | G_h01_z_1_z_1 | G_h01_h01_z_1_z_1
      | G_a0_1_a0_1_z_1_z_1 | G_h_plus_h_minus_z_1_z_1 | G_w_plus_w_minus_z_1_z_1
      | G_go_1_g_1_go_1 | G_x1_minus_a_1_x1_plus | G_x2_minus_a_1_x1_plus
      | G_x1_minus_a_1_x2_plus | G_x2_minus_a_1_x2_plus | G_d_bar_a_1_d
      | G_e_plus_a_1_e_minus | G_a_1_sd1_sd1_bar | G_a_1_sd2_sd2_bar
      | G_a_1_sd3_sd3_bar | G_a_1_sd3_sd6_bar | G_a_1_sd4_sd4_bar | G_a_1_sd5_sd5_bar
      | G_a_1_sd3_bar_sd6 | G_a_1_sd6_sd6_bar | G_a_1_sl1_minus_sl1_plus
      | G_a_1_sl2_minus_sl2_plus | G_a_1_sl3_minus_sl3_plus
      | G_a_1_sl3_minus_sl6_plus | G_a_1_sl4_minus_sl4_plus
      | G_a_1_sl5_minus_sl5_plus | G_a_1_sl3_plus_sl6_minus
      | G_a_1_sl6_minus_sl6_plus | G_a_1_su1_su1_bar | G_a_1_su2_su2_bar
      | G_a_1_su3_su3_bar | G_a_1_su3_su6_bar | G_a_1_su4_su4_bar | G_a_1_su5_su5_bar
      | G_a_1_su3_bar_su6 | G_a_1_su6_su6_bar | G_u_bar_a_1_u
      | G_x1_minus_a0_1_x1_plus | G_x2_minus_a0_1_x1_plus | G_x1_minus_a0_1_x2_plus
      | G_x2_minus_a0_1_x2_plus | G_b_bar_a0_1_b | G_tau_plus_a0_1_tau_minus
      | G_n1_a0_1_n1 | G_n1_a0_1_n2 | G_n1_a0_1_n3 | G_n1_a0_1_n4 | G_n2_a0_1_n2
      | G_n2_a0_1_n3 | G_n2_a0_1_n4 | G_n3_a0_1_n3 | G_n3_a0_1_n4 | G_n4_a0_1_n4
      | G_a0_1_sd3_sd3_bar | G_a0_1_sd3_sd6_bar | G_a0_1_sd3_bar_sd6
      | G_a0_1_sd6_sd6_bar | G_a0_1_sl3_minus_sl3_plus | G_a0_1_sl3_minus_sl6_plus
      | G_a0_1_sl3_plus_sl6_minus | G_a0_1_sl6_minus_sl6_plus | G_a0_1_su3_su3_bar
      | G_a0_1_su3_su6_bar | G_a0_1_su3_bar_su6 | G_a0_1_su6_su6_bar | G_t_bar_a0_1_t
      | G_x1_minus_h01_x1_plus | G_x2_minus_h01_x1_plus | G_x1_minus_h01_x2_plus
      | G_x2_minus_h01_x2_plus | G_x1_minus_h02_x1_plus | G_x2_minus_h02_x1_plus
      | G_x1_minus_h02_x2_plus | G_x2_minus_h02_x2_plus | G_x1_minus_z_1_x1_plus
      | G_x2_minus_z_1_x1_plus | G_x1_minus_z_1_x2_plus | G_x2_minus_z_1_x2_plus
      | G_x1_plus_su1_bar_d | G_x1_plus_su2_bar_s | G_b_su3_bar_x1_plus
      | G_b_su6_bar_x1_plus | G_x2_plus_su1_bar_d | G_x2_plus_su2_bar_s
      | G_b_su3_bar_x2_plus | G_b_su6_bar_x2_plus | G_n1_h_minus_x1_plus
      | G_n2_h_minus_x1_plus | G_n3_h_minus_x1_plus | G_n4_h_minus_x1_plus
      | G_n1_h_minus_x2_plus | G_n2_h_minus_x2_plus | G_n3_h_minus_x2_plus
      | G_n4_h_minus_x2_plus | G_x1_plus_sv1_bar_e_minus | G_x1_plus_sv2_bar_mu_minus
      | G_x1_plus_sv3_bar_tau_minus | G_x2_plus_sv1_bar_e_minus
      | G_x2_plus_sv2_bar_mu_minus | G_x2_plus_sv3_bar_tau_minus
      | G_n1_w_minus_x1_plus | G_n2_w_minus_x1_plus | G_n3_w_minus_x1_plus
      | G_n4_w_minus_x1_plus | G_n1_w_minus_x2_plus | G_n2_w_minus_x2_plus
      | G_n3_w_minus_x2_plus | G_n4_w_minus_x2_plus | G_u_bar_sd1_x1_plus
      | G_c_bar_sd2_x1_plus | G_t_bar_sd3_x1_plus | G_t_bar_sd6_x1_plus
      | G_u_bar_sd1_x2_plus | G_c_bar_sd2_x2_plus | G_t_bar_sd3_x2_plus
      | G_t_bar_sd6_x2_plus | G_ve_bar_sl1_minus_x1_plus | G_vm_bar_sl2_minus_x1_plus
      | G_vt_bar_sl3_minus_x1_plus | G_vt_bar_sl6_minus_x1_plus
      | G_ve_bar_sl1_minus_x2_plus | G_vm_bar_sl2_minus_x2_plus
      | G_vt_bar_sl3_minus_x2_plus | G_vt_bar_sl6_minus_x2_plus
      | G_x1_minus_su1_d_bar | G_x1_minus_su2_s_bar | G_b_bar_su3_x1_minus
      | G_b_bar_su6_x1_minus | G_x2_minus_su1_d_bar | G_x2_minus_su2_s_bar
      | G_b_bar_su3_x2_minus | G_b_bar_su6_x2_minus | G_x1_minus_h_plus_n1
      | G_x1_minus_h_plus_n2 | G_x1_minus_h_plus_n3 | G_x1_minus_h_plus_n4
      | G_x2_minus_h_plus_n1 | G_x2_minus_h_plus_n2 | G_x2_minus_h_plus_n3
      | G_x2_minus_h_plus_n4 | G_x1_minus_sv1_e_plus | G_x1_minus_sv2_mu_plus
      | G_x1_minus_sv3_tau_plus | G_x2_minus_sv1_e_plus | G_x2_minus_sv2_mu_plus
      | G_x2_minus_sv3_tau_plus | G_x1_minus_w_plus_n1 | G_x1_minus_w_plus_n2
      | G_x1_minus_w_plus_n3 | G_x1_minus_w_plus_n4 | G_x2_minus_w_plus_n1
      | G_x2_minus_w_plus_n2 | G_x2_minus_w_plus_n3 | G_x2_minus_w_plus_n4
      | G_x1_minus_sd1_bar_u | G_x1_minus_sd2_bar_c | G_x1_minus_sd3_bar_t
      | G_x1_minus_sd6_bar_t | G_x2_minus_sd1_bar_u | G_x2_minus_sd2_bar_c
      | G_x2_minus_sd3_bar_t | G_x2_minus_sd6_bar_t | G_x1_minus_sl1_plus_ve
      | G_x1_minus_sl2_plus_vm | G_x1_minus_sl3_plus_vt | G_x1_minus_sl6_plus_vt
      | G_x2_minus_sl1_plus_ve | G_x2_minus_sl2_plus_vm | G_x2_minus_sl3_plus_vt
      | G_x2_minus_sl6_plus_vt | G_d_bar_g_1_d | G_b_bar_h01_b | G_b_bar_h02_b
      | G_d_bar_z_1_d | G_go_1_sd1_bar_d | G_go_1_sd4_bar_d | G_go_1_sd2_bar_s
      | G_go_1_sd5_bar_s | G_go_1_sd3_bar_b | G_go_1_sd6_bar_b | G_t_bar_h_plus_b
      | G_n1_sd1_bar_d | G_n1_sd4_bar_d | G_n2_sd1_bar_d | G_n2_sd4_bar_d
      | G_n3_sd1_bar_d | G_n3_sd4_bar_d | G_n4_sd1_bar_d | G_n4_sd4_bar_d
      | G_n1_sd2_bar_s | G_n1_sd5_bar_s | G_n2_sd2_bar_s | G_n2_sd5_bar_s
      | G_n3_sd2_bar_s | G_n3_sd5_bar_s | G_n4_sd2_bar_s | G_n4_sd5_bar_s
      | G_n1_sd3_bar_b | G_n1_sd6_bar_b | G_n2_sd3_bar_b | G_n2_sd6_bar_b
      | G_n3_sd3_bar_b | G_n3_sd6_bar_b | G_n4_sd3_bar_b | G_n4_sd6_bar_b
      | G_u_bar_w_plus_d | G_c_bar_w_plus_s | G_t_bar_w_plus_b | G_d_bar_sd1_go_1
      | G_d_bar_sd4_go_1 | G_s_bar_sd2_go_1 | G_s_bar_sd5_go_1 | G_b_bar_sd3_go_1
      | G_b_bar_sd6_go_1 | G_b_bar_h_minus_t | G_d_bar_sd1_n1 | G_d_bar_sd4_n1
      | G_d_bar_sd1_n2 | G_d_bar_sd4_n2 | G_d_bar_sd1_n3 | G_d_bar_sd4_n3
      | G_d_bar_sd1_n4 | G_d_bar_sd4_n4 | G_s_bar_sd2_n1 | G_s_bar_sd5_n1
      | G_s_bar_sd2_n2 | G_s_bar_sd5_n2 | G_s_bar_sd2_n3 | G_s_bar_sd5_n3
      | G_s_bar_sd2_n4 | G_s_bar_sd5_n4 | G_b_bar_sd3_n1 | G_b_bar_sd6_n1
      | G_b_bar_sd3_n2 | G_b_bar_sd6_n2 | G_b_bar_sd3_n3 | G_b_bar_sd6_n3
      | G_b_bar_sd3_n4 | G_b_bar_sd6_n4 | G_d_bar_w_minus_u | G_s_bar_w_minus_c
      | G_b_bar_w_minus_t | G_g_1_sd1_sd1_bar | G_g_1_sd2_sd2_bar | G_g_1_sd3_sd3_bar
      | G_g_1_sd3_sd6_bar | G_g_1_sd4_sd4_bar | G_g_1_sd5_sd5_bar | G_g_1_sd3_bar_sd6
      | G_g_1_sd6_sd6_bar | G_g_1_su1_su1_bar | G_g_1_su2_su2_bar | G_g_1_su3_su3_bar
      | G_g_1_su3_su6_bar | G_g_1_su4_su4_bar | G_g_1_su5_su5_bar | G_g_1_su3_bar_su6
      | G_g_1_su6_su6_bar | G_u_bar_su1_go_1 | G_c_bar_su2_go_1 | G_t_bar_su3_go_1
      | G_u_bar_su4_go_1 | G_c_bar_su5_go_1 | G_t_bar_su6_go_1 | G_go_1_su1_bar_u
      | G_go_1_su2_bar_c | G_go_1_su3_bar_t | G_go_1_su4_bar_u | G_go_1_su5_bar_c
      | G_go_1_su6_bar_t | G_vt_bar_h_plus_tau_minus | G_h_plus_sd1_su1_bar
      | G_h_plus_sd2_su2_bar | G_h_plus_sd3_su3_bar | G_h_plus_sd3_su6_bar
      | G_h_plus_sd6_su3_bar | G_h_plus_sd6_su6_bar | G_h_plus_sl1_minus_sv1_bar
      | G_h_plus_sl2_minus_sv2_bar | G_h_plus_sl3_minus_sv3_bar
      | G_h_plus_sl6_minus_sv3_bar | G_tau_plus_h01_tau_minus | G_n1_h01_n1
      | G_n1_h01_n2 | G_n1_h01_n3 | G_n1_h01_n4 | G_n2_h01_n2 | G_n2_h01_n3
      | G_n2_h01_n4 | G_n3_h01_n3 | G_n3_h01_n4 | G_n4_h01_n4 | G_h01_sd1_sd1_bar
      | G_h01_sd2_sd2_bar | G_h01_sd3_sd3_bar | G_h01_sd3_sd6_bar | G_h01_sd4_sd4_bar
      | G_h01_sd5_sd5_bar | G_h01_sd3_bar_sd6 | G_h01_sd6_sd6_bar
      | G_h01_sl1_minus_sl1_plus | G_h01_sl2_minus_sl2_plus
      | G_h01_sl3_minus_sl3_plus | G_h01_sl3_minus_sl6_plus
      | G_h01_sl4_minus_sl4_plus | G_h01_sl5_minus_sl5_plus
      | G_h01_sl3_plus_sl6_minus | G_h01_sl6_minus_sl6_plus | G_h01_sv1_sv1_bar
      | G_h01_su1_su1_bar | G_h01_su2_su2_bar | G_h01_su3_su3_bar | G_h01_su3_su6_bar
      | G_h01_su4_su4_bar | G_h01_su5_su5_bar | G_h01_su3_bar_su6 | G_h01_su6_su6_bar
      | G_t_bar_h01_t | G_tau_plus_h02_tau_minus | G_n1_h02_n1 | G_n1_h02_n2
      | G_n1_h02_n3 | G_n1_h02_n4 | G_n2_h02_n2 | G_n2_h02_n3 | G_n2_h02_n4
      | G_n3_h02_n3 | G_n3_h02_n4 | G_n4_h02_n4 | G_h02_sd1_sd1_bar
      | G_h02_sd2_sd2_bar | G_h02_sd3_sd3_bar | G_h02_sd3_sd6_bar | G_h02_sd4_sd4_bar
      | G_h02_sd5_sd5_bar | G_h02_sd3_bar_sd6 | G_h02_sd6_sd6_bar
      | G_h02_sl1_minus_sl1_plus | G_h02_sl2_minus_sl2_plus
      | G_h02_sl3_minus_sl3_plus | G_h02_sl3_minus_sl6_plus
      | G_h02_sl4_minus_sl4_plus | G_h02_sl5_minus_sl5_plus
      | G_h02_sl3_plus_sl6_minus | G_h02_sl6_minus_sl6_plus | G_h02_sv1_sv1_bar
      | G_h02_su1_su1_bar | G_h02_su2_su2_bar | G_h02_su3_su3_bar | G_h02_su3_su6_bar
      | G_h02_su4_su4_bar | G_h02_su5_su5_bar | G_h02_su3_bar_su6 | G_h02_su6_su6_bar
      | G_t_bar_h02_t | G_tau_plus_h_minus_vt | G_h_minus_sd1_bar_su1
      | G_h_minus_sd2_bar_su2 | G_h_minus_sd3_bar_su3 | G_h_minus_sd3_bar_su6
      | G_h_minus_sd6_bar_su3 | G_h_minus_sd6_bar_su6 | G_h_minus_sl1_plus_sv1
      | G_h_minus_sl2_plus_sv2 | G_h_minus_sl3_plus_sv3 | G_h_minus_sl6_plus_sv3
      | G_e_plus_z_1_e_minus | G_n1_sl1_plus_e_minus | G_n1_sl4_plus_e_minus
      | G_n2_sl1_plus_e_minus | G_n2_sl4_plus_e_minus | G_n3_sl1_plus_e_minus
      | G_n3_sl4_plus_e_minus | G_n4_sl1_plus_e_minus | G_n4_sl4_plus_e_minus
      | G_n1_sl2_plus_mu_minus | G_n1_sl5_plus_mu_minus | G_n2_sl2_plus_mu_minus
      | G_n2_sl5_plus_mu_minus | G_n3_sl2_plus_mu_minus | G_n3_sl5_plus_mu_minus
      | G_n4_sl2_plus_mu_minus | G_n4_sl5_plus_mu_minus | G_n1_sl3_plus_tau_minus
      | G_n1_sl6_plus_tau_minus | G_n2_sl3_plus_tau_minus | G_n2_sl6_plus_tau_minus
      | G_n3_sl3_plus_tau_minus | G_n3_sl6_plus_tau_minus | G_n4_sl3_plus_tau_minus
      | G_n4_sl6_plus_tau_minus | G_ve_bar_w_plus_e_minus | G_e_plus_sl1_minus_n1
      | G_e_plus_sl4_minus_n1 | G_e_plus_sl1_minus_n2 | G_e_plus_sl4_minus_n2
      | G_e_plus_sl1_minus_n3 | G_e_plus_sl4_minus_n3 | G_e_plus_sl1_minus_n4
      | G_e_plus_sl4_minus_n4 | G_mu_plus_sl2_minus_n1 | G_mu_plus_sl5_minus_n1
      | G_mu_plus_sl2_minus_n2 | G_mu_plus_sl5_minus_n2 | G_mu_plus_sl2_minus_n3
      | G_mu_plus_sl5_minus_n3 | G_mu_plus_sl2_minus_n4 | G_mu_plus_sl5_minus_n4
      | G_tau_plus_sl3_minus_n1 | G_tau_plus_sl6_minus_n1 | G_tau_plus_sl3_minus_n2
      | G_tau_plus_sl6_minus_n2 | G_tau_plus_sl3_minus_n3 | G_tau_plus_sl6_minus_n3
      | G_tau_plus_sl3_minus_n4 | G_tau_plus_sl6_minus_n4 | G_n1_z_1_n1 | G_n1_z_1_n2
      | G_n1_z_1_n3 | G_n1_z_1_n4 | G_n2_z_1_n2 | G_n2_z_1_n3 | G_n2_z_1_n4
      | G_n3_z_1_n3 | G_n3_z_1_n4 | G_n4_z_1_n4 | G_ve_bar_sv1_n1 | G_vm_bar_sv2_n1
      | G_vt_bar_sv3_n1 | G_ve_bar_sv1_n2 | G_vm_bar_sv2_n2 | G_vt_bar_sv3_n2
      | G_ve_bar_sv1_n3 | G_vm_bar_sv2_n3 | G_vt_bar_sv3_n3 | G_ve_bar_sv1_n4
      | G_vm_bar_sv2_n4 | G_vt_bar_sv3_n4 | G_n1_sv1_bar_ve | G_n1_sv2_bar_vm
      | G_n1_sv3_bar_vt | G_n2_sv1_bar_ve | G_n2_sv2_bar_vm | G_n2_sv3_bar_vt
      | G_n3_sv1_bar_ve | G_n3_sv2_bar_vm | G_n3_sv3_bar_vt | G_n4_sv1_bar_ve
      | G_n4_sv2_bar_vm | G_n4_sv3_bar_vt | G_u_bar_su1_n1 | G_c_bar_su2_n1
      | G_t_bar_su3_n1 | G_u_bar_su4_n1 | G_c_bar_su5_n1 | G_t_bar_su6_n1
      | G_u_bar_su1_n2 | G_c_bar_su2_n2 | G_t_bar_su3_n2 | G_u_bar_su4_n2
      | G_c_bar_su5_n2 | G_t_bar_su6_n2 | G_u_bar_su1_n3 | G_c_bar_su2_n3
      | G_t_bar_su3_n3 | G_u_bar_su4_n3 | G_c_bar_su5_n3 | G_t_bar_su6_n3
      | G_u_bar_su1_n4 | G_c_bar_su2_n4 | G_t_bar_su3_n4 | G_u_bar_su4_n4
      | G_c_bar_su5_n4 | G_t_bar_su6_n4 | G_n1_su1_bar_u | G_n1_su2_bar_c
      | G_n1_su3_bar_t | G_n1_su4_bar_u | G_n1_su5_bar_c | G_n1_su6_bar_t
      | G_n2_su1_bar_u | G_n2_su2_bar_c | G_n2_su3_bar_t | G_n2_su4_bar_u
      | G_n2_su5_bar_c | G_n2_su6_bar_t | G_n3_su1_bar_u | G_n3_su2_bar_c
      | G_n3_su3_bar_t | G_n3_su4_bar_u | G_n3_su5_bar_c | G_n3_su6_bar_t
      | G_n4_su1_bar_u | G_n4_su2_bar_c | G_n4_su3_bar_t | G_n4_su4_bar_u
      | G_n4_su5_bar_c | G_n4_su6_bar_t | G_z_1_sd1_sd1_bar | G_z_1_sd2_sd2_bar
      | G_z_1_sd3_sd3_bar | G_z_1_sd3_sd6_bar | G_z_1_sd4_sd4_bar | G_z_1_sd5_sd5_bar
      | G_z_1_sd3_bar_sd6 | G_z_1_sd6_sd6_bar | G_w_plus_sd1_su1_bar
      | G_w_plus_sd2_su2_bar | G_w_plus_sd3_su3_bar | G_w_plus_sd3_su6_bar
      | G_w_plus_sd6_su3_bar | G_w_plus_sd6_su6_bar | G_w_minus_sd1_bar_su1
      | G_w_minus_sd2_bar_su2 | G_w_minus_sd3_bar_su3 | G_w_minus_sd3_bar_su6
      | G_w_minus_sd6_bar_su3 | G_w_minus_sd6_bar_su6 | G_z_1_sl1_minus_sl1_plus
      | G_z_1_sl2_minus_sl2_plus | G_z_1_sl3_minus_sl3_plus
      | G_z_1_sl3_minus_sl6_plus | G_z_1_sl4_minus_sl4_plus
      | G_z_1_sl5_minus_sl5_plus | G_z_1_sl3_plus_sl6_minus
      | G_z_1_sl6_minus_sl6_plus | G_w_plus_sl1_minus_sv1_bar
      | G_w_plus_sl2_minus_sv2_bar | G_w_plus_sl3_minus_sv3_bar
      | G_w_plus_sl6_minus_sv3_bar | G_w_minus_sl1_plus_sv1 | G_w_minus_sl2_plus_sv2
      | G_w_minus_sl3_plus_sv3 | G_w_minus_sl6_plus_sv3 | G_z_1_sv1_sv1_bar
      | G_z_1_su1_su1_bar | G_z_1_su2_su2_bar | G_z_1_su3_su3_bar | G_z_1_su3_su6_bar
      | G_z_1_su4_su4_bar | G_z_1_su5_su5_bar | G_z_1_su3_bar_su6 | G_z_1_su6_su6_bar
      | G_u_bar_z_1_u | G_ve_bar_z_1_ve | G_sd1_sd1_bar_a_1_a_1
      | G_sd2_sd2_bar_a_1_a_1 | G_sd3_sd3_bar_a_1_a_1 | G_sd3_sd6_bar_a_1_a_1
      | G_sd4_sd4_bar_a_1_a_1 | G_sd5_sd5_bar_a_1_a_1 | G_sd3_bar_sd6_a_1_a_1
      | G_sd6_sd6_bar_a_1_a_1 | G_sl1_minus_sl1_plus_a_1_a_1
      | G_sl2_minus_sl2_plus_a_1_a_1 | G_sl3_minus_sl3_plus_a_1_a_1
      | G_sl3_minus_sl6_plus_a_1_a_1 | G_sl4_minus_sl4_plus_a_1_a_1
      | G_sl5_minus_sl5_plus_a_1_a_1 | G_sl3_plus_sl6_minus_a_1_a_1
      | G_sl6_minus_sl6_plus_a_1_a_1 | G_su1_su1_bar_a_1_a_1 | G_su2_su2_bar_a_1_a_1
      | G_su3_su3_bar_a_1_a_1 | G_su3_su6_bar_a_1_a_1 | G_su4_su4_bar_a_1_a_1
      | G_su5_su5_bar_a_1_a_1 | G_su3_bar_su6_a_1_a_1 | G_su6_su6_bar_a_1_a_1
      | G_sd1_sd1_bar_a_1_g_1 | G_sd2_sd2_bar_a_1_g_1 | G_sd3_sd3_bar_a_1_g_1
      | G_sd3_sd6_bar_a_1_g_1 | G_sd4_sd4_bar_a_1_g_1 | G_sd5_sd5_bar_a_1_g_1
      | G_sd3_bar_sd6_a_1_g_1 | G_sd6_sd6_bar_a_1_g_1 | G_su1_su1_bar_a_1_g_1
      | G_su2_su2_bar_a_1_g_1 | G_su3_su3_bar_a_1_g_1 | G_su3_su6_bar_a_1_g_1
      | G_su4_su4_bar_a_1_g_1 | G_su5_su5_bar_a_1_g_1 | G_su3_bar_su6_a_1_g_1
      | G_su6_su6_bar_a_1_g_1 | G_sd1_sd1_bar_a_1_z_1 | G_sd2_sd2_bar_a_1_z_1
      | G_sd3_sd3_bar_a_1_z_1 | G_sd3_sd6_bar_a_1_z_1 | G_sd4_sd4_bar_a_1_z_1
      | G_sd5_sd5_bar_a_1_z_1 | G_sd3_bar_sd6_a_1_z_1 | G_sd6_sd6_bar_a_1_z_1
      | G_sd1_su1_bar_a_1_w_plus | G_sd2_su2_bar_a_1_w_plus
      | G_sd3_su3_bar_a_1_w_plus | G_sd3_su6_bar_a_1_w_plus
      | G_sd6_su3_bar_a_1_w_plus | G_sd6_su6_bar_a_1_w_plus
      | G_sd1_bar_su1_a_1_w_minus | G_sd2_bar_su2_a_1_w_minus
      | G_sd3_bar_su3_a_1_w_minus | G_sd3_bar_su6_a_1_w_minus
      | G_sd6_bar_su3_a_1_w_minus | G_sd6_bar_su6_a_1_w_minus
      | G_sl1_minus_sl1_plus_a_1_z_1 | G_sl2_minus_sl2_plus_a_1_z_1
      | G_sl3_minus_sl3_plus_a_1_z_1 | G_sl3_minus_sl6_plus_a_1_z_1
      | G_sl4_minus_sl4_plus_a_1_z_1 | G_sl5_minus_sl5_plus_a_1_z_1
      | G_sl3_plus_sl6_minus_a_1_z_1 | G_sl6_minus_sl6_plus_a_1_z_1
      | G_sl1_minus_sv1_bar_a_1_w_plus | G_sl2_minus_sv2_bar_a_1_w_plus
      | G_sl3_minus_sv3_bar_a_1_w_plus | G_sl6_minus_sv3_bar_a_1_w_plus
      | G_sl1_plus_sv1_a_1_w_minus | G_sl2_plus_sv2_a_1_w_minus
      | G_sl3_plus_sv3_a_1_w_minus | G_sl6_plus_sv3_a_1_w_minus
      | G_su1_su1_bar_a_1_z_1 | G_su2_su2_bar_a_1_z_1 | G_su3_su3_bar_a_1_z_1
      | G_su3_su6_bar_a_1_z_1 | G_su4_su4_bar_a_1_z_1 | G_su5_su5_bar_a_1_z_1
      | G_su3_bar_su6_a_1_z_1 | G_su6_su6_bar_a_1_z_1 | G_sd1_sd1_bar_g_1_g_1
      | G_sd2_sd2_bar_g_1_g_1 | G_sd3_sd3_bar_g_1_g_1 | G_sd3_sd6_bar_g_1_g_1
      | G_sd4_sd4_bar_g_1_g_1 | G_sd5_sd5_bar_g_1_g_1 | G_sd3_bar_sd6_g_1_g_1
      | G_sd6_sd6_bar_g_1_g_1 | G_su1_su1_bar_g_1_g_1 | G_su2_su2_bar_g_1_g_1
      | G_su3_su3_bar_g_1_g_1 | G_su3_su6_bar_g_1_g_1 | G_su4_su4_bar_g_1_g_1
      | G_su5_su5_bar_g_1_g_1 | G_su3_bar_su6_g_1_g_1 | G_su6_su6_bar_g_1_g_1
      | G_sd1_sd1_bar_g_1_z_1 | G_sd2_sd2_bar_g_1_z_1 | G_sd3_sd3_bar_g_1_z_1
      | G_sd3_sd6_bar_g_1_z_1 | G_sd4_sd4_bar_g_1_z_1 | G_sd5_sd5_bar_g_1_z_1
      | G_sd3_bar_sd6_g_1_z_1 | G_sd6_sd6_bar_g_1_z_1 | G_sd1_su1_bar_g_1_w_plus
      | G_sd2_su2_bar_g_1_w_plus | G_sd3_su3_bar_g_1_w_plus
      | G_sd3_su6_bar_g_1_w_plus | G_sd6_su3_bar_g_1_w_plus
      | G_sd6_su6_bar_g_1_w_plus | G_sd1_bar_su1_g_1_w_minus
      | G_sd2_bar_su2_g_1_w_minus | G_sd3_bar_su3_g_1_w_minus
      | G_sd3_bar_su6_g_1_w_minus | G_sd6_bar_su3_g_1_w_minus
      | G_sd6_bar_su6_g_1_w_minus | G_su1_su1_bar_g_1_z_1 | G_su2_su2_bar_g_1_z_1
      | G_su3_su3_bar_g_1_z_1 | G_su3_su6_bar_g_1_z_1 | G_su4_su4_bar_g_1_z_1
      | G_su5_su5_bar_g_1_z_1 | G_su3_bar_su6_g_1_z_1 | G_su6_su6_bar_g_1_z_1
      | G_sd1_sd1_bar_w_plus_w_minus | G_sd2_sd2_bar_w_plus_w_minus
      | G_sd3_sd3_bar_w_plus_w_minus | G_sd3_sd6_bar_w_plus_w_minus
      | G_sd3_bar_sd6_w_plus_w_minus | G_sd6_sd6_bar_w_plus_w_minus
      | G_sd1_sd1_bar_z_1_z_1 | G_sd2_sd2_bar_z_1_z_1 | G_sd3_sd3_bar_z_1_z_1
      | G_sd3_sd6_bar_z_1_z_1 | G_sd4_sd4_bar_z_1_z_1 | G_sd5_sd5_bar_z_1_z_1
      | G_sd3_bar_sd6_z_1_z_1 | G_sd6_sd6_bar_z_1_z_1 | G_sd1_su1_bar_w_plus_z_1
      | G_sd2_su2_bar_w_plus_z_1 | G_sd3_su3_bar_w_plus_z_1
      | G_sd3_su6_bar_w_plus_z_1 | G_sd6_su3_bar_w_plus_z_1
      | G_sd6_su6_bar_w_plus_z_1 | G_sd1_bar_su1_w_minus_z_1
      | G_sd2_bar_su2_w_minus_z_1 | G_sd3_bar_su3_w_minus_z_1
      | G_sd3_bar_su6_w_minus_z_1 | G_sd6_bar_su3_w_minus_z_1
      | G_sd6_bar_su6_w_minus_z_1 | G_sl1_minus_sl1_plus_w_plus_w_minus
      | G_sl2_minus_sl2_plus_w_plus_w_minus | G_sl3_minus_sl3_plus_w_plus_w_minus
      | G_sl3_minus_sl6_plus_w_plus_w_minus | G_sl3_plus_sl6_minus_w_plus_w_minus
      | G_sl6_minus_sl6_plus_w_plus_w_minus | G_sl1_minus_sl1_plus_z_1_z_1
      | G_sl2_minus_sl2_plus_z_1_z_1 | G_sl3_minus_sl3_plus_z_1_z_1
      | G_sl3_minus_sl6_plus_z_1_z_1 | G_sl4_minus_sl4_plus_z_1_z_1
      | G_sl5_minus_sl5_plus_z_1_z_1 | G_sl3_plus_sl6_minus_z_1_z_1
      | G_sl6_minus_sl6_plus_z_1_z_1 | G_sl1_minus_sv1_bar_w_plus_z_1
      | G_sl2_minus_sv2_bar_w_plus_z_1 | G_sl3_minus_sv3_bar_w_plus_z_1
      | G_sl6_minus_sv3_bar_w_plus_z_1 | G_sl1_plus_sv1_w_minus_z_1
      | G_sl2_plus_sv2_w_minus_z_1 | G_sl3_plus_sv3_w_minus_z_1
      | G_sl6_plus_sv3_w_minus_z_1 | G_sv1_sv1_bar_w_plus_w_minus
      | G_sv1_sv1_bar_z_1_z_1 | G_su1_su1_bar_w_plus_w_minus
      | G_su2_su2_bar_w_plus_w_minus | G_su3_su3_bar_w_plus_w_minus
      | G_su3_su6_bar_w_plus_w_minus | G_su3_bar_su6_w_plus_w_minus
      | G_su6_su6_bar_w_plus_w_minus | G_su1_su1_bar_z_1_z_1 | G_su2_su2_bar_z_1_z_1
      | G_su3_su3_bar_z_1_z_1 | G_su3_su6_bar_z_1_z_1 | G_su4_su4_bar_z_1_z_1
      | G_su5_su5_bar_z_1_z_1 | G_su3_bar_su6_z_1_z_1 | G_su6_su6_bar_z_1_z_1

   let parameters () = {input = []; derived = []; derived_arrays = []}

   let constant_symbol = function
      | G_h01_h01_h02 -> "G_h01_h01_h02" | G_h02_h02_h02 -> "G_h02_h02_h02"
      | G_h01_h01_h01 -> "G_h01_h01_h01" | G_h01_h02_h02 -> "G_h01_h02_h02"
      | G_h_plus_h_minus_a_1_a_1 -> "G_h_plus_h_minus_a_1_a_1"
      | G_a0_1_a0_1_h02 -> "G_a0_1_a0_1_h02"
      | G_h_plus_h02_h_minus -> "G_h_plus_h02_h_minus"
      | G_a0_1_a0_1_h01 -> "G_a0_1_a0_1_h01"
      | G_h_plus_h01_h_minus -> "G_h_plus_h01_h_minus"
      | G_a_1_h_plus_h_minus -> "G_a_1_h_plus_h_minus"
      | G_g_1_g_1_g_1 -> "G_g_1_g_1_g_1" | G_g_1_g_1_g_1_g_1 -> "G_g_1_g_1_g_1_g_1"
      | G_h_minus_a_1_w_plus -> "G_h_minus_a_1_w_plus"
      | G_h01_h_minus_a_1_w_plus -> "G_h01_h_minus_a_1_w_plus"
      | G_a0_1_h_minus_a_1_w_plus -> "G_a0_1_h_minus_a_1_w_plus"
      | G_w_plus_a0_1_h_minus -> "G_w_plus_a0_1_h_minus"
      | G_w_plus_h01_h_minus -> "G_w_plus_h01_h_minus"
      | G_h02_h_minus_a_1_w_plus -> "G_h02_h_minus_a_1_w_plus"
      | G_w_plus_h02_h_minus -> "G_w_plus_h02_h_minus"
      | G_a_1_w_plus_w_minus -> "G_a_1_w_plus_w_minus"
      | G_a0_1_h_plus_a_1_w_minus -> "G_a0_1_h_plus_a_1_w_minus"
      | G_h02_w_plus_w_minus -> "G_h02_w_plus_w_minus"
      | G_h01_w_plus_w_minus -> "G_h01_w_plus_w_minus"
      | G_h01_h01_w_plus_w_minus -> "G_h01_h01_w_plus_w_minus"
      | G_a0_1_a0_1_w_plus_w_minus -> "G_a0_1_a0_1_w_plus_w_minus"
      | G_a_1_a_1_w_plus_w_minus -> "G_a_1_a_1_w_plus_w_minus"
      | G_w_plus_w_minus_z_1 -> "G_w_plus_w_minus_z_1"
      | G_w_plus_w_plus_w_minus_w_minus -> "G_w_plus_w_plus_w_minus_w_minus"
      | G_h_plus_h_minus_a_1_z_1 -> "G_h_plus_h_minus_a_1_z_1"
      | G_z_1_a0_1_h01 -> "G_z_1_a0_1_h01"
      | G_z_1_h_plus_h_minus -> "G_z_1_h_plus_h_minus"
      | G_z_1_a0_1_h02 -> "G_z_1_a0_1_h02"
      | G_h_minus_w_plus_z_1 -> "G_h_minus_w_plus_z_1"
      | G_h01_h_minus_w_plus_z_1 -> "G_h01_h_minus_w_plus_z_1"
      | G_a0_1_h_minus_w_plus_z_1 -> "G_a0_1_h_minus_w_plus_z_1"
      | G_h02_h_minus_w_plus_z_1 -> "G_h02_h_minus_w_plus_z_1"
      | G_a0_1_h_plus_w_minus_z_1 -> "G_a0_1_h_plus_w_minus_z_1"
      | G_a_1_w_plus_w_minus_z_1 -> "G_a_1_w_plus_w_minus_z_1"
      | G_h02_z_1_z_1 -> "G_h02_z_1_z_1" | G_h01_z_1_z_1 -> "G_h01_z_1_z_1"
      | G_h01_h01_z_1_z_1 -> "G_h01_h01_z_1_z_1"
      | G_a0_1_a0_1_z_1_z_1 -> "G_a0_1_a0_1_z_1_z_1"
      | G_h_plus_h_minus_z_1_z_1 -> "G_h_plus_h_minus_z_1_z_1"
      | G_w_plus_w_minus_z_1_z_1 -> "G_w_plus_w_minus_z_1_z_1"
      | G_go_1_g_1_go_1 -> "G_go_1_g_1_go_1"
      | G_x1_minus_a_1_x1_plus -> "G_x1_minus_a_1_x1_plus"
      | G_x2_minus_a_1_x1_plus -> "G_x2_minus_a_1_x1_plus"
      | G_x1_minus_a_1_x2_plus -> "G_x1_minus_a_1_x2_plus"
      | G_x2_minus_a_1_x2_plus -> "G_x2_minus_a_1_x2_plus"
      | G_d_bar_a_1_d -> "G_d_bar_a_1_d"
      | G_e_plus_a_1_e_minus -> "G_e_plus_a_1_e_minus"
      | G_a_1_sd1_sd1_bar -> "G_a_1_sd1_sd1_bar"
      | G_a_1_sd2_sd2_bar -> "G_a_1_sd2_sd2_bar"
      | G_a_1_sd3_sd3_bar -> "G_a_1_sd3_sd3_bar"
      | G_a_1_sd3_sd6_bar -> "G_a_1_sd3_sd6_bar"
      | G_a_1_sd4_sd4_bar -> "G_a_1_sd4_sd4_bar"
      | G_a_1_sd5_sd5_bar -> "G_a_1_sd5_sd5_bar"
      | G_a_1_sd3_bar_sd6 -> "G_a_1_sd3_bar_sd6"
      | G_a_1_sd6_sd6_bar -> "G_a_1_sd6_sd6_bar"
      | G_a_1_sl1_minus_sl1_plus -> "G_a_1_sl1_minus_sl1_plus"
      | G_a_1_sl2_minus_sl2_plus -> "G_a_1_sl2_minus_sl2_plus"
      | G_a_1_sl3_minus_sl3_plus -> "G_a_1_sl3_minus_sl3_plus"
      | G_a_1_sl3_minus_sl6_plus -> "G_a_1_sl3_minus_sl6_plus"
      | G_a_1_sl4_minus_sl4_plus -> "G_a_1_sl4_minus_sl4_plus"
      | G_a_1_sl5_minus_sl5_plus -> "G_a_1_sl5_minus_sl5_plus"
      | G_a_1_sl3_plus_sl6_minus -> "G_a_1_sl3_plus_sl6_minus"
      | G_a_1_sl6_minus_sl6_plus -> "G_a_1_sl6_minus_sl6_plus"
      | G_a_1_su1_su1_bar -> "G_a_1_su1_su1_bar"
      | G_a_1_su2_su2_bar -> "G_a_1_su2_su2_bar"
      | G_a_1_su3_su3_bar -> "G_a_1_su3_su3_bar"
      | G_a_1_su3_su6_bar -> "G_a_1_su3_su6_bar"
      | G_a_1_su4_su4_bar -> "G_a_1_su4_su4_bar"
      | G_a_1_su5_su5_bar -> "G_a_1_su5_su5_bar"
      | G_a_1_su3_bar_su6 -> "G_a_1_su3_bar_su6"
      | G_a_1_su6_su6_bar -> "G_a_1_su6_su6_bar" | G_u_bar_a_1_u -> "G_u_bar_a_1_u"
      | G_x1_minus_a0_1_x1_plus -> "G_x1_minus_a0_1_x1_plus"
      | G_x2_minus_a0_1_x1_plus -> "G_x2_minus_a0_1_x1_plus"
      | G_x1_minus_a0_1_x2_plus -> "G_x1_minus_a0_1_x2_plus"
      | G_x2_minus_a0_1_x2_plus -> "G_x2_minus_a0_1_x2_plus"
      | G_b_bar_a0_1_b -> "G_b_bar_a0_1_b"
      | G_tau_plus_a0_1_tau_minus -> "G_tau_plus_a0_1_tau_minus"
      | G_n1_a0_1_n1 -> "G_n1_a0_1_n1" | G_n1_a0_1_n2 -> "G_n1_a0_1_n2"
      | G_n1_a0_1_n3 -> "G_n1_a0_1_n3" | G_n1_a0_1_n4 -> "G_n1_a0_1_n4"
      | G_n2_a0_1_n2 -> "G_n2_a0_1_n2" | G_n2_a0_1_n3 -> "G_n2_a0_1_n3"
      | G_n2_a0_1_n4 -> "G_n2_a0_1_n4" | G_n3_a0_1_n3 -> "G_n3_a0_1_n3"
      | G_n3_a0_1_n4 -> "G_n3_a0_1_n4" | G_n4_a0_1_n4 -> "G_n4_a0_1_n4"
      | G_a0_1_sd3_sd3_bar -> "G_a0_1_sd3_sd3_bar"
      | G_a0_1_sd3_sd6_bar -> "G_a0_1_sd3_sd6_bar"
      | G_a0_1_sd3_bar_sd6 -> "G_a0_1_sd3_bar_sd6"
      | G_a0_1_sd6_sd6_bar -> "G_a0_1_sd6_sd6_bar"
      | G_a0_1_sl3_minus_sl3_plus -> "G_a0_1_sl3_minus_sl3_plus"
      | G_a0_1_sl3_minus_sl6_plus -> "G_a0_1_sl3_minus_sl6_plus"
      | G_a0_1_sl3_plus_sl6_minus -> "G_a0_1_sl3_plus_sl6_minus"
      | G_a0_1_sl6_minus_sl6_plus -> "G_a0_1_sl6_minus_sl6_plus"
      | G_a0_1_su3_su3_bar -> "G_a0_1_su3_su3_bar"
      | G_a0_1_su3_su6_bar -> "G_a0_1_su3_su6_bar"
      | G_a0_1_su3_bar_su6 -> "G_a0_1_su3_bar_su6"
      | G_a0_1_su6_su6_bar -> "G_a0_1_su6_su6_bar"
      | G_t_bar_a0_1_t -> "G_t_bar_a0_1_t"
      | G_x1_minus_h01_x1_plus -> "G_x1_minus_h01_x1_plus"
      | G_x2_minus_h01_x1_plus -> "G_x2_minus_h01_x1_plus"
      | G_x1_minus_h01_x2_plus -> "G_x1_minus_h01_x2_plus"
      | G_x2_minus_h01_x2_plus -> "G_x2_minus_h01_x2_plus"
      | G_x1_minus_h02_x1_plus -> "G_x1_minus_h02_x1_plus"
      | G_x2_minus_h02_x1_plus -> "G_x2_minus_h02_x1_plus"
      | G_x1_minus_h02_x2_plus -> "G_x1_minus_h02_x2_plus"
      | G_x2_minus_h02_x2_plus -> "G_x2_minus_h02_x2_plus"
      | G_x1_minus_z_1_x1_plus -> "G_x1_minus_z_1_x1_plus"
      | G_x2_minus_z_1_x1_plus -> "G_x2_minus_z_1_x1_plus"
      | G_x1_minus_z_1_x2_plus -> "G_x1_minus_z_1_x2_plus"
      | G_x2_minus_z_1_x2_plus -> "G_x2_minus_z_1_x2_plus"
      | G_x1_plus_su1_bar_d -> "G_x1_plus_su1_bar_d"
      | G_x1_plus_su2_bar_s -> "G_x1_plus_su2_bar_s"
      | G_b_su3_bar_x1_plus -> "G_b_su3_bar_x1_plus"
      | G_b_su6_bar_x1_plus -> "G_b_su6_bar_x1_plus"
      | G_x2_plus_su1_bar_d -> "G_x2_plus_su1_bar_d"
      | G_x2_plus_su2_bar_s -> "G_x2_plus_su2_bar_s"
      | G_b_su3_bar_x2_plus -> "G_b_su3_bar_x2_plus"
      | G_b_su6_bar_x2_plus -> "G_b_su6_bar_x2_plus"
      | G_n1_h_minus_x1_plus -> "G_n1_h_minus_x1_plus"
      | G_n2_h_minus_x1_plus -> "G_n2_h_minus_x1_plus"
      | G_n3_h_minus_x1_plus -> "G_n3_h_minus_x1_plus"
      | G_n4_h_minus_x1_plus -> "G_n4_h_minus_x1_plus"
      | G_n1_h_minus_x2_plus -> "G_n1_h_minus_x2_plus"
      | G_n2_h_minus_x2_plus -> "G_n2_h_minus_x2_plus"
      | G_n3_h_minus_x2_plus -> "G_n3_h_minus_x2_plus"
      | G_n4_h_minus_x2_plus -> "G_n4_h_minus_x2_plus"
      | G_x1_plus_sv1_bar_e_minus -> "G_x1_plus_sv1_bar_e_minus"
      | G_x1_plus_sv2_bar_mu_minus -> "G_x1_plus_sv2_bar_mu_minus"
      | G_x1_plus_sv3_bar_tau_minus -> "G_x1_plus_sv3_bar_tau_minus"
      | G_x2_plus_sv1_bar_e_minus -> "G_x2_plus_sv1_bar_e_minus"
      | G_x2_plus_sv2_bar_mu_minus -> "G_x2_plus_sv2_bar_mu_minus"
      | G_x2_plus_sv3_bar_tau_minus -> "G_x2_plus_sv3_bar_tau_minus"
      | G_n1_w_minus_x1_plus -> "G_n1_w_minus_x1_plus"
      | G_n2_w_minus_x1_plus -> "G_n2_w_minus_x1_plus"
      | G_n3_w_minus_x1_plus -> "G_n3_w_minus_x1_plus"
      | G_n4_w_minus_x1_plus -> "G_n4_w_minus_x1_plus"
      | G_n1_w_minus_x2_plus -> "G_n1_w_minus_x2_plus"
      | G_n2_w_minus_x2_plus -> "G_n2_w_minus_x2_plus"
      | G_n3_w_minus_x2_plus -> "G_n3_w_minus_x2_plus"
      | G_n4_w_minus_x2_plus -> "G_n4_w_minus_x2_plus"
      | G_u_bar_sd1_x1_plus -> "G_u_bar_sd1_x1_plus"
      | G_c_bar_sd2_x1_plus -> "G_c_bar_sd2_x1_plus"
      | G_t_bar_sd3_x1_plus -> "G_t_bar_sd3_x1_plus"
      | G_t_bar_sd6_x1_plus -> "G_t_bar_sd6_x1_plus"
      | G_u_bar_sd1_x2_plus -> "G_u_bar_sd1_x2_plus"
      | G_c_bar_sd2_x2_plus -> "G_c_bar_sd2_x2_plus"
      | G_t_bar_sd3_x2_plus -> "G_t_bar_sd3_x2_plus"
      | G_t_bar_sd6_x2_plus -> "G_t_bar_sd6_x2_plus"
      | G_ve_bar_sl1_minus_x1_plus -> "G_ve_bar_sl1_minus_x1_plus"
      | G_vm_bar_sl2_minus_x1_plus -> "G_vm_bar_sl2_minus_x1_plus"
      | G_vt_bar_sl3_minus_x1_plus -> "G_vt_bar_sl3_minus_x1_plus"
      | G_vt_bar_sl6_minus_x1_plus -> "G_vt_bar_sl6_minus_x1_plus"
      | G_ve_bar_sl1_minus_x2_plus -> "G_ve_bar_sl1_minus_x2_plus"
      | G_vm_bar_sl2_minus_x2_plus -> "G_vm_bar_sl2_minus_x2_plus"
      | G_vt_bar_sl3_minus_x2_plus -> "G_vt_bar_sl3_minus_x2_plus"
      | G_vt_bar_sl6_minus_x2_plus -> "G_vt_bar_sl6_minus_x2_plus"
      | G_x1_minus_su1_d_bar -> "G_x1_minus_su1_d_bar"
      | G_x1_minus_su2_s_bar -> "G_x1_minus_su2_s_bar"
      | G_b_bar_su3_x1_minus -> "G_b_bar_su3_x1_minus"
      | G_b_bar_su6_x1_minus -> "G_b_bar_su6_x1_minus"
      | G_x2_minus_su1_d_bar -> "G_x2_minus_su1_d_bar"
      | G_x2_minus_su2_s_bar -> "G_x2_minus_su2_s_bar"
      | G_b_bar_su3_x2_minus -> "G_b_bar_su3_x2_minus"
      | G_b_bar_su6_x2_minus -> "G_b_bar_su6_x2_minus"
      | G_x1_minus_h_plus_n1 -> "G_x1_minus_h_plus_n1"
      | G_x1_minus_h_plus_n2 -> "G_x1_minus_h_plus_n2"
      | G_x1_minus_h_plus_n3 -> "G_x1_minus_h_plus_n3"
      | G_x1_minus_h_plus_n4 -> "G_x1_minus_h_plus_n4"
      | G_x2_minus_h_plus_n1 -> "G_x2_minus_h_plus_n1"
      | G_x2_minus_h_plus_n2 -> "G_x2_minus_h_plus_n2"
      | G_x2_minus_h_plus_n3 -> "G_x2_minus_h_plus_n3"
      | G_x2_minus_h_plus_n4 -> "G_x2_minus_h_plus_n4"
      | G_x1_minus_sv1_e_plus -> "G_x1_minus_sv1_e_plus"
      | G_x1_minus_sv2_mu_plus -> "G_x1_minus_sv2_mu_plus"
      | G_x1_minus_sv3_tau_plus -> "G_x1_minus_sv3_tau_plus"
      | G_x2_minus_sv1_e_plus -> "G_x2_minus_sv1_e_plus"
      | G_x2_minus_sv2_mu_plus -> "G_x2_minus_sv2_mu_plus"
      | G_x2_minus_sv3_tau_plus -> "G_x2_minus_sv3_tau_plus"
      | G_x1_minus_w_plus_n1 -> "G_x1_minus_w_plus_n1"
      | G_x1_minus_w_plus_n2 -> "G_x1_minus_w_plus_n2"
      | G_x1_minus_w_plus_n3 -> "G_x1_minus_w_plus_n3"
      | G_x1_minus_w_plus_n4 -> "G_x1_minus_w_plus_n4"
      | G_x2_minus_w_plus_n1 -> "G_x2_minus_w_plus_n1"
      | G_x2_minus_w_plus_n2 -> "G_x2_minus_w_plus_n2"
      | G_x2_minus_w_plus_n3 -> "G_x2_minus_w_plus_n3"
      | G_x2_minus_w_plus_n4 -> "G_x2_minus_w_plus_n4"
      | G_x1_minus_sd1_bar_u -> "G_x1_minus_sd1_bar_u"
      | G_x1_minus_sd2_bar_c -> "G_x1_minus_sd2_bar_c"
      | G_x1_minus_sd3_bar_t -> "G_x1_minus_sd3_bar_t"
      | G_x1_minus_sd6_bar_t -> "G_x1_minus_sd6_bar_t"
      | G_x2_minus_sd1_bar_u -> "G_x2_minus_sd1_bar_u"
      | G_x2_minus_sd2_bar_c -> "G_x2_minus_sd2_bar_c"
      | G_x2_minus_sd3_bar_t -> "G_x2_minus_sd3_bar_t"
      | G_x2_minus_sd6_bar_t -> "G_x2_minus_sd6_bar_t"
      | G_x1_minus_sl1_plus_ve -> "G_x1_minus_sl1_plus_ve"
      | G_x1_minus_sl2_plus_vm -> "G_x1_minus_sl2_plus_vm"
      | G_x1_minus_sl3_plus_vt -> "G_x1_minus_sl3_plus_vt"
      | G_x1_minus_sl6_plus_vt -> "G_x1_minus_sl6_plus_vt"
      | G_x2_minus_sl1_plus_ve -> "G_x2_minus_sl1_plus_ve"
      | G_x2_minus_sl2_plus_vm -> "G_x2_minus_sl2_plus_vm"
      | G_x2_minus_sl3_plus_vt -> "G_x2_minus_sl3_plus_vt"
      | G_x2_minus_sl6_plus_vt -> "G_x2_minus_sl6_plus_vt"
      | G_d_bar_g_1_d -> "G_d_bar_g_1_d" | G_b_bar_h01_b -> "G_b_bar_h01_b"
      | G_b_bar_h02_b -> "G_b_bar_h02_b" | G_d_bar_z_1_d -> "G_d_bar_z_1_d"
      | G_go_1_sd1_bar_d -> "G_go_1_sd1_bar_d"
      | G_go_1_sd4_bar_d -> "G_go_1_sd4_bar_d"
      | G_go_1_sd2_bar_s -> "G_go_1_sd2_bar_s"
      | G_go_1_sd5_bar_s -> "G_go_1_sd5_bar_s"
      | G_go_1_sd3_bar_b -> "G_go_1_sd3_bar_b"
      | G_go_1_sd6_bar_b -> "G_go_1_sd6_bar_b"
      | G_t_bar_h_plus_b -> "G_t_bar_h_plus_b" | G_n1_sd1_bar_d -> "G_n1_sd1_bar_d"
      | G_n1_sd4_bar_d -> "G_n1_sd4_bar_d" | G_n2_sd1_bar_d -> "G_n2_sd1_bar_d"
      | G_n2_sd4_bar_d -> "G_n2_sd4_bar_d" | G_n3_sd1_bar_d -> "G_n3_sd1_bar_d"
      | G_n3_sd4_bar_d -> "G_n3_sd4_bar_d" | G_n4_sd1_bar_d -> "G_n4_sd1_bar_d"
      | G_n4_sd4_bar_d -> "G_n4_sd4_bar_d" | G_n1_sd2_bar_s -> "G_n1_sd2_bar_s"
      | G_n1_sd5_bar_s -> "G_n1_sd5_bar_s" | G_n2_sd2_bar_s -> "G_n2_sd2_bar_s"
      | G_n2_sd5_bar_s -> "G_n2_sd5_bar_s" | G_n3_sd2_bar_s -> "G_n3_sd2_bar_s"
      | G_n3_sd5_bar_s -> "G_n3_sd5_bar_s" | G_n4_sd2_bar_s -> "G_n4_sd2_bar_s"
      | G_n4_sd5_bar_s -> "G_n4_sd5_bar_s" | G_n1_sd3_bar_b -> "G_n1_sd3_bar_b"
      | G_n1_sd6_bar_b -> "G_n1_sd6_bar_b" | G_n2_sd3_bar_b -> "G_n2_sd3_bar_b"
      | G_n2_sd6_bar_b -> "G_n2_sd6_bar_b" | G_n3_sd3_bar_b -> "G_n3_sd3_bar_b"
      | G_n3_sd6_bar_b -> "G_n3_sd6_bar_b" | G_n4_sd3_bar_b -> "G_n4_sd3_bar_b"
      | G_n4_sd6_bar_b -> "G_n4_sd6_bar_b" | G_u_bar_w_plus_d -> "G_u_bar_w_plus_d"
      | G_c_bar_w_plus_s -> "G_c_bar_w_plus_s"
      | G_t_bar_w_plus_b -> "G_t_bar_w_plus_b"
      | G_d_bar_sd1_go_1 -> "G_d_bar_sd1_go_1"
      | G_d_bar_sd4_go_1 -> "G_d_bar_sd4_go_1"
      | G_s_bar_sd2_go_1 -> "G_s_bar_sd2_go_1"
      | G_s_bar_sd5_go_1 -> "G_s_bar_sd5_go_1"
      | G_b_bar_sd3_go_1 -> "G_b_bar_sd3_go_1"
      | G_b_bar_sd6_go_1 -> "G_b_bar_sd6_go_1"
      | G_b_bar_h_minus_t -> "G_b_bar_h_minus_t" | G_d_bar_sd1_n1 -> "G_d_bar_sd1_n1"
      | G_d_bar_sd4_n1 -> "G_d_bar_sd4_n1" | G_d_bar_sd1_n2 -> "G_d_bar_sd1_n2"
      | G_d_bar_sd4_n2 -> "G_d_bar_sd4_n2" | G_d_bar_sd1_n3 -> "G_d_bar_sd1_n3"
      | G_d_bar_sd4_n3 -> "G_d_bar_sd4_n3" | G_d_bar_sd1_n4 -> "G_d_bar_sd1_n4"
      | G_d_bar_sd4_n4 -> "G_d_bar_sd4_n4" | G_s_bar_sd2_n1 -> "G_s_bar_sd2_n1"
      | G_s_bar_sd5_n1 -> "G_s_bar_sd5_n1" | G_s_bar_sd2_n2 -> "G_s_bar_sd2_n2"
      | G_s_bar_sd5_n2 -> "G_s_bar_sd5_n2" | G_s_bar_sd2_n3 -> "G_s_bar_sd2_n3"
      | G_s_bar_sd5_n3 -> "G_s_bar_sd5_n3" | G_s_bar_sd2_n4 -> "G_s_bar_sd2_n4"
      | G_s_bar_sd5_n4 -> "G_s_bar_sd5_n4" | G_b_bar_sd3_n1 -> "G_b_bar_sd3_n1"
      | G_b_bar_sd6_n1 -> "G_b_bar_sd6_n1" | G_b_bar_sd3_n2 -> "G_b_bar_sd3_n2"
      | G_b_bar_sd6_n2 -> "G_b_bar_sd6_n2" | G_b_bar_sd3_n3 -> "G_b_bar_sd3_n3"
      | G_b_bar_sd6_n3 -> "G_b_bar_sd6_n3" | G_b_bar_sd3_n4 -> "G_b_bar_sd3_n4"
      | G_b_bar_sd6_n4 -> "G_b_bar_sd6_n4" | G_d_bar_w_minus_u -> "G_d_bar_w_minus_u"
      | G_s_bar_w_minus_c -> "G_s_bar_w_minus_c"
      | G_b_bar_w_minus_t -> "G_b_bar_w_minus_t"
      | G_g_1_sd1_sd1_bar -> "G_g_1_sd1_sd1_bar"
      | G_g_1_sd2_sd2_bar -> "G_g_1_sd2_sd2_bar"
      | G_g_1_sd3_sd3_bar -> "G_g_1_sd3_sd3_bar"
      | G_g_1_sd3_sd6_bar -> "G_g_1_sd3_sd6_bar"
      | G_g_1_sd4_sd4_bar -> "G_g_1_sd4_sd4_bar"
      | G_g_1_sd5_sd5_bar -> "G_g_1_sd5_sd5_bar"
      | G_g_1_sd3_bar_sd6 -> "G_g_1_sd3_bar_sd6"
      | G_g_1_sd6_sd6_bar -> "G_g_1_sd6_sd6_bar"
      | G_g_1_su1_su1_bar -> "G_g_1_su1_su1_bar"
      | G_g_1_su2_su2_bar -> "G_g_1_su2_su2_bar"
      | G_g_1_su3_su3_bar -> "G_g_1_su3_su3_bar"
      | G_g_1_su3_su6_bar -> "G_g_1_su3_su6_bar"
      | G_g_1_su4_su4_bar -> "G_g_1_su4_su4_bar"
      | G_g_1_su5_su5_bar -> "G_g_1_su5_su5_bar"
      | G_g_1_su3_bar_su6 -> "G_g_1_su3_bar_su6"
      | G_g_1_su6_su6_bar -> "G_g_1_su6_su6_bar"
      | G_u_bar_su1_go_1 -> "G_u_bar_su1_go_1"
      | G_c_bar_su2_go_1 -> "G_c_bar_su2_go_1"
      | G_t_bar_su3_go_1 -> "G_t_bar_su3_go_1"
      | G_u_bar_su4_go_1 -> "G_u_bar_su4_go_1"
      | G_c_bar_su5_go_1 -> "G_c_bar_su5_go_1"
      | G_t_bar_su6_go_1 -> "G_t_bar_su6_go_1"
      | G_go_1_su1_bar_u -> "G_go_1_su1_bar_u"
      | G_go_1_su2_bar_c -> "G_go_1_su2_bar_c"
      | G_go_1_su3_bar_t -> "G_go_1_su3_bar_t"
      | G_go_1_su4_bar_u -> "G_go_1_su4_bar_u"
      | G_go_1_su5_bar_c -> "G_go_1_su5_bar_c"
      | G_go_1_su6_bar_t -> "G_go_1_su6_bar_t"
      | G_vt_bar_h_plus_tau_minus -> "G_vt_bar_h_plus_tau_minus"
      | G_h_plus_sd1_su1_bar -> "G_h_plus_sd1_su1_bar"
      | G_h_plus_sd2_su2_bar -> "G_h_plus_sd2_su2_bar"
      | G_h_plus_sd3_su3_bar -> "G_h_plus_sd3_su3_bar"
      | G_h_plus_sd3_su6_bar -> "G_h_plus_sd3_su6_bar"
      | G_h_plus_sd6_su3_bar -> "G_h_plus_sd6_su3_bar"
      | G_h_plus_sd6_su6_bar -> "G_h_plus_sd6_su6_bar"
      | G_h_plus_sl1_minus_sv1_bar -> "G_h_plus_sl1_minus_sv1_bar"
      | G_h_plus_sl2_minus_sv2_bar -> "G_h_plus_sl2_minus_sv2_bar"
      | G_h_plus_sl3_minus_sv3_bar -> "G_h_plus_sl3_minus_sv3_bar"
      | G_h_plus_sl6_minus_sv3_bar -> "G_h_plus_sl6_minus_sv3_bar"
      | G_tau_plus_h01_tau_minus -> "G_tau_plus_h01_tau_minus"
      | G_n1_h01_n1 -> "G_n1_h01_n1" | G_n1_h01_n2 -> "G_n1_h01_n2"
      | G_n1_h01_n3 -> "G_n1_h01_n3" | G_n1_h01_n4 -> "G_n1_h01_n4"
      | G_n2_h01_n2 -> "G_n2_h01_n2" | G_n2_h01_n3 -> "G_n2_h01_n3"
      | G_n2_h01_n4 -> "G_n2_h01_n4" | G_n3_h01_n3 -> "G_n3_h01_n3"
      | G_n3_h01_n4 -> "G_n3_h01_n4" | G_n4_h01_n4 -> "G_n4_h01_n4"
      | G_h01_sd1_sd1_bar -> "G_h01_sd1_sd1_bar"
      | G_h01_sd2_sd2_bar -> "G_h01_sd2_sd2_bar"
      | G_h01_sd3_sd3_bar -> "G_h01_sd3_sd3_bar"
      | G_h01_sd3_sd6_bar -> "G_h01_sd3_sd6_bar"
      | G_h01_sd4_sd4_bar -> "G_h01_sd4_sd4_bar"
      | G_h01_sd5_sd5_bar -> "G_h01_sd5_sd5_bar"
      | G_h01_sd3_bar_sd6 -> "G_h01_sd3_bar_sd6"
      | G_h01_sd6_sd6_bar -> "G_h01_sd6_sd6_bar"
      | G_h01_sl1_minus_sl1_plus -> "G_h01_sl1_minus_sl1_plus"
      | G_h01_sl2_minus_sl2_plus -> "G_h01_sl2_minus_sl2_plus"
      | G_h01_sl3_minus_sl3_plus -> "G_h01_sl3_minus_sl3_plus"
      | G_h01_sl3_minus_sl6_plus -> "G_h01_sl3_minus_sl6_plus"
      | G_h01_sl4_minus_sl4_plus -> "G_h01_sl4_minus_sl4_plus"
      | G_h01_sl5_minus_sl5_plus -> "G_h01_sl5_minus_sl5_plus"
      | G_h01_sl3_plus_sl6_minus -> "G_h01_sl3_plus_sl6_minus"
      | G_h01_sl6_minus_sl6_plus -> "G_h01_sl6_minus_sl6_plus"
      | G_h01_sv1_sv1_bar -> "G_h01_sv1_sv1_bar"
      | G_h01_su1_su1_bar -> "G_h01_su1_su1_bar"
      | G_h01_su2_su2_bar -> "G_h01_su2_su2_bar"
      | G_h01_su3_su3_bar -> "G_h01_su3_su3_bar"
      | G_h01_su3_su6_bar -> "G_h01_su3_su6_bar"
      | G_h01_su4_su4_bar -> "G_h01_su4_su4_bar"
      | G_h01_su5_su5_bar -> "G_h01_su5_su5_bar"
      | G_h01_su3_bar_su6 -> "G_h01_su3_bar_su6"
      | G_h01_su6_su6_bar -> "G_h01_su6_su6_bar" | G_t_bar_h01_t -> "G_t_bar_h01_t"
      | G_tau_plus_h02_tau_minus -> "G_tau_plus_h02_tau_minus"
      | G_n1_h02_n1 -> "G_n1_h02_n1" | G_n1_h02_n2 -> "G_n1_h02_n2"
      | G_n1_h02_n3 -> "G_n1_h02_n3" | G_n1_h02_n4 -> "G_n1_h02_n4"
      | G_n2_h02_n2 -> "G_n2_h02_n2" | G_n2_h02_n3 -> "G_n2_h02_n3"
      | G_n2_h02_n4 -> "G_n2_h02_n4" | G_n3_h02_n3 -> "G_n3_h02_n3"
      | G_n3_h02_n4 -> "G_n3_h02_n4" | G_n4_h02_n4 -> "G_n4_h02_n4"
      | G_h02_sd1_sd1_bar -> "G_h02_sd1_sd1_bar"
      | G_h02_sd2_sd2_bar -> "G_h02_sd2_sd2_bar"
      | G_h02_sd3_sd3_bar -> "G_h02_sd3_sd3_bar"
      | G_h02_sd3_sd6_bar -> "G_h02_sd3_sd6_bar"
      | G_h02_sd4_sd4_bar -> "G_h02_sd4_sd4_bar"
      | G_h02_sd5_sd5_bar -> "G_h02_sd5_sd5_bar"
      | G_h02_sd3_bar_sd6 -> "G_h02_sd3_bar_sd6"
      | G_h02_sd6_sd6_bar -> "G_h02_sd6_sd6_bar"
      | G_h02_sl1_minus_sl1_plus -> "G_h02_sl1_minus_sl1_plus"
      | G_h02_sl2_minus_sl2_plus -> "G_h02_sl2_minus_sl2_plus"
      | G_h02_sl3_minus_sl3_plus -> "G_h02_sl3_minus_sl3_plus"
      | G_h02_sl3_minus_sl6_plus -> "G_h02_sl3_minus_sl6_plus"
      | G_h02_sl4_minus_sl4_plus -> "G_h02_sl4_minus_sl4_plus"
      | G_h02_sl5_minus_sl5_plus -> "G_h02_sl5_minus_sl5_plus"
      | G_h02_sl3_plus_sl6_minus -> "G_h02_sl3_plus_sl6_minus"
      | G_h02_sl6_minus_sl6_plus -> "G_h02_sl6_minus_sl6_plus"
      | G_h02_sv1_sv1_bar -> "G_h02_sv1_sv1_bar"
      | G_h02_su1_su1_bar -> "G_h02_su1_su1_bar"
      | G_h02_su2_su2_bar -> "G_h02_su2_su2_bar"
      | G_h02_su3_su3_bar -> "G_h02_su3_su3_bar"
      | G_h02_su3_su6_bar -> "G_h02_su3_su6_bar"
      | G_h02_su4_su4_bar -> "G_h02_su4_su4_bar"
      | G_h02_su5_su5_bar -> "G_h02_su5_su5_bar"
      | G_h02_su3_bar_su6 -> "G_h02_su3_bar_su6"
      | G_h02_su6_su6_bar -> "G_h02_su6_su6_bar" | G_t_bar_h02_t -> "G_t_bar_h02_t"
      | G_tau_plus_h_minus_vt -> "G_tau_plus_h_minus_vt"
      | G_h_minus_sd1_bar_su1 -> "G_h_minus_sd1_bar_su1"
      | G_h_minus_sd2_bar_su2 -> "G_h_minus_sd2_bar_su2"
      | G_h_minus_sd3_bar_su3 -> "G_h_minus_sd3_bar_su3"
      | G_h_minus_sd3_bar_su6 -> "G_h_minus_sd3_bar_su6"
      | G_h_minus_sd6_bar_su3 -> "G_h_minus_sd6_bar_su3"
      | G_h_minus_sd6_bar_su6 -> "G_h_minus_sd6_bar_su6"
      | G_h_minus_sl1_plus_sv1 -> "G_h_minus_sl1_plus_sv1"
      | G_h_minus_sl2_plus_sv2 -> "G_h_minus_sl2_plus_sv2"
      | G_h_minus_sl3_plus_sv3 -> "G_h_minus_sl3_plus_sv3"
      | G_h_minus_sl6_plus_sv3 -> "G_h_minus_sl6_plus_sv3"
      | G_e_plus_z_1_e_minus -> "G_e_plus_z_1_e_minus"
      | G_n1_sl1_plus_e_minus -> "G_n1_sl1_plus_e_minus"
      | G_n1_sl4_plus_e_minus -> "G_n1_sl4_plus_e_minus"
      | G_n2_sl1_plus_e_minus -> "G_n2_sl1_plus_e_minus"
      | G_n2_sl4_plus_e_minus -> "G_n2_sl4_plus_e_minus"
      | G_n3_sl1_plus_e_minus -> "G_n3_sl1_plus_e_minus"
      | G_n3_sl4_plus_e_minus -> "G_n3_sl4_plus_e_minus"
      | G_n4_sl1_plus_e_minus -> "G_n4_sl1_plus_e_minus"
      | G_n4_sl4_plus_e_minus -> "G_n4_sl4_plus_e_minus"
      | G_n1_sl2_plus_mu_minus -> "G_n1_sl2_plus_mu_minus"
      | G_n1_sl5_plus_mu_minus -> "G_n1_sl5_plus_mu_minus"
      | G_n2_sl2_plus_mu_minus -> "G_n2_sl2_plus_mu_minus"
      | G_n2_sl5_plus_mu_minus -> "G_n2_sl5_plus_mu_minus"
      | G_n3_sl2_plus_mu_minus -> "G_n3_sl2_plus_mu_minus"
      | G_n3_sl5_plus_mu_minus -> "G_n3_sl5_plus_mu_minus"
      | G_n4_sl2_plus_mu_minus -> "G_n4_sl2_plus_mu_minus"
      | G_n4_sl5_plus_mu_minus -> "G_n4_sl5_plus_mu_minus"
      | G_n1_sl3_plus_tau_minus -> "G_n1_sl3_plus_tau_minus"
      | G_n1_sl6_plus_tau_minus -> "G_n1_sl6_plus_tau_minus"
      | G_n2_sl3_plus_tau_minus -> "G_n2_sl3_plus_tau_minus"
      | G_n2_sl6_plus_tau_minus -> "G_n2_sl6_plus_tau_minus"
      | G_n3_sl3_plus_tau_minus -> "G_n3_sl3_plus_tau_minus"
      | G_n3_sl6_plus_tau_minus -> "G_n3_sl6_plus_tau_minus"
      | G_n4_sl3_plus_tau_minus -> "G_n4_sl3_plus_tau_minus"
      | G_n4_sl6_plus_tau_minus -> "G_n4_sl6_plus_tau_minus"
      | G_ve_bar_w_plus_e_minus -> "G_ve_bar_w_plus_e_minus"
      | G_e_plus_sl1_minus_n1 -> "G_e_plus_sl1_minus_n1"
      | G_e_plus_sl4_minus_n1 -> "G_e_plus_sl4_minus_n1"
      | G_e_plus_sl1_minus_n2 -> "G_e_plus_sl1_minus_n2"
      | G_e_plus_sl4_minus_n2 -> "G_e_plus_sl4_minus_n2"
      | G_e_plus_sl1_minus_n3 -> "G_e_plus_sl1_minus_n3"
      | G_e_plus_sl4_minus_n3 -> "G_e_plus_sl4_minus_n3"
      | G_e_plus_sl1_minus_n4 -> "G_e_plus_sl1_minus_n4"
      | G_e_plus_sl4_minus_n4 -> "G_e_plus_sl4_minus_n4"
      | G_mu_plus_sl2_minus_n1 -> "G_mu_plus_sl2_minus_n1"
      | G_mu_plus_sl5_minus_n1 -> "G_mu_plus_sl5_minus_n1"
      | G_mu_plus_sl2_minus_n2 -> "G_mu_plus_sl2_minus_n2"
      | G_mu_plus_sl5_minus_n2 -> "G_mu_plus_sl5_minus_n2"
      | G_mu_plus_sl2_minus_n3 -> "G_mu_plus_sl2_minus_n3"
      | G_mu_plus_sl5_minus_n3 -> "G_mu_plus_sl5_minus_n3"
      | G_mu_plus_sl2_minus_n4 -> "G_mu_plus_sl2_minus_n4"
      | G_mu_plus_sl5_minus_n4 -> "G_mu_plus_sl5_minus_n4"
      | G_tau_plus_sl3_minus_n1 -> "G_tau_plus_sl3_minus_n1"
      | G_tau_plus_sl6_minus_n1 -> "G_tau_plus_sl6_minus_n1"
      | G_tau_plus_sl3_minus_n2 -> "G_tau_plus_sl3_minus_n2"
      | G_tau_plus_sl6_minus_n2 -> "G_tau_plus_sl6_minus_n2"
      | G_tau_plus_sl3_minus_n3 -> "G_tau_plus_sl3_minus_n3"
      | G_tau_plus_sl6_minus_n3 -> "G_tau_plus_sl6_minus_n3"
      | G_tau_plus_sl3_minus_n4 -> "G_tau_plus_sl3_minus_n4"
      | G_tau_plus_sl6_minus_n4 -> "G_tau_plus_sl6_minus_n4"
      | G_n1_z_1_n1 -> "G_n1_z_1_n1" | G_n1_z_1_n2 -> "G_n1_z_1_n2"
      | G_n1_z_1_n3 -> "G_n1_z_1_n3" | G_n1_z_1_n4 -> "G_n1_z_1_n4"
      | G_n2_z_1_n2 -> "G_n2_z_1_n2" | G_n2_z_1_n3 -> "G_n2_z_1_n3"
      | G_n2_z_1_n4 -> "G_n2_z_1_n4" | G_n3_z_1_n3 -> "G_n3_z_1_n3"
      | G_n3_z_1_n4 -> "G_n3_z_1_n4" | G_n4_z_1_n4 -> "G_n4_z_1_n4"
      | G_ve_bar_sv1_n1 -> "G_ve_bar_sv1_n1" | G_vm_bar_sv2_n1 -> "G_vm_bar_sv2_n1"
      | G_vt_bar_sv3_n1 -> "G_vt_bar_sv3_n1" | G_ve_bar_sv1_n2 -> "G_ve_bar_sv1_n2"
      | G_vm_bar_sv2_n2 -> "G_vm_bar_sv2_n2" | G_vt_bar_sv3_n2 -> "G_vt_bar_sv3_n2"
      | G_ve_bar_sv1_n3 -> "G_ve_bar_sv1_n3" | G_vm_bar_sv2_n3 -> "G_vm_bar_sv2_n3"
      | G_vt_bar_sv3_n3 -> "G_vt_bar_sv3_n3" | G_ve_bar_sv1_n4 -> "G_ve_bar_sv1_n4"
      | G_vm_bar_sv2_n4 -> "G_vm_bar_sv2_n4" | G_vt_bar_sv3_n4 -> "G_vt_bar_sv3_n4"
      | G_n1_sv1_bar_ve -> "G_n1_sv1_bar_ve" | G_n1_sv2_bar_vm -> "G_n1_sv2_bar_vm"
      | G_n1_sv3_bar_vt -> "G_n1_sv3_bar_vt" | G_n2_sv1_bar_ve -> "G_n2_sv1_bar_ve"
      | G_n2_sv2_bar_vm -> "G_n2_sv2_bar_vm" | G_n2_sv3_bar_vt -> "G_n2_sv3_bar_vt"
      | G_n3_sv1_bar_ve -> "G_n3_sv1_bar_ve" | G_n3_sv2_bar_vm -> "G_n3_sv2_bar_vm"
      | G_n3_sv3_bar_vt -> "G_n3_sv3_bar_vt" | G_n4_sv1_bar_ve -> "G_n4_sv1_bar_ve"
      | G_n4_sv2_bar_vm -> "G_n4_sv2_bar_vm" | G_n4_sv3_bar_vt -> "G_n4_sv3_bar_vt"
      | G_u_bar_su1_n1 -> "G_u_bar_su1_n1" | G_c_bar_su2_n1 -> "G_c_bar_su2_n1"
      | G_t_bar_su3_n1 -> "G_t_bar_su3_n1" | G_u_bar_su4_n1 -> "G_u_bar_su4_n1"
      | G_c_bar_su5_n1 -> "G_c_bar_su5_n1" | G_t_bar_su6_n1 -> "G_t_bar_su6_n1"
      | G_u_bar_su1_n2 -> "G_u_bar_su1_n2" | G_c_bar_su2_n2 -> "G_c_bar_su2_n2"
      | G_t_bar_su3_n2 -> "G_t_bar_su3_n2" | G_u_bar_su4_n2 -> "G_u_bar_su4_n2"
      | G_c_bar_su5_n2 -> "G_c_bar_su5_n2" | G_t_bar_su6_n2 -> "G_t_bar_su6_n2"
      | G_u_bar_su1_n3 -> "G_u_bar_su1_n3" | G_c_bar_su2_n3 -> "G_c_bar_su2_n3"
      | G_t_bar_su3_n3 -> "G_t_bar_su3_n3" | G_u_bar_su4_n3 -> "G_u_bar_su4_n3"
      | G_c_bar_su5_n3 -> "G_c_bar_su5_n3" | G_t_bar_su6_n3 -> "G_t_bar_su6_n3"
      | G_u_bar_su1_n4 -> "G_u_bar_su1_n4" | G_c_bar_su2_n4 -> "G_c_bar_su2_n4"
      | G_t_bar_su3_n4 -> "G_t_bar_su3_n4" | G_u_bar_su4_n4 -> "G_u_bar_su4_n4"
      | G_c_bar_su5_n4 -> "G_c_bar_su5_n4" | G_t_bar_su6_n4 -> "G_t_bar_su6_n4"
      | G_n1_su1_bar_u -> "G_n1_su1_bar_u" | G_n1_su2_bar_c -> "G_n1_su2_bar_c"
      | G_n1_su3_bar_t -> "G_n1_su3_bar_t" | G_n1_su4_bar_u -> "G_n1_su4_bar_u"
      | G_n1_su5_bar_c -> "G_n1_su5_bar_c" | G_n1_su6_bar_t -> "G_n1_su6_bar_t"
      | G_n2_su1_bar_u -> "G_n2_su1_bar_u" | G_n2_su2_bar_c -> "G_n2_su2_bar_c"
      | G_n2_su3_bar_t -> "G_n2_su3_bar_t" | G_n2_su4_bar_u -> "G_n2_su4_bar_u"
      | G_n2_su5_bar_c -> "G_n2_su5_bar_c" | G_n2_su6_bar_t -> "G_n2_su6_bar_t"
      | G_n3_su1_bar_u -> "G_n3_su1_bar_u" | G_n3_su2_bar_c -> "G_n3_su2_bar_c"
      | G_n3_su3_bar_t -> "G_n3_su3_bar_t" | G_n3_su4_bar_u -> "G_n3_su4_bar_u"
      | G_n3_su5_bar_c -> "G_n3_su5_bar_c" | G_n3_su6_bar_t -> "G_n3_su6_bar_t"
      | G_n4_su1_bar_u -> "G_n4_su1_bar_u" | G_n4_su2_bar_c -> "G_n4_su2_bar_c"
      | G_n4_su3_bar_t -> "G_n4_su3_bar_t" | G_n4_su4_bar_u -> "G_n4_su4_bar_u"
      | G_n4_su5_bar_c -> "G_n4_su5_bar_c" | G_n4_su6_bar_t -> "G_n4_su6_bar_t"
      | G_z_1_sd1_sd1_bar -> "G_z_1_sd1_sd1_bar"
      | G_z_1_sd2_sd2_bar -> "G_z_1_sd2_sd2_bar"
      | G_z_1_sd3_sd3_bar -> "G_z_1_sd3_sd3_bar"
      | G_z_1_sd3_sd6_bar -> "G_z_1_sd3_sd6_bar"
      | G_z_1_sd4_sd4_bar -> "G_z_1_sd4_sd4_bar"
      | G_z_1_sd5_sd5_bar -> "G_z_1_sd5_sd5_bar"
      | G_z_1_sd3_bar_sd6 -> "G_z_1_sd3_bar_sd6"
      | G_z_1_sd6_sd6_bar -> "G_z_1_sd6_sd6_bar"
      | G_w_plus_sd1_su1_bar -> "G_w_plus_sd1_su1_bar"
      | G_w_plus_sd2_su2_bar -> "G_w_plus_sd2_su2_bar"
      | G_w_plus_sd3_su3_bar -> "G_w_plus_sd3_su3_bar"
      | G_w_plus_sd3_su6_bar -> "G_w_plus_sd3_su6_bar"
      | G_w_plus_sd6_su3_bar -> "G_w_plus_sd6_su3_bar"
      | G_w_plus_sd6_su6_bar -> "G_w_plus_sd6_su6_bar"
      | G_w_minus_sd1_bar_su1 -> "G_w_minus_sd1_bar_su1"
      | G_w_minus_sd2_bar_su2 -> "G_w_minus_sd2_bar_su2"
      | G_w_minus_sd3_bar_su3 -> "G_w_minus_sd3_bar_su3"
      | G_w_minus_sd3_bar_su6 -> "G_w_minus_sd3_bar_su6"
      | G_w_minus_sd6_bar_su3 -> "G_w_minus_sd6_bar_su3"
      | G_w_minus_sd6_bar_su6 -> "G_w_minus_sd6_bar_su6"
      | G_z_1_sl1_minus_sl1_plus -> "G_z_1_sl1_minus_sl1_plus"
      | G_z_1_sl2_minus_sl2_plus -> "G_z_1_sl2_minus_sl2_plus"
      | G_z_1_sl3_minus_sl3_plus -> "G_z_1_sl3_minus_sl3_plus"
      | G_z_1_sl3_minus_sl6_plus -> "G_z_1_sl3_minus_sl6_plus"
      | G_z_1_sl4_minus_sl4_plus -> "G_z_1_sl4_minus_sl4_plus"
      | G_z_1_sl5_minus_sl5_plus -> "G_z_1_sl5_minus_sl5_plus"
      | G_z_1_sl3_plus_sl6_minus -> "G_z_1_sl3_plus_sl6_minus"
      | G_z_1_sl6_minus_sl6_plus -> "G_z_1_sl6_minus_sl6_plus"
      | G_w_plus_sl1_minus_sv1_bar -> "G_w_plus_sl1_minus_sv1_bar"
      | G_w_plus_sl2_minus_sv2_bar -> "G_w_plus_sl2_minus_sv2_bar"
      | G_w_plus_sl3_minus_sv3_bar -> "G_w_plus_sl3_minus_sv3_bar"
      | G_w_plus_sl6_minus_sv3_bar -> "G_w_plus_sl6_minus_sv3_bar"
      | G_w_minus_sl1_plus_sv1 -> "G_w_minus_sl1_plus_sv1"
      | G_w_minus_sl2_plus_sv2 -> "G_w_minus_sl2_plus_sv2"
      | G_w_minus_sl3_plus_sv3 -> "G_w_minus_sl3_plus_sv3"
      | G_w_minus_sl6_plus_sv3 -> "G_w_minus_sl6_plus_sv3"
      | G_z_1_sv1_sv1_bar -> "G_z_1_sv1_sv1_bar"
      | G_z_1_su1_su1_bar -> "G_z_1_su1_su1_bar"
      | G_z_1_su2_su2_bar -> "G_z_1_su2_su2_bar"
      | G_z_1_su3_su3_bar -> "G_z_1_su3_su3_bar"
      | G_z_1_su3_su6_bar -> "G_z_1_su3_su6_bar"
      | G_z_1_su4_su4_bar -> "G_z_1_su4_su4_bar"
      | G_z_1_su5_su5_bar -> "G_z_1_su5_su5_bar"
      | G_z_1_su3_bar_su6 -> "G_z_1_su3_bar_su6"
      | G_z_1_su6_su6_bar -> "G_z_1_su6_su6_bar" | G_u_bar_z_1_u -> "G_u_bar_z_1_u"
      | G_ve_bar_z_1_ve -> "G_ve_bar_z_1_ve"
      | G_sd1_sd1_bar_a_1_a_1 -> "G_sd1_sd1_bar_a_1_a_1"
      | G_sd2_sd2_bar_a_1_a_1 -> "G_sd2_sd2_bar_a_1_a_1"
      | G_sd3_sd3_bar_a_1_a_1 -> "G_sd3_sd3_bar_a_1_a_1"
      | G_sd3_sd6_bar_a_1_a_1 -> "G_sd3_sd6_bar_a_1_a_1"
      | G_sd4_sd4_bar_a_1_a_1 -> "G_sd4_sd4_bar_a_1_a_1"
      | G_sd5_sd5_bar_a_1_a_1 -> "G_sd5_sd5_bar_a_1_a_1"
      | G_sd3_bar_sd6_a_1_a_1 -> "G_sd3_bar_sd6_a_1_a_1"
      | G_sd6_sd6_bar_a_1_a_1 -> "G_sd6_sd6_bar_a_1_a_1"
      | G_sl1_minus_sl1_plus_a_1_a_1 -> "G_sl1_minus_sl1_plus_a_1_a_1"
      | G_sl2_minus_sl2_plus_a_1_a_1 -> "G_sl2_minus_sl2_plus_a_1_a_1"
      | G_sl3_minus_sl3_plus_a_1_a_1 -> "G_sl3_minus_sl3_plus_a_1_a_1"
      | G_sl3_minus_sl6_plus_a_1_a_1 -> "G_sl3_minus_sl6_plus_a_1_a_1"
      | G_sl4_minus_sl4_plus_a_1_a_1 -> "G_sl4_minus_sl4_plus_a_1_a_1"
      | G_sl5_minus_sl5_plus_a_1_a_1 -> "G_sl5_minus_sl5_plus_a_1_a_1"
      | G_sl3_plus_sl6_minus_a_1_a_1 -> "G_sl3_plus_sl6_minus_a_1_a_1"
      | G_sl6_minus_sl6_plus_a_1_a_1 -> "G_sl6_minus_sl6_plus_a_1_a_1"
      | G_su1_su1_bar_a_1_a_1 -> "G_su1_su1_bar_a_1_a_1"
      | G_su2_su2_bar_a_1_a_1 -> "G_su2_su2_bar_a_1_a_1"
      | G_su3_su3_bar_a_1_a_1 -> "G_su3_su3_bar_a_1_a_1"
      | G_su3_su6_bar_a_1_a_1 -> "G_su3_su6_bar_a_1_a_1"
      | G_su4_su4_bar_a_1_a_1 -> "G_su4_su4_bar_a_1_a_1"
      | G_su5_su5_bar_a_1_a_1 -> "G_su5_su5_bar_a_1_a_1"
      | G_su3_bar_su6_a_1_a_1 -> "G_su3_bar_su6_a_1_a_1"
      | G_su6_su6_bar_a_1_a_1 -> "G_su6_su6_bar_a_1_a_1"
      | G_sd1_sd1_bar_a_1_g_1 -> "G_sd1_sd1_bar_a_1_g_1"
      | G_sd2_sd2_bar_a_1_g_1 -> "G_sd2_sd2_bar_a_1_g_1"
      | G_sd3_sd3_bar_a_1_g_1 -> "G_sd3_sd3_bar_a_1_g_1"
      | G_sd3_sd6_bar_a_1_g_1 -> "G_sd3_sd6_bar_a_1_g_1"
      | G_sd4_sd4_bar_a_1_g_1 -> "G_sd4_sd4_bar_a_1_g_1"
      | G_sd5_sd5_bar_a_1_g_1 -> "G_sd5_sd5_bar_a_1_g_1"
      | G_sd3_bar_sd6_a_1_g_1 -> "G_sd3_bar_sd6_a_1_g_1"
      | G_sd6_sd6_bar_a_1_g_1 -> "G_sd6_sd6_bar_a_1_g_1"
      | G_su1_su1_bar_a_1_g_1 -> "G_su1_su1_bar_a_1_g_1"
      | G_su2_su2_bar_a_1_g_1 -> "G_su2_su2_bar_a_1_g_1"
      | G_su3_su3_bar_a_1_g_1 -> "G_su3_su3_bar_a_1_g_1"
      | G_su3_su6_bar_a_1_g_1 -> "G_su3_su6_bar_a_1_g_1"
      | G_su4_su4_bar_a_1_g_1 -> "G_su4_su4_bar_a_1_g_1"
      | G_su5_su5_bar_a_1_g_1 -> "G_su5_su5_bar_a_1_g_1"
      | G_su3_bar_su6_a_1_g_1 -> "G_su3_bar_su6_a_1_g_1"
      | G_su6_su6_bar_a_1_g_1 -> "G_su6_su6_bar_a_1_g_1"
      | G_sd1_sd1_bar_a_1_z_1 -> "G_sd1_sd1_bar_a_1_z_1"
      | G_sd2_sd2_bar_a_1_z_1 -> "G_sd2_sd2_bar_a_1_z_1"
      | G_sd3_sd3_bar_a_1_z_1 -> "G_sd3_sd3_bar_a_1_z_1"
      | G_sd3_sd6_bar_a_1_z_1 -> "G_sd3_sd6_bar_a_1_z_1"
      | G_sd4_sd4_bar_a_1_z_1 -> "G_sd4_sd4_bar_a_1_z_1"
      | G_sd5_sd5_bar_a_1_z_1 -> "G_sd5_sd5_bar_a_1_z_1"
      | G_sd3_bar_sd6_a_1_z_1 -> "G_sd3_bar_sd6_a_1_z_1"
      | G_sd6_sd6_bar_a_1_z_1 -> "G_sd6_sd6_bar_a_1_z_1"
      | G_sd1_su1_bar_a_1_w_plus -> "G_sd1_su1_bar_a_1_w_plus"
      | G_sd2_su2_bar_a_1_w_plus -> "G_sd2_su2_bar_a_1_w_plus"
      | G_sd3_su3_bar_a_1_w_plus -> "G_sd3_su3_bar_a_1_w_plus"
      | G_sd3_su6_bar_a_1_w_plus -> "G_sd3_su6_bar_a_1_w_plus"
      | G_sd6_su3_bar_a_1_w_plus -> "G_sd6_su3_bar_a_1_w_plus"
      | G_sd6_su6_bar_a_1_w_plus -> "G_sd6_su6_bar_a_1_w_plus"
      | G_sd1_bar_su1_a_1_w_minus -> "G_sd1_bar_su1_a_1_w_minus"
      | G_sd2_bar_su2_a_1_w_minus -> "G_sd2_bar_su2_a_1_w_minus"
      | G_sd3_bar_su3_a_1_w_minus -> "G_sd3_bar_su3_a_1_w_minus"
      | G_sd3_bar_su6_a_1_w_minus -> "G_sd3_bar_su6_a_1_w_minus"
      | G_sd6_bar_su3_a_1_w_minus -> "G_sd6_bar_su3_a_1_w_minus"
      | G_sd6_bar_su6_a_1_w_minus -> "G_sd6_bar_su6_a_1_w_minus"
      | G_sl1_minus_sl1_plus_a_1_z_1 -> "G_sl1_minus_sl1_plus_a_1_z_1"
      | G_sl2_minus_sl2_plus_a_1_z_1 -> "G_sl2_minus_sl2_plus_a_1_z_1"
      | G_sl3_minus_sl3_plus_a_1_z_1 -> "G_sl3_minus_sl3_plus_a_1_z_1"
      | G_sl3_minus_sl6_plus_a_1_z_1 -> "G_sl3_minus_sl6_plus_a_1_z_1"
      | G_sl4_minus_sl4_plus_a_1_z_1 -> "G_sl4_minus_sl4_plus_a_1_z_1"
      | G_sl5_minus_sl5_plus_a_1_z_1 -> "G_sl5_minus_sl5_plus_a_1_z_1"
      | G_sl3_plus_sl6_minus_a_1_z_1 -> "G_sl3_plus_sl6_minus_a_1_z_1"
      | G_sl6_minus_sl6_plus_a_1_z_1 -> "G_sl6_minus_sl6_plus_a_1_z_1"
      | G_sl1_minus_sv1_bar_a_1_w_plus -> "G_sl1_minus_sv1_bar_a_1_w_plus"
      | G_sl2_minus_sv2_bar_a_1_w_plus -> "G_sl2_minus_sv2_bar_a_1_w_plus"
      | G_sl3_minus_sv3_bar_a_1_w_plus -> "G_sl3_minus_sv3_bar_a_1_w_plus"
      | G_sl6_minus_sv3_bar_a_1_w_plus -> "G_sl6_minus_sv3_bar_a_1_w_plus"
      | G_sl1_plus_sv1_a_1_w_minus -> "G_sl1_plus_sv1_a_1_w_minus"
      | G_sl2_plus_sv2_a_1_w_minus -> "G_sl2_plus_sv2_a_1_w_minus"
      | G_sl3_plus_sv3_a_1_w_minus -> "G_sl3_plus_sv3_a_1_w_minus"
      | G_sl6_plus_sv3_a_1_w_minus -> "G_sl6_plus_sv3_a_1_w_minus"
      | G_su1_su1_bar_a_1_z_1 -> "G_su1_su1_bar_a_1_z_1"
      | G_su2_su2_bar_a_1_z_1 -> "G_su2_su2_bar_a_1_z_1"
      | G_su3_su3_bar_a_1_z_1 -> "G_su3_su3_bar_a_1_z_1"
      | G_su3_su6_bar_a_1_z_1 -> "G_su3_su6_bar_a_1_z_1"
      | G_su4_su4_bar_a_1_z_1 -> "G_su4_su4_bar_a_1_z_1"
      | G_su5_su5_bar_a_1_z_1 -> "G_su5_su5_bar_a_1_z_1"
      | G_su3_bar_su6_a_1_z_1 -> "G_su3_bar_su6_a_1_z_1"
      | G_su6_su6_bar_a_1_z_1 -> "G_su6_su6_bar_a_1_z_1"
      | G_sd1_sd1_bar_g_1_g_1 -> "G_sd1_sd1_bar_g_1_g_1"
      | G_sd2_sd2_bar_g_1_g_1 -> "G_sd2_sd2_bar_g_1_g_1"
      | G_sd3_sd3_bar_g_1_g_1 -> "G_sd3_sd3_bar_g_1_g_1"
      | G_sd3_sd6_bar_g_1_g_1 -> "G_sd3_sd6_bar_g_1_g_1"
      | G_sd4_sd4_bar_g_1_g_1 -> "G_sd4_sd4_bar_g_1_g_1"
      | G_sd5_sd5_bar_g_1_g_1 -> "G_sd5_sd5_bar_g_1_g_1"
      | G_sd3_bar_sd6_g_1_g_1 -> "G_sd3_bar_sd6_g_1_g_1"
      | G_sd6_sd6_bar_g_1_g_1 -> "G_sd6_sd6_bar_g_1_g_1"
      | G_su1_su1_bar_g_1_g_1 -> "G_su1_su1_bar_g_1_g_1"
      | G_su2_su2_bar_g_1_g_1 -> "G_su2_su2_bar_g_1_g_1"
      | G_su3_su3_bar_g_1_g_1 -> "G_su3_su3_bar_g_1_g_1"
      | G_su3_su6_bar_g_1_g_1 -> "G_su3_su6_bar_g_1_g_1"
      | G_su4_su4_bar_g_1_g_1 -> "G_su4_su4_bar_g_1_g_1"
      | G_su5_su5_bar_g_1_g_1 -> "G_su5_su5_bar_g_1_g_1"
      | G_su3_bar_su6_g_1_g_1 -> "G_su3_bar_su6_g_1_g_1"
      | G_su6_su6_bar_g_1_g_1 -> "G_su6_su6_bar_g_1_g_1"
      | G_sd1_sd1_bar_g_1_z_1 -> "G_sd1_sd1_bar_g_1_z_1"
      | G_sd2_sd2_bar_g_1_z_1 -> "G_sd2_sd2_bar_g_1_z_1"
      | G_sd3_sd3_bar_g_1_z_1 -> "G_sd3_sd3_bar_g_1_z_1"
      | G_sd3_sd6_bar_g_1_z_1 -> "G_sd3_sd6_bar_g_1_z_1"
      | G_sd4_sd4_bar_g_1_z_1 -> "G_sd4_sd4_bar_g_1_z_1"
      | G_sd5_sd5_bar_g_1_z_1 -> "G_sd5_sd5_bar_g_1_z_1"
      | G_sd3_bar_sd6_g_1_z_1 -> "G_sd3_bar_sd6_g_1_z_1"
      | G_sd6_sd6_bar_g_1_z_1 -> "G_sd6_sd6_bar_g_1_z_1"
      | G_sd1_su1_bar_g_1_w_plus -> "G_sd1_su1_bar_g_1_w_plus"
      | G_sd2_su2_bar_g_1_w_plus -> "G_sd2_su2_bar_g_1_w_plus"
      | G_sd3_su3_bar_g_1_w_plus -> "G_sd3_su3_bar_g_1_w_plus"
      | G_sd3_su6_bar_g_1_w_plus -> "G_sd3_su6_bar_g_1_w_plus"
      | G_sd6_su3_bar_g_1_w_plus -> "G_sd6_su3_bar_g_1_w_plus"
      | G_sd6_su6_bar_g_1_w_plus -> "G_sd6_su6_bar_g_1_w_plus"
      | G_sd1_bar_su1_g_1_w_minus -> "G_sd1_bar_su1_g_1_w_minus"
      | G_sd2_bar_su2_g_1_w_minus -> "G_sd2_bar_su2_g_1_w_minus"
      | G_sd3_bar_su3_g_1_w_minus -> "G_sd3_bar_su3_g_1_w_minus"
      | G_sd3_bar_su6_g_1_w_minus -> "G_sd3_bar_su6_g_1_w_minus"
      | G_sd6_bar_su3_g_1_w_minus -> "G_sd6_bar_su3_g_1_w_minus"
      | G_sd6_bar_su6_g_1_w_minus -> "G_sd6_bar_su6_g_1_w_minus"
      | G_su1_su1_bar_g_1_z_1 -> "G_su1_su1_bar_g_1_z_1"
      | G_su2_su2_bar_g_1_z_1 -> "G_su2_su2_bar_g_1_z_1"
      | G_su3_su3_bar_g_1_z_1 -> "G_su3_su3_bar_g_1_z_1"
      | G_su3_su6_bar_g_1_z_1 -> "G_su3_su6_bar_g_1_z_1"
      | G_su4_su4_bar_g_1_z_1 -> "G_su4_su4_bar_g_1_z_1"
      | G_su5_su5_bar_g_1_z_1 -> "G_su5_su5_bar_g_1_z_1"
      | G_su3_bar_su6_g_1_z_1 -> "G_su3_bar_su6_g_1_z_1"
      | G_su6_su6_bar_g_1_z_1 -> "G_su6_su6_bar_g_1_z_1"
      | G_sd1_sd1_bar_w_plus_w_minus -> "G_sd1_sd1_bar_w_plus_w_minus"
      | G_sd2_sd2_bar_w_plus_w_minus -> "G_sd2_sd2_bar_w_plus_w_minus"
      | G_sd3_sd3_bar_w_plus_w_minus -> "G_sd3_sd3_bar_w_plus_w_minus"
      | G_sd3_sd6_bar_w_plus_w_minus -> "G_sd3_sd6_bar_w_plus_w_minus"
      | G_sd3_bar_sd6_w_plus_w_minus -> "G_sd3_bar_sd6_w_plus_w_minus"
      | G_sd6_sd6_bar_w_plus_w_minus -> "G_sd6_sd6_bar_w_plus_w_minus"
      | G_sd1_sd1_bar_z_1_z_1 -> "G_sd1_sd1_bar_z_1_z_1"
      | G_sd2_sd2_bar_z_1_z_1 -> "G_sd2_sd2_bar_z_1_z_1"
      | G_sd3_sd3_bar_z_1_z_1 -> "G_sd3_sd3_bar_z_1_z_1"
      | G_sd3_sd6_bar_z_1_z_1 -> "G_sd3_sd6_bar_z_1_z_1"
      | G_sd4_sd4_bar_z_1_z_1 -> "G_sd4_sd4_bar_z_1_z_1"
      | G_sd5_sd5_bar_z_1_z_1 -> "G_sd5_sd5_bar_z_1_z_1"
      | G_sd3_bar_sd6_z_1_z_1 -> "G_sd3_bar_sd6_z_1_z_1"
      | G_sd6_sd6_bar_z_1_z_1 -> "G_sd6_sd6_bar_z_1_z_1"
      | G_sd1_su1_bar_w_plus_z_1 -> "G_sd1_su1_bar_w_plus_z_1"
      | G_sd2_su2_bar_w_plus_z_1 -> "G_sd2_su2_bar_w_plus_z_1"
      | G_sd3_su3_bar_w_plus_z_1 -> "G_sd3_su3_bar_w_plus_z_1"
      | G_sd3_su6_bar_w_plus_z_1 -> "G_sd3_su6_bar_w_plus_z_1"
      | G_sd6_su3_bar_w_plus_z_1 -> "G_sd6_su3_bar_w_plus_z_1"
      | G_sd6_su6_bar_w_plus_z_1 -> "G_sd6_su6_bar_w_plus_z_1"
      | G_sd1_bar_su1_w_minus_z_1 -> "G_sd1_bar_su1_w_minus_z_1"
      | G_sd2_bar_su2_w_minus_z_1 -> "G_sd2_bar_su2_w_minus_z_1"
      | G_sd3_bar_su3_w_minus_z_1 -> "G_sd3_bar_su3_w_minus_z_1"
      | G_sd3_bar_su6_w_minus_z_1 -> "G_sd3_bar_su6_w_minus_z_1"
      | G_sd6_bar_su3_w_minus_z_1 -> "G_sd6_bar_su3_w_minus_z_1"
      | G_sd6_bar_su6_w_minus_z_1 -> "G_sd6_bar_su6_w_minus_z_1"
      | G_sl1_minus_sl1_plus_w_plus_w_minus -> "G_sl1_minus_sl1_plus_w_plus_w_minus"
      | G_sl2_minus_sl2_plus_w_plus_w_minus -> "G_sl2_minus_sl2_plus_w_plus_w_minus"
      | G_sl3_minus_sl3_plus_w_plus_w_minus -> "G_sl3_minus_sl3_plus_w_plus_w_minus"
      | G_sl3_minus_sl6_plus_w_plus_w_minus -> "G_sl3_minus_sl6_plus_w_plus_w_minus"
      | G_sl3_plus_sl6_minus_w_plus_w_minus -> "G_sl3_plus_sl6_minus_w_plus_w_minus"
      | G_sl6_minus_sl6_plus_w_plus_w_minus -> "G_sl6_minus_sl6_plus_w_plus_w_minus"
      | G_sl1_minus_sl1_plus_z_1_z_1 -> "G_sl1_minus_sl1_plus_z_1_z_1"
      | G_sl2_minus_sl2_plus_z_1_z_1 -> "G_sl2_minus_sl2_plus_z_1_z_1"
      | G_sl3_minus_sl3_plus_z_1_z_1 -> "G_sl3_minus_sl3_plus_z_1_z_1"
      | G_sl3_minus_sl6_plus_z_1_z_1 -> "G_sl3_minus_sl6_plus_z_1_z_1"
      | G_sl4_minus_sl4_plus_z_1_z_1 -> "G_sl4_minus_sl4_plus_z_1_z_1"
      | G_sl5_minus_sl5_plus_z_1_z_1 -> "G_sl5_minus_sl5_plus_z_1_z_1"
      | G_sl3_plus_sl6_minus_z_1_z_1 -> "G_sl3_plus_sl6_minus_z_1_z_1"
      | G_sl6_minus_sl6_plus_z_1_z_1 -> "G_sl6_minus_sl6_plus_z_1_z_1"
      | G_sl1_minus_sv1_bar_w_plus_z_1 -> "G_sl1_minus_sv1_bar_w_plus_z_1"
      | G_sl2_minus_sv2_bar_w_plus_z_1 -> "G_sl2_minus_sv2_bar_w_plus_z_1"
      | G_sl3_minus_sv3_bar_w_plus_z_1 -> "G_sl3_minus_sv3_bar_w_plus_z_1"
      | G_sl6_minus_sv3_bar_w_plus_z_1 -> "G_sl6_minus_sv3_bar_w_plus_z_1"
      | G_sl1_plus_sv1_w_minus_z_1 -> "G_sl1_plus_sv1_w_minus_z_1"
      | G_sl2_plus_sv2_w_minus_z_1 -> "G_sl2_plus_sv2_w_minus_z_1"
      | G_sl3_plus_sv3_w_minus_z_1 -> "G_sl3_plus_sv3_w_minus_z_1"
      | G_sl6_plus_sv3_w_minus_z_1 -> "G_sl6_plus_sv3_w_minus_z_1"
      | G_sv1_sv1_bar_w_plus_w_minus -> "G_sv1_sv1_bar_w_plus_w_minus"
      | G_sv1_sv1_bar_z_1_z_1 -> "G_sv1_sv1_bar_z_1_z_1"
      | G_su1_su1_bar_w_plus_w_minus -> "G_su1_su1_bar_w_plus_w_minus"
      | G_su2_su2_bar_w_plus_w_minus -> "G_su2_su2_bar_w_plus_w_minus"
      | G_su3_su3_bar_w_plus_w_minus -> "G_su3_su3_bar_w_plus_w_minus"
      | G_su3_su6_bar_w_plus_w_minus -> "G_su3_su6_bar_w_plus_w_minus"
      | G_su3_bar_su6_w_plus_w_minus -> "G_su3_bar_su6_w_plus_w_minus"
      | G_su6_su6_bar_w_plus_w_minus -> "G_su6_su6_bar_w_plus_w_minus"
      | G_su1_su1_bar_z_1_z_1 -> "G_su1_su1_bar_z_1_z_1"
      | G_su2_su2_bar_z_1_z_1 -> "G_su2_su2_bar_z_1_z_1"
      | G_su3_su3_bar_z_1_z_1 -> "G_su3_su3_bar_z_1_z_1"
      | G_su3_su6_bar_z_1_z_1 -> "G_su3_su6_bar_z_1_z_1"
      | G_su4_su4_bar_z_1_z_1 -> "G_su4_su4_bar_z_1_z_1"
      | G_su5_su5_bar_z_1_z_1 -> "G_su5_su5_bar_z_1_z_1"
      | G_su3_bar_su6_z_1_z_1 -> "G_su3_bar_su6_z_1_z_1"
      | G_su6_su6_bar_z_1_z_1 -> "G_su6_su6_bar_z_1_z_1"

   (* Vertices and fusions *)

   let max_degree () = 4

   let vertices_3 = [
      (FRS (S1_H0 H01), FRS (S1_H0 H01), FRS (S2_H0_1 H02)),
       Scalar_Scalar_Scalar 1,
       G_h01_h01_h02
      ;
      (FRS (S2_H0_1 H02), FRS (S2_H0_1 H02), FRS (S2_H0_1 H02)),
       Scalar_Scalar_Scalar 1,
       G_h02_h02_h02
      ;
      (FRS (S1_H0 H01), FRS (S1_H0 H01), FRS (S1_H0 H01)),
       Scalar_Scalar_Scalar 1,
       G_h01_h01_h01
      ;
      (FRS (S1_H0 H01), FRS (S2_H0_1 H02), FRS (S2_H0_1 H02)),
       Scalar_Scalar_Scalar 1,
       G_h01_h02_h02
      ;
      (FRS (S3_A0 A0_1), FRS (S3_A0 A0_1), FRS (S2_H0_1 H02)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_a0_1_h02
      ;
      (FRS (S4_H H_plus), FRS (S2_H0_1 H02), FRS (S4_H H_minus)),
       Scalar_Scalar_Scalar 1,
       G_h_plus_h02_h_minus
      ;
      (FRS (S3_A0 A0_1), FRS (S3_A0 A0_1), FRS (S1_H0 H01)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_a0_1_h01
      ;
      (FRS (S4_H H_plus), FRS (S1_H0 H01), FRS (S4_H H_minus)),
       Scalar_Scalar_Scalar 1,
       G_h_plus_h01_h_minus
      ;
      (FRV (V1_A A_1), FRS (S4_H H_plus), FRS (S4_H H_minus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_h_plus_h_minus
      ;
      (FRS (S4_H H_minus), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar_Vector_Vector 1,
       G_h_minus_a_1_w_plus
      ;
      (FRV (V3_W W_plus), FRS (S3_A0 A0_1), FRS (S4_H H_minus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_a0_1_h_minus
      ;
      (FRV (V3_W W_plus), FRS (S1_H0 H01), FRS (S4_H H_minus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_h01_h_minus
      ;
      (FRV (V3_W W_plus), FRS (S2_H0_1 H02), FRS (S4_H H_minus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_h02_h_minus
      ;
      (FRV (V1_A A_1), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Gauge_Gauge_Gauge 1,
       G_a_1_w_plus_w_minus
      ;
      (FRS (S4_H H_plus), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar_Vector_Vector 1,
       G_h_minus_a_1_w_plus
      ;
      (FRV (V3_W W_minus), FRS (S3_A0 A0_1), FRS (S4_H H_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_a0_1_h_minus
      ;
      (FRV (V3_W W_minus), FRS (S4_H H_plus), FRS (S1_H0 H01)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_h01_h_minus
      ;
      (FRV (V3_W W_minus), FRS (S4_H H_plus), FRS (S2_H0_1 H02)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_h02_h_minus
      ;
      (FRS (S2_H0_1 H02), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar_Vector_Vector 1,
       G_h02_w_plus_w_minus
      ;
      (FRS (S1_H0 H01), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar_Vector_Vector 1,
       G_h01_w_plus_w_minus
      ;
      (FRV (V3_W W_plus), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Gauge_Gauge_Gauge 1,
       G_w_plus_w_minus_z_1
      ;
      (FRV (V2_Z Z_1), FRS (S3_A0 A0_1), FRS (S1_H0 H01)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_a0_1_h01
      ;
      (FRV (V2_Z Z_1), FRS (S4_H H_plus), FRS (S4_H H_minus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_h_plus_h_minus
      ;
      (FRV (V2_Z Z_1), FRS (S3_A0 A0_1), FRS (S2_H0_1 H02)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_a0_1_h02
      ;
      (FRS (S4_H H_minus), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar_Vector_Vector 1,
       G_h_minus_w_plus_z_1
      ;
      (FRS (S4_H H_plus), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar_Vector_Vector 1,
       G_h_minus_w_plus_z_1
      ;
      (FRS (S2_H0_1 H02), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar_Vector_Vector 1,
       G_h02_z_1_z_1
      ;
      (FRS (S1_H0 H01), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar_Vector_Vector 1,
       G_h01_z_1_z_1
      ;
      (FRF (F2_Ch X1_minus), FRV (V1_A A_1), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_x1_minus_a_1_x1_plus
      ;
      (FRF (F2_Ch X2_minus), FRV (V1_A A_1), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_x2_minus_a_1_x1_plus
      ;
      (FRF (F2_Ch X1_minus), FRV (V1_A A_1), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_x1_minus_a_1_x2_plus
      ;
      (FRF (F2_Ch X2_minus), FRV (V1_A A_1), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_x2_minus_a_1_x2_plus
      ;
      (FRF (F7_Dq D_bar), FRV (V1_A A_1), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_d_bar_a_1_d
      ;
      (FRF (F7_Dq S_bar), FRV (V1_A A_1), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_d_bar_a_1_d
      ;
      (FRF (F7_Dq B_bar), FRV (V1_A A_1), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_d_bar_a_1_d
      ;
      (FRF (F5_L E_plus), FRV (V1_A A_1), FRF (F5_L E_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_e_plus_a_1_e_minus
      ;
      (FRF (F5_L Mu_plus), FRV (V1_A A_1), FRF (F5_L Mu_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_e_plus_a_1_e_minus
      ;
      (FRF (F5_L Tau_plus), FRV (V1_A A_1), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_e_plus_a_1_e_minus
      ;
      (FRV (V1_A A_1), FRS (S10_Sd Sd1), FRS (S10_Sd Sd1_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd1_sd1_bar
      ;
      (FRV (V1_A A_1), FRS (S10_Sd Sd2), FRS (S10_Sd Sd2_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd2_sd2_bar
      ;
      (FRV (V1_A A_1), FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd3_sd3_bar
      ;
      (FRV (V1_A A_1), FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd3_sd6_bar
      ;
      (FRV (V1_A A_1), FRS (S10_Sd Sd4), FRS (S10_Sd Sd4_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd4_sd4_bar
      ;
      (FRV (V1_A A_1), FRS (S10_Sd Sd5), FRS (S10_Sd Sd5_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd5_sd5_bar
      ;
      (FRV (V1_A A_1), FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd3_bar_sd6
      ;
      (FRV (V1_A A_1), FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sd6_sd6_bar
      ;
      (FRV (V1_A A_1), FRS (S8_Sl Sl1_minus), FRS (S8_Sl Sl1_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sl1_minus_sl1_plus
      ;
      (FRV (V1_A A_1), FRS (S8_Sl Sl2_minus), FRS (S8_Sl Sl2_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sl2_minus_sl2_plus
      ;
      (FRV (V1_A A_1), FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl3_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sl3_minus_sl3_plus
      ;
      (FRV (V1_A A_1), FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl6_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sl3_minus_sl6_plus
      ;
      (FRV (V1_A A_1), FRS (S8_Sl Sl4_minus), FRS (S8_Sl Sl4_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sl4_minus_sl4_plus
      ;
      (FRV (V1_A A_1), FRS (S8_Sl Sl5_minus), FRS (S8_Sl Sl5_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sl5_minus_sl5_plus
      ;
      (FRV (V1_A A_1), FRS (S8_Sl Sl3_plus), FRS (S8_Sl Sl6_minus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sl3_plus_sl6_minus
      ;
      (FRV (V1_A A_1), FRS (S8_Sl Sl6_minus), FRS (S8_Sl Sl6_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_sl6_minus_sl6_plus
      ;
      (FRV (V1_A A_1), FRS (S9_Su Su1), FRS (S9_Su Su1_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su1_su1_bar
      ;
      (FRV (V1_A A_1), FRS (S9_Su Su2), FRS (S9_Su Su2_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su2_su2_bar
      ;
      (FRV (V1_A A_1), FRS (S9_Su Su3), FRS (S9_Su Su3_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su3_su3_bar
      ;
      (FRV (V1_A A_1), FRS (S9_Su Su3), FRS (S9_Su Su6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su3_su6_bar
      ;
      (FRV (V1_A A_1), FRS (S9_Su Su4), FRS (S9_Su Su4_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su4_su4_bar
      ;
      (FRV (V1_A A_1), FRS (S9_Su Su5), FRS (S9_Su Su5_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su5_su5_bar
      ;
      (FRV (V1_A A_1), FRS (S9_Su Su3_bar), FRS (S9_Su Su6)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su3_bar_su6
      ;
      (FRV (V1_A A_1), FRS (S9_Su Su6), FRS (S9_Su Su6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_a_1_su6_su6_bar
      ;
      (FRF (F6_Uq U_bar), FRV (V1_A A_1), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_u_bar_a_1_u
      ;
      (FRF (F6_Uq C_bar), FRV (V1_A A_1), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_u_bar_a_1_u
      ;
      (FRF (F6_Uq T_bar), FRV (V1_A A_1), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_u_bar_a_1_u
      ;
      (FRF (F2_Ch X1_minus), FRS (S3_A0 A0_1), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x1_minus_a0_1_x1_plus
      ;
      (FRF (F2_Ch X2_minus), FRS (S3_A0 A0_1), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x2_minus_a0_1_x1_plus
      ;
      (FRF (F2_Ch X1_minus), FRS (S3_A0 A0_1), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x1_minus_a0_1_x2_plus
      ;
      (FRF (F2_Ch X2_minus), FRS (S3_A0 A0_1), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x2_minus_a0_1_x2_plus
      ;
      (FRF (F7_Dq B_bar), FRS (S3_A0 A0_1), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_a0_1_b
      ;
      (FRF (F5_L Tau_plus), FRS (S3_A0 A0_1), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_tau_plus_a0_1_tau_minus
      ;
      (FRF (F1_Neu N1), FRS (S3_A0 A0_1), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_a0_1_n1
      ;
      (FRF (F1_Neu N1), FRS (S3_A0 A0_1), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_a0_1_n2
      ;
      (FRF (F1_Neu N1), FRS (S3_A0 A0_1), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_a0_1_n3
      ;
      (FRF (F1_Neu N1), FRS (S3_A0 A0_1), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_a0_1_n4
      ;
      (FRF (F1_Neu N2), FRS (S3_A0 A0_1), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_a0_1_n2
      ;
      (FRF (F1_Neu N2), FRS (S3_A0 A0_1), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_a0_1_n3
      ;
      (FRF (F1_Neu N2), FRS (S3_A0 A0_1), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_a0_1_n4
      ;
      (FRF (F1_Neu N3), FRS (S3_A0 A0_1), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_a0_1_n3
      ;
      (FRF (F1_Neu N3), FRS (S3_A0 A0_1), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_a0_1_n4
      ;
      (FRF (F1_Neu N4), FRS (S3_A0 A0_1), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_a0_1_n4
      ;
      (FRS (S3_A0 A0_1), FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_sd3_sd3_bar
      ;
      (FRS (S3_A0 A0_1), FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_sd3_sd6_bar
      ;
      (FRS (S3_A0 A0_1), FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_sd3_bar_sd6
      ;
      (FRS (S3_A0 A0_1), FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_sd6_sd6_bar
      ;
      (FRS (S3_A0 A0_1), FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl3_plus)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_sl3_minus_sl3_plus
      ;
      (FRS (S3_A0 A0_1), FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl6_plus)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_sl3_minus_sl6_plus
      ;
      (FRS (S3_A0 A0_1), FRS (S8_Sl Sl3_plus), FRS (S8_Sl Sl6_minus)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_sl3_plus_sl6_minus
      ;
      (FRS (S3_A0 A0_1), FRS (S8_Sl Sl6_minus), FRS (S8_Sl Sl6_plus)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_sl6_minus_sl6_plus
      ;
      (FRS (S3_A0 A0_1), FRS (S9_Su Su3), FRS (S9_Su Su3_bar)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_su3_su3_bar
      ;
      (FRS (S3_A0 A0_1), FRS (S9_Su Su3), FRS (S9_Su Su6_bar)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_su3_su6_bar
      ;
      (FRS (S3_A0 A0_1), FRS (S9_Su Su3_bar), FRS (S9_Su Su6)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_su3_bar_su6
      ;
      (FRS (S3_A0 A0_1), FRS (S9_Su Su6), FRS (S9_Su Su6_bar)),
       Scalar_Scalar_Scalar 1,
       G_a0_1_su6_su6_bar
      ;
      (FRF (F6_Uq T_bar), FRS (S3_A0 A0_1), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_a0_1_t
      ;
      (FRF (F2_Ch X1_minus), FRS (S1_H0 H01), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x1_minus_h01_x1_plus
      ;
      (FRF (F2_Ch X2_minus), FRS (S1_H0 H01), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x2_minus_h01_x1_plus
      ;
      (FRF (F2_Ch X1_minus), FRS (S1_H0 H01), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x1_minus_h01_x2_plus
      ;
      (FRF (F2_Ch X2_minus), FRS (S1_H0 H01), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x2_minus_h01_x2_plus
      ;
      (FRF (F2_Ch X1_minus), FRS (S2_H0_1 H02), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x1_minus_h02_x1_plus
      ;
      (FRF (F2_Ch X2_minus), FRS (S2_H0_1 H02), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x2_minus_h02_x1_plus
      ;
      (FRF (F2_Ch X1_minus), FRS (S2_H0_1 H02), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x1_minus_h02_x2_plus
      ;
      (FRF (F2_Ch X2_minus), FRS (S2_H0_1 H02), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x2_minus_h02_x2_plus
      ;
      (FRF (F2_Ch X1_minus), FRV (V2_Z Z_1), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_x1_minus_z_1_x1_plus
      ;
      (FRF (F2_Ch X2_minus), FRV (V2_Z Z_1), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_x2_minus_z_1_x1_plus
      ;
      (FRF (F2_Ch X1_minus), FRV (V2_Z Z_1), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_x1_minus_z_1_x2_plus
      ;
      (FRF (F2_Ch X2_minus), FRV (V2_Z Z_1), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_x2_minus_z_1_x2_plus
      ;
      (FRF (F2_Ch X1_plus), FRS (S9_Su Su1_bar), FRF (F7_Dq D)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SL, Coupling.Psi),
       G_x1_plus_su1_bar_d
      ;
      (FRF (F2_Ch X1_plus), FRS (S9_Su Su2_bar), FRF (F7_Dq S)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SL, Coupling.Psi),
       G_x1_plus_su2_bar_s
      ;
      (FRF (F7_Dq B), FRS (S9_Su Su3_bar), FRF (F2_Ch X1_plus)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_b_su3_bar_x1_plus
      ;
      (FRF (F7_Dq B), FRS (S9_Su Su6_bar), FRF (F2_Ch X1_plus)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_b_su6_bar_x1_plus
      ;
      (FRF (F2_Ch X2_plus), FRS (S9_Su Su1_bar), FRF (F7_Dq D)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SL, Coupling.Psi),
       G_x2_plus_su1_bar_d
      ;
      (FRF (F2_Ch X2_plus), FRS (S9_Su Su2_bar), FRF (F7_Dq S)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SL, Coupling.Psi),
       G_x2_plus_su2_bar_s
      ;
      (FRF (F7_Dq B), FRS (S9_Su Su3_bar), FRF (F2_Ch X2_plus)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_b_su3_bar_x2_plus
      ;
      (FRF (F7_Dq B), FRS (S9_Su Su6_bar), FRF (F2_Ch X2_plus)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_b_su6_bar_x2_plus
      ;
      (FRF (F1_Neu N1), FRS (S4_H H_minus), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h_minus_x1_plus
      ;
      (FRF (F1_Neu N2), FRS (S4_H H_minus), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h_minus_x1_plus
      ;
      (FRF (F1_Neu N3), FRS (S4_H H_minus), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_h_minus_x1_plus
      ;
      (FRF (F1_Neu N4), FRS (S4_H H_minus), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_h_minus_x1_plus
      ;
      (FRF (F1_Neu N1), FRS (S4_H H_minus), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h_minus_x2_plus
      ;
      (FRF (F1_Neu N2), FRS (S4_H H_minus), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h_minus_x2_plus
      ;
      (FRF (F1_Neu N3), FRS (S4_H H_minus), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_h_minus_x2_plus
      ;
      (FRF (F1_Neu N4), FRS (S4_H H_minus), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_h_minus_x2_plus
      ;
      (FRF (F2_Ch X1_plus), FRS (S7_Sn Sv1_bar), FRF (F5_L E_minus)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SL, Coupling.Psi),
       G_x1_plus_sv1_bar_e_minus
      ;
      (FRF (F2_Ch X1_plus), FRS (S7_Sn Sv2_bar), FRF (F5_L Mu_minus)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SL, Coupling.Psi),
       G_x1_plus_sv2_bar_mu_minus
      ;
      (FRF (F2_Ch X1_plus), FRS (S7_Sn Sv3_bar), FRF (F5_L Tau_minus)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_x1_plus_sv3_bar_tau_minus
      ;
      (FRF (F2_Ch X2_plus), FRS (S7_Sn Sv1_bar), FRF (F5_L E_minus)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SL, Coupling.Psi),
       G_x2_plus_sv1_bar_e_minus
      ;
      (FRF (F2_Ch X2_plus), FRS (S7_Sn Sv2_bar), FRF (F5_L Mu_minus)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SL, Coupling.Psi),
       G_x2_plus_sv2_bar_mu_minus
      ;
      (FRF (F2_Ch X2_plus), FRS (S7_Sn Sv3_bar), FRF (F5_L Tau_minus)),
       Coupling.PBP (1, Coupling.Psi, Coupling.SLR, Coupling.Psi),
       G_x2_plus_sv3_bar_tau_minus
      ;
      (FRF (F1_Neu N1), FRV (V3_W W_minus), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n1_w_minus_x1_plus
      ;
      (FRF (F1_Neu N2), FRV (V3_W W_minus), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n2_w_minus_x1_plus
      ;
      (FRF (F1_Neu N3), FRV (V3_W W_minus), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n3_w_minus_x1_plus
      ;
      (FRF (F1_Neu N4), FRV (V3_W W_minus), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n4_w_minus_x1_plus
      ;
      (FRF (F1_Neu N1), FRV (V3_W W_minus), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n1_w_minus_x2_plus
      ;
      (FRF (F1_Neu N2), FRV (V3_W W_minus), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n2_w_minus_x2_plus
      ;
      (FRF (F1_Neu N3), FRV (V3_W W_minus), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n3_w_minus_x2_plus
      ;
      (FRF (F1_Neu N4), FRV (V3_W W_minus), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Psi),
       G_n4_w_minus_x2_plus
      ;
      (FRF (F6_Uq U_bar), FRS (S10_Sd Sd1), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_u_bar_sd1_x1_plus
      ;
      (FRF (F6_Uq C_bar), FRS (S10_Sd Sd2), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_c_bar_sd2_x1_plus
      ;
      (FRF (F6_Uq T_bar), FRS (S10_Sd Sd3), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_sd3_x1_plus
      ;
      (FRF (F6_Uq T_bar), FRS (S10_Sd Sd6), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_sd6_x1_plus
      ;
      (FRF (F6_Uq U_bar), FRS (S10_Sd Sd1), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_u_bar_sd1_x2_plus
      ;
      (FRF (F6_Uq C_bar), FRS (S10_Sd Sd2), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_c_bar_sd2_x2_plus
      ;
      (FRF (F6_Uq T_bar), FRS (S10_Sd Sd3), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_sd3_x2_plus
      ;
      (FRF (F6_Uq T_bar), FRS (S10_Sd Sd6), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_sd6_x2_plus
      ;
      (FRF (F4_Vl Ve_bar), FRS (S8_Sl Sl1_minus), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_ve_bar_sl1_minus_x1_plus
      ;
      (FRF (F4_Vl Vm_bar), FRS (S8_Sl Sl2_minus), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vm_bar_sl2_minus_x1_plus
      ;
      (FRF (F4_Vl Vt_bar), FRS (S8_Sl Sl3_minus), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vt_bar_sl3_minus_x1_plus
      ;
      (FRF (F4_Vl Vt_bar), FRS (S8_Sl Sl6_minus), FRF (F2_Ch X1_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vt_bar_sl6_minus_x1_plus
      ;
      (FRF (F4_Vl Ve_bar), FRS (S8_Sl Sl1_minus), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_ve_bar_sl1_minus_x2_plus
      ;
      (FRF (F4_Vl Vm_bar), FRS (S8_Sl Sl2_minus), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vm_bar_sl2_minus_x2_plus
      ;
      (FRF (F4_Vl Vt_bar), FRS (S8_Sl Sl3_minus), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vt_bar_sl3_minus_x2_plus
      ;
      (FRF (F4_Vl Vt_bar), FRS (S8_Sl Sl6_minus), FRF (F2_Ch X2_plus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vt_bar_sl6_minus_x2_plus
      ;
      (FRF (F2_Ch X1_minus), FRS (S9_Su Su1), FRF (F7_Dq D_bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SR, Coupling.Psibar),
       G_x1_minus_su1_d_bar
      ;
      (FRF (F2_Ch X1_minus), FRS (S9_Su Su2), FRF (F7_Dq S_bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SR, Coupling.Psibar),
       G_x1_minus_su2_s_bar
      ;
      (FRF (F7_Dq B_bar), FRS (S9_Su Su3), FRF (F2_Ch X1_minus)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_b_bar_su3_x1_minus
      ;
      (FRF (F7_Dq B_bar), FRS (S9_Su Su6), FRF (F2_Ch X1_minus)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_b_bar_su6_x1_minus
      ;
      (FRF (F2_Ch X2_minus), FRS (S9_Su Su1), FRF (F7_Dq D_bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SR, Coupling.Psibar),
       G_x2_minus_su1_d_bar
      ;
      (FRF (F2_Ch X2_minus), FRS (S9_Su Su2), FRF (F7_Dq S_bar)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SR, Coupling.Psibar),
       G_x2_minus_su2_s_bar
      ;
      (FRF (F7_Dq B_bar), FRS (S9_Su Su3), FRF (F2_Ch X2_minus)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_b_bar_su3_x2_minus
      ;
      (FRF (F7_Dq B_bar), FRS (S9_Su Su6), FRF (F2_Ch X2_minus)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_b_bar_su6_x2_minus
      ;
      (FRF (F2_Ch X1_minus), FRS (S4_H H_plus), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x1_minus_h_plus_n1
      ;
      (FRF (F2_Ch X1_minus), FRS (S4_H H_plus), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x1_minus_h_plus_n2
      ;
      (FRF (F2_Ch X1_minus), FRS (S4_H H_plus), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x1_minus_h_plus_n3
      ;
      (FRF (F2_Ch X1_minus), FRS (S4_H H_plus), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x1_minus_h_plus_n4
      ;
      (FRF (F2_Ch X2_minus), FRS (S4_H H_plus), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x2_minus_h_plus_n1
      ;
      (FRF (F2_Ch X2_minus), FRS (S4_H H_plus), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x2_minus_h_plus_n2
      ;
      (FRF (F2_Ch X2_minus), FRS (S4_H H_plus), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x2_minus_h_plus_n3
      ;
      (FRF (F2_Ch X2_minus), FRS (S4_H H_plus), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x2_minus_h_plus_n4
      ;
      (FRF (F2_Ch X1_minus), FRS (S7_Sn Sv1), FRF (F5_L E_plus)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SR, Coupling.Psibar),
       G_x1_minus_sv1_e_plus
      ;
      (FRF (F2_Ch X1_minus), FRS (S7_Sn Sv2), FRF (F5_L Mu_plus)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SR, Coupling.Psibar),
       G_x1_minus_sv2_mu_plus
      ;
      (FRF (F2_Ch X1_minus), FRS (S7_Sn Sv3), FRF (F5_L Tau_plus)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_x1_minus_sv3_tau_plus
      ;
      (FRF (F2_Ch X2_minus), FRS (S7_Sn Sv1), FRF (F5_L E_plus)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SR, Coupling.Psibar),
       G_x2_minus_sv1_e_plus
      ;
      (FRF (F2_Ch X2_minus), FRS (S7_Sn Sv2), FRF (F5_L Mu_plus)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SR, Coupling.Psibar),
       G_x2_minus_sv2_mu_plus
      ;
      (FRF (F2_Ch X2_minus), FRS (S7_Sn Sv3), FRF (F5_L Tau_plus)),
       Coupling.BBB (1, Coupling.Psibar, Coupling.SLR, Coupling.Psibar),
       G_x2_minus_sv3_tau_plus
      ;
      (FRF (F2_Ch X1_minus), FRV (V3_W W_plus), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_x1_minus_w_plus_n1
      ;
      (FRF (F2_Ch X1_minus), FRV (V3_W W_plus), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_x1_minus_w_plus_n2
      ;
      (FRF (F2_Ch X1_minus), FRV (V3_W W_plus), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_x1_minus_w_plus_n3
      ;
      (FRF (F2_Ch X1_minus), FRV (V3_W W_plus), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_x1_minus_w_plus_n4
      ;
      (FRF (F2_Ch X2_minus), FRV (V3_W W_plus), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_x2_minus_w_plus_n1
      ;
      (FRF (F2_Ch X2_minus), FRV (V3_W W_plus), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_x2_minus_w_plus_n2
      ;
      (FRF (F2_Ch X2_minus), FRV (V3_W W_plus), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_x2_minus_w_plus_n3
      ;
      (FRF (F2_Ch X2_minus), FRV (V3_W W_plus), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Chi),
       G_x2_minus_w_plus_n4
      ;
      (FRF (F2_Ch X1_minus), FRS (S10_Sd Sd1_bar), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_x1_minus_sd1_bar_u
      ;
      (FRF (F2_Ch X1_minus), FRS (S10_Sd Sd2_bar), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_x1_minus_sd2_bar_c
      ;
      (FRF (F2_Ch X1_minus), FRS (S10_Sd Sd3_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x1_minus_sd3_bar_t
      ;
      (FRF (F2_Ch X1_minus), FRS (S10_Sd Sd6_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x1_minus_sd6_bar_t
      ;
      (FRF (F2_Ch X2_minus), FRS (S10_Sd Sd1_bar), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_x2_minus_sd1_bar_u
      ;
      (FRF (F2_Ch X2_minus), FRS (S10_Sd Sd2_bar), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_x2_minus_sd2_bar_c
      ;
      (FRF (F2_Ch X2_minus), FRS (S10_Sd Sd3_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x2_minus_sd3_bar_t
      ;
      (FRF (F2_Ch X2_minus), FRS (S10_Sd Sd6_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_x2_minus_sd6_bar_t
      ;
      (FRF (F2_Ch X1_minus), FRS (S8_Sl Sl1_plus), FRF (F4_Vl Ve)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_x1_minus_sl1_plus_ve
      ;
      (FRF (F2_Ch X1_minus), FRS (S8_Sl Sl2_plus), FRF (F4_Vl Vm)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_x1_minus_sl2_plus_vm
      ;
      (FRF (F2_Ch X1_minus), FRS (S8_Sl Sl3_plus), FRF (F4_Vl Vt)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_x1_minus_sl3_plus_vt
      ;
      (FRF (F2_Ch X1_minus), FRS (S8_Sl Sl6_plus), FRF (F4_Vl Vt)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_x1_minus_sl6_plus_vt
      ;
      (FRF (F2_Ch X2_minus), FRS (S8_Sl Sl1_plus), FRF (F4_Vl Ve)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_x2_minus_sl1_plus_ve
      ;
      (FRF (F2_Ch X2_minus), FRS (S8_Sl Sl2_plus), FRF (F4_Vl Vm)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_x2_minus_sl2_plus_vm
      ;
      (FRF (F2_Ch X2_minus), FRS (S8_Sl Sl3_plus), FRF (F4_Vl Vt)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_x2_minus_sl3_plus_vt
      ;
      (FRF (F2_Ch X2_minus), FRS (S8_Sl Sl6_plus), FRF (F4_Vl Vt)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_x2_minus_sl6_plus_vt
      ;
      (FRF (F7_Dq B_bar), FRS (S1_H0 H01), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_h01_b
      ;
      (FRF (F7_Dq B_bar), FRS (S2_H0_1 H02), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_h02_b
      ;
      (FRF (F7_Dq D_bar), FRV (V2_Z Z_1), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d_bar_z_1_d
      ;
      (FRF (F7_Dq S_bar), FRV (V2_Z Z_1), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d_bar_z_1_d
      ;
      (FRF (F7_Dq B_bar), FRV (V2_Z Z_1), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_d_bar_z_1_d
      ;
      (FRF (F6_Uq T_bar), FRS (S4_H H_plus), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_h_plus_b
      ;
      (FRF (F1_Neu N1), FRS (S10_Sd Sd1_bar), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n1_sd1_bar_d
      ;
      (FRF (F1_Neu N1), FRS (S10_Sd Sd4_bar), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sd4_bar_d
      ;
      (FRF (F1_Neu N2), FRS (S10_Sd Sd1_bar), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n2_sd1_bar_d
      ;
      (FRF (F1_Neu N2), FRS (S10_Sd Sd4_bar), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sd4_bar_d
      ;
      (FRF (F1_Neu N3), FRS (S10_Sd Sd1_bar), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n3_sd1_bar_d
      ;
      (FRF (F1_Neu N3), FRS (S10_Sd Sd4_bar), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sd4_bar_d
      ;
      (FRF (F1_Neu N4), FRS (S10_Sd Sd1_bar), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n4_sd1_bar_d
      ;
      (FRF (F1_Neu N4), FRS (S10_Sd Sd4_bar), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sd4_bar_d
      ;
      (FRF (F1_Neu N1), FRS (S10_Sd Sd2_bar), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n1_sd2_bar_s
      ;
      (FRF (F1_Neu N1), FRS (S10_Sd Sd5_bar), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sd5_bar_s
      ;
      (FRF (F1_Neu N2), FRS (S10_Sd Sd2_bar), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n2_sd2_bar_s
      ;
      (FRF (F1_Neu N2), FRS (S10_Sd Sd5_bar), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sd5_bar_s
      ;
      (FRF (F1_Neu N3), FRS (S10_Sd Sd2_bar), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n3_sd2_bar_s
      ;
      (FRF (F1_Neu N3), FRS (S10_Sd Sd5_bar), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sd5_bar_s
      ;
      (FRF (F1_Neu N4), FRS (S10_Sd Sd2_bar), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n4_sd2_bar_s
      ;
      (FRF (F1_Neu N4), FRS (S10_Sd Sd5_bar), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sd5_bar_s
      ;
      (FRF (F1_Neu N1), FRS (S10_Sd Sd3_bar), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd3_bar_b
      ;
      (FRF (F1_Neu N1), FRS (S10_Sd Sd6_bar), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sd6_bar_b
      ;
      (FRF (F1_Neu N2), FRS (S10_Sd Sd3_bar), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd3_bar_b
      ;
      (FRF (F1_Neu N2), FRS (S10_Sd Sd6_bar), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sd6_bar_b
      ;
      (FRF (F1_Neu N3), FRS (S10_Sd Sd3_bar), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd3_bar_b
      ;
      (FRF (F1_Neu N3), FRS (S10_Sd Sd6_bar), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sd6_bar_b
      ;
      (FRF (F1_Neu N4), FRS (S10_Sd Sd3_bar), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd3_bar_b
      ;
      (FRF (F1_Neu N4), FRS (S10_Sd Sd6_bar), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sd6_bar_b
      ;
      (FRF (F6_Uq U_bar), FRV (V3_W W_plus), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_u_bar_w_plus_d
      ;
      (FRF (F6_Uq C_bar), FRV (V3_W W_plus), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_c_bar_w_plus_s
      ;
      (FRF (F6_Uq T_bar), FRV (V3_W W_plus), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_t_bar_w_plus_b
      ;
      (FRF (F7_Dq B_bar), FRS (S4_H H_minus), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_h_minus_t
      ;
      (FRF (F7_Dq D_bar), FRS (S10_Sd Sd1), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_d_bar_sd1_n1
      ;
      (FRF (F7_Dq D_bar), FRS (S10_Sd Sd4), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_d_bar_sd4_n1
      ;
      (FRF (F7_Dq D_bar), FRS (S10_Sd Sd1), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_d_bar_sd1_n2
      ;
      (FRF (F7_Dq D_bar), FRS (S10_Sd Sd4), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_d_bar_sd4_n2
      ;
      (FRF (F7_Dq D_bar), FRS (S10_Sd Sd1), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_d_bar_sd1_n3
      ;
      (FRF (F7_Dq D_bar), FRS (S10_Sd Sd4), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_d_bar_sd4_n3
      ;
      (FRF (F7_Dq D_bar), FRS (S10_Sd Sd1), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_d_bar_sd1_n4
      ;
      (FRF (F7_Dq D_bar), FRS (S10_Sd Sd4), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_d_bar_sd4_n4
      ;
      (FRF (F7_Dq S_bar), FRS (S10_Sd Sd2), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_s_bar_sd2_n1
      ;
      (FRF (F7_Dq S_bar), FRS (S10_Sd Sd5), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_s_bar_sd5_n1
      ;
      (FRF (F7_Dq S_bar), FRS (S10_Sd Sd2), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_s_bar_sd2_n2
      ;
      (FRF (F7_Dq S_bar), FRS (S10_Sd Sd5), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_s_bar_sd5_n2
      ;
      (FRF (F7_Dq S_bar), FRS (S10_Sd Sd2), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_s_bar_sd2_n3
      ;
      (FRF (F7_Dq S_bar), FRS (S10_Sd Sd5), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_s_bar_sd5_n3
      ;
      (FRF (F7_Dq S_bar), FRS (S10_Sd Sd2), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_s_bar_sd2_n4
      ;
      (FRF (F7_Dq S_bar), FRS (S10_Sd Sd5), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_s_bar_sd5_n4
      ;
      (FRF (F7_Dq B_bar), FRS (S10_Sd Sd3), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_sd3_n1
      ;
      (FRF (F7_Dq B_bar), FRS (S10_Sd Sd6), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_sd6_n1
      ;
      (FRF (F7_Dq B_bar), FRS (S10_Sd Sd3), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_sd3_n2
      ;
      (FRF (F7_Dq B_bar), FRS (S10_Sd Sd6), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_sd6_n2
      ;
      (FRF (F7_Dq B_bar), FRS (S10_Sd Sd3), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_sd3_n3
      ;
      (FRF (F7_Dq B_bar), FRS (S10_Sd Sd6), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_sd6_n3
      ;
      (FRF (F7_Dq B_bar), FRS (S10_Sd Sd3), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_sd3_n4
      ;
      (FRF (F7_Dq B_bar), FRS (S10_Sd Sd6), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_sd6_n4
      ;
      (FRF (F7_Dq D_bar), FRV (V3_W W_minus), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_d_bar_w_minus_u
      ;
      (FRF (F7_Dq S_bar), FRV (V3_W W_minus), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_s_bar_w_minus_c
      ;
      (FRF (F7_Dq B_bar), FRV (V3_W W_minus), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_b_bar_w_minus_t
      ;
      (FRF (F4_Vl Vt_bar), FRS (S4_H H_plus), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vt_bar_h_plus_tau_minus
      ;
      (FRS (S4_H H_plus), FRS (S10_Sd Sd1), FRS (S9_Su Su1_bar)),
       Scalar_Scalar_Scalar 1,
       G_h_plus_sd1_su1_bar
      ;
      (FRS (S4_H H_plus), FRS (S10_Sd Sd2), FRS (S9_Su Su2_bar)),
       Scalar_Scalar_Scalar 1,
       G_h_plus_sd2_su2_bar
      ;
      (FRS (S4_H H_plus), FRS (S10_Sd Sd3), FRS (S9_Su Su3_bar)),
       Scalar_Scalar_Scalar 1,
       G_h_plus_sd3_su3_bar
      ;
      (FRS (S4_H H_plus), FRS (S10_Sd Sd3), FRS (S9_Su Su6_bar)),
       Scalar_Scalar_Scalar 1,
       G_h_plus_sd3_su6_bar
      ;
      (FRS (S4_H H_plus), FRS (S10_Sd Sd6), FRS (S9_Su Su3_bar)),
       Scalar_Scalar_Scalar 1,
       G_h_plus_sd6_su3_bar
      ;
      (FRS (S4_H H_plus), FRS (S10_Sd Sd6), FRS (S9_Su Su6_bar)),
       Scalar_Scalar_Scalar 1,
       G_h_plus_sd6_su6_bar
      ;
      (FRS (S4_H H_plus), FRS (S8_Sl Sl1_minus), FRS (S7_Sn Sv1_bar)),
       Scalar_Scalar_Scalar 1,
       G_h_plus_sl1_minus_sv1_bar
      ;
      (FRS (S4_H H_plus), FRS (S8_Sl Sl2_minus), FRS (S7_Sn Sv2_bar)),
       Scalar_Scalar_Scalar 1,
       G_h_plus_sl2_minus_sv2_bar
      ;
      (FRS (S4_H H_plus), FRS (S8_Sl Sl3_minus), FRS (S7_Sn Sv3_bar)),
       Scalar_Scalar_Scalar 1,
       G_h_plus_sl3_minus_sv3_bar
      ;
      (FRS (S4_H H_plus), FRS (S8_Sl Sl6_minus), FRS (S7_Sn Sv3_bar)),
       Scalar_Scalar_Scalar 1,
       G_h_plus_sl6_minus_sv3_bar
      ;
      (FRF (F5_L Tau_plus), FRS (S1_H0 H01), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_tau_plus_h01_tau_minus
      ;
      (FRF (F1_Neu N1), FRS (S1_H0 H01), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h01_n1
      ;
      (FRF (F1_Neu N1), FRS (S1_H0 H01), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h01_n2
      ;
      (FRF (F1_Neu N1), FRS (S1_H0 H01), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h01_n3
      ;
      (FRF (F1_Neu N1), FRS (S1_H0 H01), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h01_n4
      ;
      (FRF (F1_Neu N2), FRS (S1_H0 H01), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h01_n2
      ;
      (FRF (F1_Neu N2), FRS (S1_H0 H01), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h01_n3
      ;
      (FRF (F1_Neu N2), FRS (S1_H0 H01), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h01_n4
      ;
      (FRF (F1_Neu N3), FRS (S1_H0 H01), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_h01_n3
      ;
      (FRF (F1_Neu N3), FRS (S1_H0 H01), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_h01_n4
      ;
      (FRF (F1_Neu N4), FRS (S1_H0 H01), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_h01_n4
      ;
      (FRS (S1_H0 H01), FRS (S10_Sd Sd1), FRS (S10_Sd Sd1_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_sd1_sd1_bar
      ;
      (FRS (S1_H0 H01), FRS (S10_Sd Sd2), FRS (S10_Sd Sd2_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_sd2_sd2_bar
      ;
      (FRS (S1_H0 H01), FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_sd3_sd3_bar
      ;
      (FRS (S1_H0 H01), FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_sd3_sd6_bar
      ;
      (FRS (S1_H0 H01), FRS (S10_Sd Sd4), FRS (S10_Sd Sd4_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_sd4_sd4_bar
      ;
      (FRS (S1_H0 H01), FRS (S10_Sd Sd5), FRS (S10_Sd Sd5_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_sd5_sd5_bar
      ;
      (FRS (S1_H0 H01), FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6)),
       Scalar_Scalar_Scalar 1,
       G_h01_sd3_bar_sd6
      ;
      (FRS (S1_H0 H01), FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_sd6_sd6_bar
      ;
      (FRS (S1_H0 H01), FRS (S8_Sl Sl1_minus), FRS (S8_Sl Sl1_plus)),
       Scalar_Scalar_Scalar 1,
       G_h01_sl1_minus_sl1_plus
      ;
      (FRS (S1_H0 H01), FRS (S8_Sl Sl2_minus), FRS (S8_Sl Sl2_plus)),
       Scalar_Scalar_Scalar 1,
       G_h01_sl2_minus_sl2_plus
      ;
      (FRS (S1_H0 H01), FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl3_plus)),
       Scalar_Scalar_Scalar 1,
       G_h01_sl3_minus_sl3_plus
      ;
      (FRS (S1_H0 H01), FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl6_plus)),
       Scalar_Scalar_Scalar 1,
       G_h01_sl3_minus_sl6_plus
      ;
      (FRS (S1_H0 H01), FRS (S8_Sl Sl4_minus), FRS (S8_Sl Sl4_plus)),
       Scalar_Scalar_Scalar 1,
       G_h01_sl4_minus_sl4_plus
      ;
      (FRS (S1_H0 H01), FRS (S8_Sl Sl5_minus), FRS (S8_Sl Sl5_plus)),
       Scalar_Scalar_Scalar 1,
       G_h01_sl5_minus_sl5_plus
      ;
      (FRS (S1_H0 H01), FRS (S8_Sl Sl3_plus), FRS (S8_Sl Sl6_minus)),
       Scalar_Scalar_Scalar 1,
       G_h01_sl3_plus_sl6_minus
      ;
      (FRS (S1_H0 H01), FRS (S8_Sl Sl6_minus), FRS (S8_Sl Sl6_plus)),
       Scalar_Scalar_Scalar 1,
       G_h01_sl6_minus_sl6_plus
      ;
      (FRS (S1_H0 H01), FRS (S7_Sn Sv1), FRS (S7_Sn Sv1_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_sv1_sv1_bar
      ;
      (FRS (S1_H0 H01), FRS (S7_Sn Sv2), FRS (S7_Sn Sv2_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_sv1_sv1_bar
      ;
      (FRS (S1_H0 H01), FRS (S7_Sn Sv3), FRS (S7_Sn Sv3_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_sv1_sv1_bar
      ;
      (FRS (S1_H0 H01), FRS (S9_Su Su1), FRS (S9_Su Su1_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_su1_su1_bar
      ;
      (FRS (S1_H0 H01), FRS (S9_Su Su2), FRS (S9_Su Su2_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_su2_su2_bar
      ;
      (FRS (S1_H0 H01), FRS (S9_Su Su3), FRS (S9_Su Su3_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_su3_su3_bar
      ;
      (FRS (S1_H0 H01), FRS (S9_Su Su3), FRS (S9_Su Su6_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_su3_su6_bar
      ;
      (FRS (S1_H0 H01), FRS (S9_Su Su4), FRS (S9_Su Su4_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_su4_su4_bar
      ;
      (FRS (S1_H0 H01), FRS (S9_Su Su5), FRS (S9_Su Su5_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_su5_su5_bar
      ;
      (FRS (S1_H0 H01), FRS (S9_Su Su3_bar), FRS (S9_Su Su6)),
       Scalar_Scalar_Scalar 1,
       G_h01_su3_bar_su6
      ;
      (FRS (S1_H0 H01), FRS (S9_Su Su6), FRS (S9_Su Su6_bar)),
       Scalar_Scalar_Scalar 1,
       G_h01_su6_su6_bar
      ;
      (FRF (F6_Uq T_bar), FRS (S1_H0 H01), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_h01_t
      ;
      (FRF (F5_L Tau_plus), FRS (S2_H0_1 H02), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_tau_plus_h02_tau_minus
      ;
      (FRF (F1_Neu N1), FRS (S2_H0_1 H02), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h02_n1
      ;
      (FRF (F1_Neu N1), FRS (S2_H0_1 H02), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h02_n2
      ;
      (FRF (F1_Neu N1), FRS (S2_H0_1 H02), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h02_n3
      ;
      (FRF (F1_Neu N1), FRS (S2_H0_1 H02), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_h02_n4
      ;
      (FRF (F1_Neu N2), FRS (S2_H0_1 H02), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h02_n2
      ;
      (FRF (F1_Neu N2), FRS (S2_H0_1 H02), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h02_n3
      ;
      (FRF (F1_Neu N2), FRS (S2_H0_1 H02), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_h02_n4
      ;
      (FRF (F1_Neu N3), FRS (S2_H0_1 H02), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_h02_n3
      ;
      (FRF (F1_Neu N3), FRS (S2_H0_1 H02), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_h02_n4
      ;
      (FRF (F1_Neu N4), FRS (S2_H0_1 H02), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_h02_n4
      ;
      (FRS (S2_H0_1 H02), FRS (S10_Sd Sd1), FRS (S10_Sd Sd1_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_sd1_sd1_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S10_Sd Sd2), FRS (S10_Sd Sd2_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_sd2_sd2_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_sd3_sd3_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_sd3_sd6_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S10_Sd Sd4), FRS (S10_Sd Sd4_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_sd4_sd4_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S10_Sd Sd5), FRS (S10_Sd Sd5_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_sd5_sd5_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6)),
       Scalar_Scalar_Scalar 1,
       G_h02_sd3_bar_sd6
      ;
      (FRS (S2_H0_1 H02), FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_sd6_sd6_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S8_Sl Sl1_minus), FRS (S8_Sl Sl1_plus)),
       Scalar_Scalar_Scalar 1,
       G_h02_sl1_minus_sl1_plus
      ;
      (FRS (S2_H0_1 H02), FRS (S8_Sl Sl2_minus), FRS (S8_Sl Sl2_plus)),
       Scalar_Scalar_Scalar 1,
       G_h02_sl2_minus_sl2_plus
      ;
      (FRS (S2_H0_1 H02), FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl3_plus)),
       Scalar_Scalar_Scalar 1,
       G_h02_sl3_minus_sl3_plus
      ;
      (FRS (S2_H0_1 H02), FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl6_plus)),
       Scalar_Scalar_Scalar 1,
       G_h02_sl3_minus_sl6_plus
      ;
      (FRS (S2_H0_1 H02), FRS (S8_Sl Sl4_minus), FRS (S8_Sl Sl4_plus)),
       Scalar_Scalar_Scalar 1,
       G_h02_sl4_minus_sl4_plus
      ;
      (FRS (S2_H0_1 H02), FRS (S8_Sl Sl5_minus), FRS (S8_Sl Sl5_plus)),
       Scalar_Scalar_Scalar 1,
       G_h02_sl5_minus_sl5_plus
      ;
      (FRS (S2_H0_1 H02), FRS (S8_Sl Sl3_plus), FRS (S8_Sl Sl6_minus)),
       Scalar_Scalar_Scalar 1,
       G_h02_sl3_plus_sl6_minus
      ;
      (FRS (S2_H0_1 H02), FRS (S8_Sl Sl6_minus), FRS (S8_Sl Sl6_plus)),
       Scalar_Scalar_Scalar 1,
       G_h02_sl6_minus_sl6_plus
      ;
      (FRS (S2_H0_1 H02), FRS (S7_Sn Sv1), FRS (S7_Sn Sv1_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_sv1_sv1_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S7_Sn Sv2), FRS (S7_Sn Sv2_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_sv1_sv1_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S7_Sn Sv3), FRS (S7_Sn Sv3_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_sv1_sv1_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S9_Su Su1), FRS (S9_Su Su1_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_su1_su1_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S9_Su Su2), FRS (S9_Su Su2_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_su2_su2_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S9_Su Su3), FRS (S9_Su Su3_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_su3_su3_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S9_Su Su3), FRS (S9_Su Su6_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_su3_su6_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S9_Su Su4), FRS (S9_Su Su4_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_su4_su4_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S9_Su Su5), FRS (S9_Su Su5_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_su5_su5_bar
      ;
      (FRS (S2_H0_1 H02), FRS (S9_Su Su3_bar), FRS (S9_Su Su6)),
       Scalar_Scalar_Scalar 1,
       G_h02_su3_bar_su6
      ;
      (FRS (S2_H0_1 H02), FRS (S9_Su Su6), FRS (S9_Su Su6_bar)),
       Scalar_Scalar_Scalar 1,
       G_h02_su6_su6_bar
      ;
      (FRF (F6_Uq T_bar), FRS (S2_H0_1 H02), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_h02_t
      ;
      (FRF (F5_L Tau_plus), FRS (S4_H H_minus), FRF (F4_Vl Vt)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_tau_plus_h_minus_vt
      ;
      (FRS (S4_H H_minus), FRS (S10_Sd Sd1_bar), FRS (S9_Su Su1)),
       Scalar_Scalar_Scalar 1,
       G_h_minus_sd1_bar_su1
      ;
      (FRS (S4_H H_minus), FRS (S10_Sd Sd2_bar), FRS (S9_Su Su2)),
       Scalar_Scalar_Scalar 1,
       G_h_minus_sd2_bar_su2
      ;
      (FRS (S4_H H_minus), FRS (S10_Sd Sd3_bar), FRS (S9_Su Su3)),
       Scalar_Scalar_Scalar 1,
       G_h_minus_sd3_bar_su3
      ;
      (FRS (S4_H H_minus), FRS (S10_Sd Sd3_bar), FRS (S9_Su Su6)),
       Scalar_Scalar_Scalar 1,
       G_h_minus_sd3_bar_su6
      ;
      (FRS (S4_H H_minus), FRS (S10_Sd Sd6_bar), FRS (S9_Su Su3)),
       Scalar_Scalar_Scalar 1,
       G_h_minus_sd6_bar_su3
      ;
      (FRS (S4_H H_minus), FRS (S10_Sd Sd6_bar), FRS (S9_Su Su6)),
       Scalar_Scalar_Scalar 1,
       G_h_minus_sd6_bar_su6
      ;
      (FRS (S4_H H_minus), FRS (S8_Sl Sl1_plus), FRS (S7_Sn Sv1)),
       Scalar_Scalar_Scalar 1,
       G_h_minus_sl1_plus_sv1
      ;
      (FRS (S4_H H_minus), FRS (S8_Sl Sl2_plus), FRS (S7_Sn Sv2)),
       Scalar_Scalar_Scalar 1,
       G_h_minus_sl2_plus_sv2
      ;
      (FRS (S4_H H_minus), FRS (S8_Sl Sl3_plus), FRS (S7_Sn Sv3)),
       Scalar_Scalar_Scalar 1,
       G_h_minus_sl3_plus_sv3
      ;
      (FRS (S4_H H_minus), FRS (S8_Sl Sl6_plus), FRS (S7_Sn Sv3)),
       Scalar_Scalar_Scalar 1,
       G_h_minus_sl6_plus_sv3
      ;
      (FRF (F5_L E_plus), FRV (V2_Z Z_1), FRF (F5_L E_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e_plus_z_1_e_minus
      ;
      (FRF (F5_L Mu_plus), FRV (V2_Z Z_1), FRF (F5_L Mu_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e_plus_z_1_e_minus
      ;
      (FRF (F5_L Tau_plus), FRV (V2_Z Z_1), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_e_plus_z_1_e_minus
      ;
      (FRF (F1_Neu N1), FRS (S8_Sl Sl1_plus), FRF (F5_L E_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n1_sl1_plus_e_minus
      ;
      (FRF (F1_Neu N1), FRS (S8_Sl Sl4_plus), FRF (F5_L E_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sl4_plus_e_minus
      ;
      (FRF (F1_Neu N2), FRS (S8_Sl Sl1_plus), FRF (F5_L E_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n2_sl1_plus_e_minus
      ;
      (FRF (F1_Neu N2), FRS (S8_Sl Sl4_plus), FRF (F5_L E_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sl4_plus_e_minus
      ;
      (FRF (F1_Neu N3), FRS (S8_Sl Sl1_plus), FRF (F5_L E_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n3_sl1_plus_e_minus
      ;
      (FRF (F1_Neu N3), FRS (S8_Sl Sl4_plus), FRF (F5_L E_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sl4_plus_e_minus
      ;
      (FRF (F1_Neu N4), FRS (S8_Sl Sl1_plus), FRF (F5_L E_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n4_sl1_plus_e_minus
      ;
      (FRF (F1_Neu N4), FRS (S8_Sl Sl4_plus), FRF (F5_L E_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sl4_plus_e_minus
      ;
      (FRF (F1_Neu N1), FRS (S8_Sl Sl2_plus), FRF (F5_L Mu_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n1_sl2_plus_mu_minus
      ;
      (FRF (F1_Neu N1), FRS (S8_Sl Sl5_plus), FRF (F5_L Mu_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_sl5_plus_mu_minus
      ;
      (FRF (F1_Neu N2), FRS (S8_Sl Sl2_plus), FRF (F5_L Mu_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n2_sl2_plus_mu_minus
      ;
      (FRF (F1_Neu N2), FRS (S8_Sl Sl5_plus), FRF (F5_L Mu_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_sl5_plus_mu_minus
      ;
      (FRF (F1_Neu N3), FRS (S8_Sl Sl2_plus), FRF (F5_L Mu_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n3_sl2_plus_mu_minus
      ;
      (FRF (F1_Neu N3), FRS (S8_Sl Sl5_plus), FRF (F5_L Mu_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_sl5_plus_mu_minus
      ;
      (FRF (F1_Neu N4), FRS (S8_Sl Sl2_plus), FRF (F5_L Mu_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n4_sl2_plus_mu_minus
      ;
      (FRF (F1_Neu N4), FRS (S8_Sl Sl5_plus), FRF (F5_L Mu_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_sl5_plus_mu_minus
      ;
      (FRF (F1_Neu N1), FRS (S8_Sl Sl3_plus), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sl3_plus_tau_minus
      ;
      (FRF (F1_Neu N1), FRS (S8_Sl Sl6_plus), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_sl6_plus_tau_minus
      ;
      (FRF (F1_Neu N2), FRS (S8_Sl Sl3_plus), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sl3_plus_tau_minus
      ;
      (FRF (F1_Neu N2), FRS (S8_Sl Sl6_plus), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_sl6_plus_tau_minus
      ;
      (FRF (F1_Neu N3), FRS (S8_Sl Sl3_plus), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sl3_plus_tau_minus
      ;
      (FRF (F1_Neu N3), FRS (S8_Sl Sl6_plus), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_sl6_plus_tau_minus
      ;
      (FRF (F1_Neu N4), FRS (S8_Sl Sl3_plus), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sl3_plus_tau_minus
      ;
      (FRF (F1_Neu N4), FRS (S8_Sl Sl6_plus), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_sl6_plus_tau_minus
      ;
      (FRF (F4_Vl Ve_bar), FRV (V3_W W_plus), FRF (F5_L E_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_ve_bar_w_plus_e_minus
      ;
      (FRF (F4_Vl Vm_bar), FRV (V3_W W_plus), FRF (F5_L Mu_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_ve_bar_w_plus_e_minus
      ;
      (FRF (F4_Vl Vt_bar), FRV (V3_W W_plus), FRF (F5_L Tau_minus)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_ve_bar_w_plus_e_minus
      ;
      (FRF (F5_L E_plus), FRS (S8_Sl Sl1_minus), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e_plus_sl1_minus_n1
      ;
      (FRF (F5_L E_plus), FRS (S8_Sl Sl4_minus), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_e_plus_sl4_minus_n1
      ;
      (FRF (F5_L E_plus), FRS (S8_Sl Sl1_minus), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e_plus_sl1_minus_n2
      ;
      (FRF (F5_L E_plus), FRS (S8_Sl Sl4_minus), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_e_plus_sl4_minus_n2
      ;
      (FRF (F5_L E_plus), FRS (S8_Sl Sl1_minus), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e_plus_sl1_minus_n3
      ;
      (FRF (F5_L E_plus), FRS (S8_Sl Sl4_minus), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_e_plus_sl4_minus_n3
      ;
      (FRF (F5_L E_plus), FRS (S8_Sl Sl1_minus), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_e_plus_sl1_minus_n4
      ;
      (FRF (F5_L E_plus), FRS (S8_Sl Sl4_minus), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_e_plus_sl4_minus_n4
      ;
      (FRF (F5_L Mu_plus), FRS (S8_Sl Sl2_minus), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_mu_plus_sl2_minus_n1
      ;
      (FRF (F5_L Mu_plus), FRS (S8_Sl Sl5_minus), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_mu_plus_sl5_minus_n1
      ;
      (FRF (F5_L Mu_plus), FRS (S8_Sl Sl2_minus), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_mu_plus_sl2_minus_n2
      ;
      (FRF (F5_L Mu_plus), FRS (S8_Sl Sl5_minus), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_mu_plus_sl5_minus_n2
      ;
      (FRF (F5_L Mu_plus), FRS (S8_Sl Sl2_minus), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_mu_plus_sl2_minus_n3
      ;
      (FRF (F5_L Mu_plus), FRS (S8_Sl Sl5_minus), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_mu_plus_sl5_minus_n3
      ;
      (FRF (F5_L Mu_plus), FRS (S8_Sl Sl2_minus), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_mu_plus_sl2_minus_n4
      ;
      (FRF (F5_L Mu_plus), FRS (S8_Sl Sl5_minus), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_mu_plus_sl5_minus_n4
      ;
      (FRF (F5_L Tau_plus), FRS (S8_Sl Sl3_minus), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_tau_plus_sl3_minus_n1
      ;
      (FRF (F5_L Tau_plus), FRS (S8_Sl Sl6_minus), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_tau_plus_sl6_minus_n1
      ;
      (FRF (F5_L Tau_plus), FRS (S8_Sl Sl3_minus), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_tau_plus_sl3_minus_n2
      ;
      (FRF (F5_L Tau_plus), FRS (S8_Sl Sl6_minus), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_tau_plus_sl6_minus_n2
      ;
      (FRF (F5_L Tau_plus), FRS (S8_Sl Sl3_minus), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_tau_plus_sl3_minus_n3
      ;
      (FRF (F5_L Tau_plus), FRS (S8_Sl Sl6_minus), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_tau_plus_sl6_minus_n3
      ;
      (FRF (F5_L Tau_plus), FRS (S8_Sl Sl3_minus), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_tau_plus_sl3_minus_n4
      ;
      (FRF (F5_L Tau_plus), FRS (S8_Sl Sl6_minus), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_tau_plus_sl6_minus_n4
      ;
      (FRF (F5_L E_plus), FRV (V3_W W_minus), FRF (F4_Vl Ve)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_ve_bar_w_plus_e_minus
      ;
      (FRF (F5_L Mu_plus), FRV (V3_W W_minus), FRF (F4_Vl Vm)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_ve_bar_w_plus_e_minus
      ;
      (FRF (F5_L Tau_plus), FRV (V3_W W_minus), FRF (F4_Vl Vt)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_ve_bar_w_plus_e_minus
      ;
      (FRF (F1_Neu N1), FRV (V2_Z Z_1), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n1_z_1_n1
      ;
      (FRF (F1_Neu N1), FRV (V2_Z Z_1), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n1_z_1_n2
      ;
      (FRF (F1_Neu N1), FRV (V2_Z Z_1), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n1_z_1_n3
      ;
      (FRF (F1_Neu N1), FRV (V2_Z Z_1), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n1_z_1_n4
      ;
      (FRF (F1_Neu N2), FRV (V2_Z Z_1), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n2_z_1_n2
      ;
      (FRF (F1_Neu N2), FRV (V2_Z Z_1), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n2_z_1_n3
      ;
      (FRF (F1_Neu N2), FRV (V2_Z Z_1), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n2_z_1_n4
      ;
      (FRF (F1_Neu N3), FRV (V2_Z Z_1), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n3_z_1_n3
      ;
      (FRF (F1_Neu N3), FRV (V2_Z Z_1), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n3_z_1_n4
      ;
      (FRF (F1_Neu N4), FRV (V2_Z Z_1), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.VLR, Coupling.Chi),
       G_n4_z_1_n4
      ;
      (FRF (F4_Vl Ve_bar), FRS (S7_Sn Sv1), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_ve_bar_sv1_n1
      ;
      (FRF (F4_Vl Vm_bar), FRS (S7_Sn Sv2), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vm_bar_sv2_n1
      ;
      (FRF (F4_Vl Vt_bar), FRS (S7_Sn Sv3), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vt_bar_sv3_n1
      ;
      (FRF (F4_Vl Ve_bar), FRS (S7_Sn Sv1), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_ve_bar_sv1_n2
      ;
      (FRF (F4_Vl Vm_bar), FRS (S7_Sn Sv2), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vm_bar_sv2_n2
      ;
      (FRF (F4_Vl Vt_bar), FRS (S7_Sn Sv3), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vt_bar_sv3_n2
      ;
      (FRF (F4_Vl Ve_bar), FRS (S7_Sn Sv1), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_ve_bar_sv1_n3
      ;
      (FRF (F4_Vl Vm_bar), FRS (S7_Sn Sv2), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vm_bar_sv2_n3
      ;
      (FRF (F4_Vl Vt_bar), FRS (S7_Sn Sv3), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vt_bar_sv3_n3
      ;
      (FRF (F4_Vl Ve_bar), FRS (S7_Sn Sv1), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_ve_bar_sv1_n4
      ;
      (FRF (F4_Vl Vm_bar), FRS (S7_Sn Sv2), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vm_bar_sv2_n4
      ;
      (FRF (F4_Vl Vt_bar), FRS (S7_Sn Sv3), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_vt_bar_sv3_n4
      ;
      (FRF (F1_Neu N1), FRS (S7_Sn Sv1_bar), FRF (F4_Vl Ve)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n1_sv1_bar_ve
      ;
      (FRF (F1_Neu N1), FRS (S7_Sn Sv2_bar), FRF (F4_Vl Vm)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n1_sv2_bar_vm
      ;
      (FRF (F1_Neu N1), FRS (S7_Sn Sv3_bar), FRF (F4_Vl Vt)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n1_sv3_bar_vt
      ;
      (FRF (F1_Neu N2), FRS (S7_Sn Sv1_bar), FRF (F4_Vl Ve)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n2_sv1_bar_ve
      ;
      (FRF (F1_Neu N2), FRS (S7_Sn Sv2_bar), FRF (F4_Vl Vm)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n2_sv2_bar_vm
      ;
      (FRF (F1_Neu N2), FRS (S7_Sn Sv3_bar), FRF (F4_Vl Vt)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n2_sv3_bar_vt
      ;
      (FRF (F1_Neu N3), FRS (S7_Sn Sv1_bar), FRF (F4_Vl Ve)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n3_sv1_bar_ve
      ;
      (FRF (F1_Neu N3), FRS (S7_Sn Sv2_bar), FRF (F4_Vl Vm)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n3_sv2_bar_vm
      ;
      (FRF (F1_Neu N3), FRS (S7_Sn Sv3_bar), FRF (F4_Vl Vt)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n3_sv3_bar_vt
      ;
      (FRF (F1_Neu N4), FRS (S7_Sn Sv1_bar), FRF (F4_Vl Ve)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n4_sv1_bar_ve
      ;
      (FRF (F1_Neu N4), FRS (S7_Sn Sv2_bar), FRF (F4_Vl Vm)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n4_sv2_bar_vm
      ;
      (FRF (F1_Neu N4), FRS (S7_Sn Sv3_bar), FRF (F4_Vl Vt)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n4_sv3_bar_vt
      ;
      (FRF (F6_Uq U_bar), FRS (S9_Su Su1), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_u_bar_su1_n1
      ;
      (FRF (F6_Uq C_bar), FRS (S9_Su Su2), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_c_bar_su2_n1
      ;
      (FRF (F6_Uq T_bar), FRS (S9_Su Su3), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_su3_n1
      ;
      (FRF (F6_Uq U_bar), FRS (S9_Su Su4), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_u_bar_su4_n1
      ;
      (FRF (F6_Uq C_bar), FRS (S9_Su Su5), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_c_bar_su5_n1
      ;
      (FRF (F6_Uq T_bar), FRS (S9_Su Su6), FRF (F1_Neu N1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_su6_n1
      ;
      (FRF (F6_Uq U_bar), FRS (S9_Su Su1), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_u_bar_su1_n2
      ;
      (FRF (F6_Uq C_bar), FRS (S9_Su Su2), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_c_bar_su2_n2
      ;
      (FRF (F6_Uq T_bar), FRS (S9_Su Su3), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_su3_n2
      ;
      (FRF (F6_Uq U_bar), FRS (S9_Su Su4), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_u_bar_su4_n2
      ;
      (FRF (F6_Uq C_bar), FRS (S9_Su Su5), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_c_bar_su5_n2
      ;
      (FRF (F6_Uq T_bar), FRS (S9_Su Su6), FRF (F1_Neu N2)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_su6_n2
      ;
      (FRF (F6_Uq U_bar), FRS (S9_Su Su1), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_u_bar_su1_n3
      ;
      (FRF (F6_Uq C_bar), FRS (S9_Su Su2), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_c_bar_su2_n3
      ;
      (FRF (F6_Uq T_bar), FRS (S9_Su Su3), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_su3_n3
      ;
      (FRF (F6_Uq U_bar), FRS (S9_Su Su4), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_u_bar_su4_n3
      ;
      (FRF (F6_Uq C_bar), FRS (S9_Su Su5), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_c_bar_su5_n3
      ;
      (FRF (F6_Uq T_bar), FRS (S9_Su Su6), FRF (F1_Neu N3)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_su6_n3
      ;
      (FRF (F6_Uq U_bar), FRS (S9_Su Su1), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_u_bar_su1_n4
      ;
      (FRF (F6_Uq C_bar), FRS (S9_Su Su2), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_c_bar_su2_n4
      ;
      (FRF (F6_Uq T_bar), FRS (S9_Su Su3), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_su3_n4
      ;
      (FRF (F6_Uq U_bar), FRS (S9_Su Su4), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_u_bar_su4_n4
      ;
      (FRF (F6_Uq C_bar), FRS (S9_Su Su5), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_c_bar_su5_n4
      ;
      (FRF (F6_Uq T_bar), FRS (S9_Su Su6), FRF (F1_Neu N4)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_su6_n4
      ;
      (FRF (F1_Neu N1), FRS (S9_Su Su1_bar), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n1_su1_bar_u
      ;
      (FRF (F1_Neu N1), FRS (S9_Su Su2_bar), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n1_su2_bar_c
      ;
      (FRF (F1_Neu N1), FRS (S9_Su Su3_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su3_bar_t
      ;
      (FRF (F1_Neu N1), FRS (S9_Su Su4_bar), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_su4_bar_u
      ;
      (FRF (F1_Neu N1), FRS (S9_Su Su5_bar), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n1_su5_bar_c
      ;
      (FRF (F1_Neu N1), FRS (S9_Su Su6_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n1_su6_bar_t
      ;
      (FRF (F1_Neu N2), FRS (S9_Su Su1_bar), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n2_su1_bar_u
      ;
      (FRF (F1_Neu N2), FRS (S9_Su Su2_bar), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n2_su2_bar_c
      ;
      (FRF (F1_Neu N2), FRS (S9_Su Su3_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su3_bar_t
      ;
      (FRF (F1_Neu N2), FRS (S9_Su Su4_bar), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_su4_bar_u
      ;
      (FRF (F1_Neu N2), FRS (S9_Su Su5_bar), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n2_su5_bar_c
      ;
      (FRF (F1_Neu N2), FRS (S9_Su Su6_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n2_su6_bar_t
      ;
      (FRF (F1_Neu N3), FRS (S9_Su Su1_bar), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n3_su1_bar_u
      ;
      (FRF (F1_Neu N3), FRS (S9_Su Su2_bar), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n3_su2_bar_c
      ;
      (FRF (F1_Neu N3), FRS (S9_Su Su3_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su3_bar_t
      ;
      (FRF (F1_Neu N3), FRS (S9_Su Su4_bar), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_su4_bar_u
      ;
      (FRF (F1_Neu N3), FRS (S9_Su Su5_bar), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n3_su5_bar_c
      ;
      (FRF (F1_Neu N3), FRS (S9_Su Su6_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n3_su6_bar_t
      ;
      (FRF (F1_Neu N4), FRS (S9_Su Su1_bar), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n4_su1_bar_u
      ;
      (FRF (F1_Neu N4), FRS (S9_Su Su2_bar), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_n4_su2_bar_c
      ;
      (FRF (F1_Neu N4), FRS (S9_Su Su3_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su3_bar_t
      ;
      (FRF (F1_Neu N4), FRS (S9_Su Su4_bar), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_su4_bar_u
      ;
      (FRF (F1_Neu N4), FRS (S9_Su Su5_bar), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_n4_su5_bar_c
      ;
      (FRF (F1_Neu N4), FRS (S9_Su Su6_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_n4_su6_bar_t
      ;
      (FRV (V2_Z Z_1), FRS (S10_Sd Sd1), FRS (S10_Sd Sd1_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd1_sd1_bar
      ;
      (FRV (V2_Z Z_1), FRS (S10_Sd Sd2), FRS (S10_Sd Sd2_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd2_sd2_bar
      ;
      (FRV (V2_Z Z_1), FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd3_sd3_bar
      ;
      (FRV (V2_Z Z_1), FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd3_sd6_bar
      ;
      (FRV (V2_Z Z_1), FRS (S10_Sd Sd4), FRS (S10_Sd Sd4_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd4_sd4_bar
      ;
      (FRV (V2_Z Z_1), FRS (S10_Sd Sd5), FRS (S10_Sd Sd5_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd5_sd5_bar
      ;
      (FRV (V2_Z Z_1), FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd3_bar_sd6
      ;
      (FRV (V2_Z Z_1), FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sd6_sd6_bar
      ;
      (FRV (V3_W W_plus), FRS (S10_Sd Sd1), FRS (S9_Su Su1_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_sd1_su1_bar
      ;
      (FRV (V3_W W_plus), FRS (S10_Sd Sd2), FRS (S9_Su Su2_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_sd2_su2_bar
      ;
      (FRV (V3_W W_plus), FRS (S10_Sd Sd3), FRS (S9_Su Su3_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_sd3_su3_bar
      ;
      (FRV (V3_W W_plus), FRS (S10_Sd Sd3), FRS (S9_Su Su6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_sd3_su6_bar
      ;
      (FRV (V3_W W_plus), FRS (S10_Sd Sd6), FRS (S9_Su Su3_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_sd6_su3_bar
      ;
      (FRV (V3_W W_plus), FRS (S10_Sd Sd6), FRS (S9_Su Su6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_sd6_su6_bar
      ;
      (FRV (V3_W W_minus), FRS (S10_Sd Sd1_bar), FRS (S9_Su Su1)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_minus_sd1_bar_su1
      ;
      (FRV (V3_W W_minus), FRS (S10_Sd Sd2_bar), FRS (S9_Su Su2)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_minus_sd2_bar_su2
      ;
      (FRV (V3_W W_minus), FRS (S10_Sd Sd3_bar), FRS (S9_Su Su3)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_minus_sd3_bar_su3
      ;
      (FRV (V3_W W_minus), FRS (S10_Sd Sd3_bar), FRS (S9_Su Su6)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_minus_sd3_bar_su6
      ;
      (FRV (V3_W W_minus), FRS (S10_Sd Sd6_bar), FRS (S9_Su Su3)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_minus_sd6_bar_su3
      ;
      (FRV (V3_W W_minus), FRS (S10_Sd Sd6_bar), FRS (S9_Su Su6)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_minus_sd6_bar_su6
      ;
      (FRV (V2_Z Z_1), FRS (S8_Sl Sl1_minus), FRS (S8_Sl Sl1_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sl1_minus_sl1_plus
      ;
      (FRV (V2_Z Z_1), FRS (S8_Sl Sl2_minus), FRS (S8_Sl Sl2_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sl2_minus_sl2_plus
      ;
      (FRV (V2_Z Z_1), FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl3_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sl3_minus_sl3_plus
      ;
      (FRV (V2_Z Z_1), FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl6_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sl3_minus_sl6_plus
      ;
      (FRV (V2_Z Z_1), FRS (S8_Sl Sl4_minus), FRS (S8_Sl Sl4_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sl4_minus_sl4_plus
      ;
      (FRV (V2_Z Z_1), FRS (S8_Sl Sl5_minus), FRS (S8_Sl Sl5_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sl5_minus_sl5_plus
      ;
      (FRV (V2_Z Z_1), FRS (S8_Sl Sl3_plus), FRS (S8_Sl Sl6_minus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sl3_plus_sl6_minus
      ;
      (FRV (V2_Z Z_1), FRS (S8_Sl Sl6_minus), FRS (S8_Sl Sl6_plus)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sl6_minus_sl6_plus
      ;
      (FRV (V3_W W_plus), FRS (S8_Sl Sl1_minus), FRS (S7_Sn Sv1_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_sl1_minus_sv1_bar
      ;
      (FRV (V3_W W_plus), FRS (S8_Sl Sl2_minus), FRS (S7_Sn Sv2_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_sl2_minus_sv2_bar
      ;
      (FRV (V3_W W_plus), FRS (S8_Sl Sl3_minus), FRS (S7_Sn Sv3_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_sl3_minus_sv3_bar
      ;
      (FRV (V3_W W_plus), FRS (S8_Sl Sl6_minus), FRS (S7_Sn Sv3_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_plus_sl6_minus_sv3_bar
      ;
      (FRV (V3_W W_minus), FRS (S8_Sl Sl1_plus), FRS (S7_Sn Sv1)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_minus_sl1_plus_sv1
      ;
      (FRV (V3_W W_minus), FRS (S8_Sl Sl2_plus), FRS (S7_Sn Sv2)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_minus_sl2_plus_sv2
      ;
      (FRV (V3_W W_minus), FRS (S8_Sl Sl3_plus), FRS (S7_Sn Sv3)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_minus_sl3_plus_sv3
      ;
      (FRV (V3_W W_minus), FRS (S8_Sl Sl6_plus), FRS (S7_Sn Sv3)),
       Coupling.Vector_Scalar_Scalar 1,
       G_w_minus_sl6_plus_sv3
      ;
      (FRV (V2_Z Z_1), FRS (S7_Sn Sv1), FRS (S7_Sn Sv1_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sv1_sv1_bar
      ;
      (FRV (V2_Z Z_1), FRS (S7_Sn Sv2), FRS (S7_Sn Sv2_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sv1_sv1_bar
      ;
      (FRV (V2_Z Z_1), FRS (S7_Sn Sv3), FRS (S7_Sn Sv3_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_sv1_sv1_bar
      ;
      (FRV (V2_Z Z_1), FRS (S9_Su Su1), FRS (S9_Su Su1_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su1_su1_bar
      ;
      (FRV (V2_Z Z_1), FRS (S9_Su Su2), FRS (S9_Su Su2_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su2_su2_bar
      ;
      (FRV (V2_Z Z_1), FRS (S9_Su Su3), FRS (S9_Su Su3_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su3_su3_bar
      ;
      (FRV (V2_Z Z_1), FRS (S9_Su Su3), FRS (S9_Su Su6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su3_su6_bar
      ;
      (FRV (V2_Z Z_1), FRS (S9_Su Su4), FRS (S9_Su Su4_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su4_su4_bar
      ;
      (FRV (V2_Z Z_1), FRS (S9_Su Su5), FRS (S9_Su Su5_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su5_su5_bar
      ;
      (FRV (V2_Z Z_1), FRS (S9_Su Su3_bar), FRS (S9_Su Su6)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su3_bar_su6
      ;
      (FRV (V2_Z Z_1), FRS (S9_Su Su6), FRS (S9_Su Su6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_z_1_su6_su6_bar
      ;
      (FRF (F6_Uq U_bar), FRV (V2_Z Z_1), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u_bar_z_1_u
      ;
      (FRF (F6_Uq C_bar), FRV (V2_Z Z_1), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u_bar_z_1_u
      ;
      (FRF (F6_Uq T_bar), FRV (V2_Z Z_1), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VLR, Coupling.Psi),
       G_u_bar_z_1_u
      ;
      (FRF (F4_Vl Ve_bar), FRV (V2_Z Z_1), FRF (F4_Vl Ve)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_ve_bar_z_1_ve
      ;
      (FRF (F4_Vl Vm_bar), FRV (V2_Z Z_1), FRF (F4_Vl Vm)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_ve_bar_z_1_ve
      ;
      (FRF (F4_Vl Vt_bar), FRV (V2_Z Z_1), FRF (F4_Vl Vt)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.VL, Coupling.Psi),
       G_ve_bar_z_1_ve
   ]

   let vertices_3_qcd = [
      (FRV (V4_G G_1), FRV (V4_G G_1), FRV (V4_G G_1)),
       Gauge_Gauge_Gauge 1,
       G_g_1_g_1_g_1
      ;
      (FRF (F3_Go Go_1), FRV (V4_G G_1), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Chibar, Coupling.V, Coupling.Chi),
       G_go_1_g_1_go_1
      ;
      (FRF (F7_Dq D_bar), FRV (V4_G G_1), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_d_bar_g_1_d
      ;
      (FRF (F7_Dq S_bar), FRV (V4_G G_1), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_d_bar_g_1_d
      ;
      (FRF (F7_Dq B_bar), FRV (V4_G G_1), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_d_bar_g_1_d
      ;
      (FRF (F3_Go Go_1), FRS (S10_Sd Sd1_bar), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_go_1_sd1_bar_d
      ;
      (FRF (F3_Go Go_1), FRS (S10_Sd Sd4_bar), FRF (F7_Dq D)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_go_1_sd4_bar_d
      ;
      (FRF (F3_Go Go_1), FRS (S10_Sd Sd2_bar), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_go_1_sd2_bar_s
      ;
      (FRF (F3_Go Go_1), FRS (S10_Sd Sd5_bar), FRF (F7_Dq S)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_go_1_sd5_bar_s
      ;
      (FRF (F3_Go Go_1), FRS (S10_Sd Sd3_bar), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd3_bar_b
      ;
      (FRF (F3_Go Go_1), FRS (S10_Sd Sd6_bar), FRF (F7_Dq B)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_sd6_bar_b
      ;
      (FRF (F7_Dq D_bar), FRS (S10_Sd Sd1), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_d_bar_sd1_go_1
      ;
      (FRF (F7_Dq D_bar), FRS (S10_Sd Sd4), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_d_bar_sd4_go_1
      ;
      (FRF (F7_Dq S_bar), FRS (S10_Sd Sd2), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_s_bar_sd2_go_1
      ;
      (FRF (F7_Dq S_bar), FRS (S10_Sd Sd5), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_s_bar_sd5_go_1
      ;
      (FRF (F7_Dq B_bar), FRS (S10_Sd Sd3), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_sd3_go_1
      ;
      (FRF (F7_Dq B_bar), FRS (S10_Sd Sd6), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_b_bar_sd6_go_1
      ;
      (FRV (V4_G G_1), FRS (S10_Sd Sd1), FRS (S10_Sd Sd1_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd1_sd1_bar
      ;
      (FRV (V4_G G_1), FRS (S10_Sd Sd2), FRS (S10_Sd Sd2_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd2_sd2_bar
      ;
      (FRV (V4_G G_1), FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd3_sd3_bar
      ;
      (FRV (V4_G G_1), FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd3_sd6_bar
      ;
      (FRV (V4_G G_1), FRS (S10_Sd Sd4), FRS (S10_Sd Sd4_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd4_sd4_bar
      ;
      (FRV (V4_G G_1), FRS (S10_Sd Sd5), FRS (S10_Sd Sd5_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd5_sd5_bar
      ;
      (FRV (V4_G G_1), FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd3_bar_sd6
      ;
      (FRV (V4_G G_1), FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_sd6_sd6_bar
      ;
      (FRV (V4_G G_1), FRS (S9_Su Su1), FRS (S9_Su Su1_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_su1_su1_bar
      ;
      (FRV (V4_G G_1), FRS (S9_Su Su2), FRS (S9_Su Su2_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_su2_su2_bar
      ;
      (FRV (V4_G G_1), FRS (S9_Su Su3), FRS (S9_Su Su3_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_su3_su3_bar
      ;
      (FRV (V4_G G_1), FRS (S9_Su Su3), FRS (S9_Su Su6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_su3_su6_bar
      ;
      (FRV (V4_G G_1), FRS (S9_Su Su4), FRS (S9_Su Su4_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_su4_su4_bar
      ;
      (FRV (V4_G G_1), FRS (S9_Su Su5), FRS (S9_Su Su5_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_su5_su5_bar
      ;
      (FRV (V4_G G_1), FRS (S9_Su Su3_bar), FRS (S9_Su Su6)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_su3_bar_su6
      ;
      (FRV (V4_G G_1), FRS (S9_Su Su6), FRS (S9_Su Su6_bar)),
       Coupling.Vector_Scalar_Scalar 1,
       G_g_1_su6_su6_bar
      ;
      (FRF (F6_Uq U_bar), FRV (V4_G G_1), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_d_bar_g_1_d
      ;
      (FRF (F6_Uq C_bar), FRV (V4_G G_1), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_d_bar_g_1_d
      ;
      (FRF (F6_Uq T_bar), FRV (V4_G G_1), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.V, Coupling.Psi),
       G_d_bar_g_1_d
      ;
      (FRF (F6_Uq U_bar), FRS (S9_Su Su1), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_u_bar_su1_go_1
      ;
      (FRF (F6_Uq C_bar), FRS (S9_Su Su2), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_c_bar_su2_go_1
      ;
      (FRF (F6_Uq T_bar), FRS (S9_Su Su3), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_su3_go_1
      ;
      (FRF (F6_Uq U_bar), FRS (S9_Su Su4), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_u_bar_su4_go_1
      ;
      (FRF (F6_Uq C_bar), FRS (S9_Su Su5), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_c_bar_su5_go_1
      ;
      (FRF (F6_Uq T_bar), FRS (S9_Su Su6), FRF (F3_Go Go_1)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_t_bar_su6_go_1
      ;
      (FRF (F3_Go Go_1), FRS (S9_Su Su1_bar), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_go_1_su1_bar_u
      ;
      (FRF (F3_Go Go_1), FRS (S9_Su Su2_bar), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SL, Coupling.Psi),
       G_go_1_su2_bar_c
      ;
      (FRF (F3_Go Go_1), FRS (S9_Su Su3_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su3_bar_t
      ;
      (FRF (F3_Go Go_1), FRS (S9_Su Su4_bar), FRF (F6_Uq U)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_go_1_su4_bar_u
      ;
      (FRF (F3_Go Go_1), FRS (S9_Su Su5_bar), FRF (F6_Uq C)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SR, Coupling.Psi),
       G_go_1_su5_bar_c
      ;
      (FRF (F3_Go Go_1), FRS (S9_Su Su6_bar), FRF (F6_Uq T)),
       Coupling.FBF (1, Coupling.Psibar, Coupling.SLR, Coupling.Psi),
       G_go_1_su6_bar_t
   ]

   let vertices_4 = [
      (FRS (S4_H H_plus), FRS (S4_H H_minus), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_h_plus_h_minus_a_1_a_1
      ;
      (FRS (S1_H0 H01), FRS (S4_H H_minus), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_h01_h_minus_a_1_w_plus
      ;
      (FRS (S3_A0 A0_1), FRS (S4_H H_minus), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_a0_1_h_minus_a_1_w_plus
      ;
      (FRS (S2_H0_1 H02), FRS (S4_H H_minus), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_h02_h_minus_a_1_w_plus
      ;
      (FRS (S4_H H_plus), FRS (S1_H0 H01), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_h01_h_minus_a_1_w_plus
      ;
      (FRS (S3_A0 A0_1), FRS (S4_H H_plus), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_a0_1_h_plus_a_1_w_minus
      ;
      (FRS (S4_H H_plus), FRS (S2_H0_1 H02), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_h02_h_minus_a_1_w_plus
      ;
      (FRS (S1_H0 H01), FRS (S1_H0 H01), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_h01_h01_w_plus_w_minus
      ;
      (FRS (S2_H0_1 H02), FRS (S2_H0_1 H02), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_h01_h01_w_plus_w_minus
      ;
      (FRS (S3_A0 A0_1), FRS (S3_A0 A0_1), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_a0_1_a0_1_w_plus_w_minus
      ;
      (FRS (S4_H H_plus), FRS (S4_H H_minus), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_a0_1_a0_1_w_plus_w_minus
      ;
      (FRV (V1_A A_1), FRV (V1_A A_1), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Vector4 [2, Coupling.C_12_34; -1, Coupling.C_13_42; -1, Coupling.C_14_23],
       G_a_1_a_1_w_plus_w_minus
      ;
      (FRV (V3_W W_plus), FRV (V3_W W_plus), FRV (V3_W W_minus), FRV (V3_W W_minus)),
       Vector4 [2, Coupling.C_12_34; -1, Coupling.C_13_42; -1, Coupling.C_14_23],
       G_w_plus_w_plus_w_minus_w_minus
      ;
      (FRS (S4_H H_plus), FRS (S4_H H_minus), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h_plus_h_minus_a_1_z_1
      ;
      (FRS (S1_H0 H01), FRS (S4_H H_minus), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h01_h_minus_w_plus_z_1
      ;
      (FRS (S3_A0 A0_1), FRS (S4_H H_minus), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_a0_1_h_minus_w_plus_z_1
      ;
      (FRS (S2_H0_1 H02), FRS (S4_H H_minus), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h02_h_minus_w_plus_z_1
      ;
      (FRS (S4_H H_plus), FRS (S1_H0 H01), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h01_h_minus_w_plus_z_1
      ;
      (FRS (S3_A0 A0_1), FRS (S4_H H_plus), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_a0_1_h_plus_w_minus_z_1
      ;
      (FRS (S4_H H_plus), FRS (S2_H0_1 H02), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h02_h_minus_w_plus_z_1
      ;
      (FRV (V1_A A_1), FRV (V3_W W_plus), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Vector4 [1, Coupling.C_12_34; 1, Coupling.C_13_42; -2, Coupling.C_14_23],
       G_a_1_w_plus_w_minus_z_1
      ;
      (FRS (S1_H0 H01), FRS (S1_H0 H01), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h01_h01_z_1_z_1
      ;
      (FRS (S2_H0_1 H02), FRS (S2_H0_1 H02), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h01_h01_z_1_z_1
      ;
      (FRS (S3_A0 A0_1), FRS (S3_A0 A0_1), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_a0_1_a0_1_z_1_z_1
      ;
      (FRS (S4_H H_plus), FRS (S4_H H_minus), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_h_plus_h_minus_z_1_z_1
      ;
      (FRV (V3_W W_plus), FRV (V3_W W_minus), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Vector4 [2, Coupling.C_12_34; -1, Coupling.C_13_42; -1, Coupling.C_14_23],
       G_w_plus_w_minus_z_1_z_1
      ;
      (FRS (S10_Sd Sd1), FRS (S10_Sd Sd1_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1_bar_a_1_a_1
      ;
      (FRS (S10_Sd Sd2), FRS (S10_Sd Sd2_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd2_sd2_bar_a_1_a_1
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd3_bar_a_1_a_1
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_sd6_bar_a_1_a_1
      ;
      (FRS (S10_Sd Sd4), FRS (S10_Sd Sd4_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd4_sd4_bar_a_1_a_1
      ;
      (FRS (S10_Sd Sd5), FRS (S10_Sd Sd5_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd5_sd5_bar_a_1_a_1
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd3_bar_sd6_a_1_a_1
      ;
      (FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sd6_sd6_bar_a_1_a_1
      ;
      (FRS (S8_Sl Sl1_minus), FRS (S8_Sl Sl1_plus), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sl1_minus_sl1_plus_a_1_a_1
      ;
      (FRS (S8_Sl Sl2_minus), FRS (S8_Sl Sl2_plus), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sl2_minus_sl2_plus_a_1_a_1
      ;
      (FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl3_plus), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sl3_minus_sl3_plus_a_1_a_1
      ;
      (FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl6_plus), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sl3_minus_sl6_plus_a_1_a_1
      ;
      (FRS (S8_Sl Sl4_minus), FRS (S8_Sl Sl4_plus), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sl4_minus_sl4_plus_a_1_a_1
      ;
      (FRS (S8_Sl Sl5_minus), FRS (S8_Sl Sl5_plus), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sl5_minus_sl5_plus_a_1_a_1
      ;
      (FRS (S8_Sl Sl3_plus), FRS (S8_Sl Sl6_minus), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sl3_plus_sl6_minus_a_1_a_1
      ;
      (FRS (S8_Sl Sl6_minus), FRS (S8_Sl Sl6_plus), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_sl6_minus_sl6_plus_a_1_a_1
      ;
      (FRS (S9_Su Su1), FRS (S9_Su Su1_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su1_su1_bar_a_1_a_1
      ;
      (FRS (S9_Su Su2), FRS (S9_Su Su2_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su2_su2_bar_a_1_a_1
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su3_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su3_bar_a_1_a_1
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su6_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_su6_bar_a_1_a_1
      ;
      (FRS (S9_Su Su4), FRS (S9_Su Su4_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su4_su4_bar_a_1_a_1
      ;
      (FRS (S9_Su Su5), FRS (S9_Su Su5_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su5_su5_bar_a_1_a_1
      ;
      (FRS (S9_Su Su3_bar), FRS (S9_Su Su6), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su3_bar_su6_a_1_a_1
      ;
      (FRS (S9_Su Su6), FRS (S9_Su Su6_bar), FRV (V1_A A_1), FRV (V1_A A_1)),
       Scalar2_Vector2 1,
       G_su6_su6_bar_a_1_a_1
      ;
      (FRS (S10_Sd Sd1), FRS (S10_Sd Sd1_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1_bar_a_1_z_1
      ;
      (FRS (S10_Sd Sd2), FRS (S10_Sd Sd2_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd2_bar_a_1_z_1
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd3_bar_a_1_z_1
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd6_bar_a_1_z_1
      ;
      (FRS (S10_Sd Sd4), FRS (S10_Sd Sd4_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd4_bar_a_1_z_1
      ;
      (FRS (S10_Sd Sd5), FRS (S10_Sd Sd5_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd5_bar_a_1_z_1
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_bar_sd6_a_1_z_1
      ;
      (FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd6_bar_a_1_z_1
      ;
      (FRS (S10_Sd Sd1), FRS (S9_Su Su1_bar), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sd1_su1_bar_a_1_w_plus
      ;
      (FRS (S10_Sd Sd2), FRS (S9_Su Su2_bar), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sd2_su2_bar_a_1_w_plus
      ;
      (FRS (S10_Sd Sd3), FRS (S9_Su Su3_bar), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sd3_su3_bar_a_1_w_plus
      ;
      (FRS (S10_Sd Sd3), FRS (S9_Su Su6_bar), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sd3_su6_bar_a_1_w_plus
      ;
      (FRS (S10_Sd Sd6), FRS (S9_Su Su3_bar), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sd6_su3_bar_a_1_w_plus
      ;
      (FRS (S10_Sd Sd6), FRS (S9_Su Su6_bar), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sd6_su6_bar_a_1_w_plus
      ;
      (FRS (S10_Sd Sd1_bar), FRS (S9_Su Su1), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd1_bar_su1_a_1_w_minus
      ;
      (FRS (S10_Sd Sd2_bar), FRS (S9_Su Su2), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd2_bar_su2_a_1_w_minus
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S9_Su Su3), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd3_bar_su3_a_1_w_minus
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S9_Su Su6), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd3_bar_su6_a_1_w_minus
      ;
      (FRS (S10_Sd Sd6_bar), FRS (S9_Su Su3), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd6_bar_su3_a_1_w_minus
      ;
      (FRS (S10_Sd Sd6_bar), FRS (S9_Su Su6), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd6_bar_su6_a_1_w_minus
      ;
      (FRS (S8_Sl Sl1_minus), FRS (S8_Sl Sl1_plus), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl1_minus_sl1_plus_a_1_z_1
      ;
      (FRS (S8_Sl Sl2_minus), FRS (S8_Sl Sl2_plus), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl2_minus_sl2_plus_a_1_z_1
      ;
      (FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl3_plus), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl3_minus_sl3_plus_a_1_z_1
      ;
      (FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl6_plus), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl3_minus_sl6_plus_a_1_z_1
      ;
      (FRS (S8_Sl Sl4_minus), FRS (S8_Sl Sl4_plus), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl4_minus_sl4_plus_a_1_z_1
      ;
      (FRS (S8_Sl Sl5_minus), FRS (S8_Sl Sl5_plus), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl5_minus_sl5_plus_a_1_z_1
      ;
      (FRS (S8_Sl Sl3_plus), FRS (S8_Sl Sl6_minus), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl3_plus_sl6_minus_a_1_z_1
      ;
      (FRS (S8_Sl Sl6_minus), FRS (S8_Sl Sl6_plus), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl6_minus_sl6_plus_a_1_z_1
      ;
      (FRS (S8_Sl Sl1_minus), FRS (S7_Sn Sv1_bar), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sl1_minus_sv1_bar_a_1_w_plus
      ;
      (FRS (S8_Sl Sl2_minus), FRS (S7_Sn Sv2_bar), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sl2_minus_sv2_bar_a_1_w_plus
      ;
      (FRS (S8_Sl Sl3_minus), FRS (S7_Sn Sv3_bar), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sl3_minus_sv3_bar_a_1_w_plus
      ;
      (FRS (S8_Sl Sl6_minus), FRS (S7_Sn Sv3_bar), FRV (V1_A A_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sl6_minus_sv3_bar_a_1_w_plus
      ;
      (FRS (S8_Sl Sl1_plus), FRS (S7_Sn Sv1), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sl1_plus_sv1_a_1_w_minus
      ;
      (FRS (S8_Sl Sl2_plus), FRS (S7_Sn Sv2), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sl2_plus_sv2_a_1_w_minus
      ;
      (FRS (S8_Sl Sl3_plus), FRS (S7_Sn Sv3), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sl3_plus_sv3_a_1_w_minus
      ;
      (FRS (S8_Sl Sl6_plus), FRS (S7_Sn Sv3), FRV (V1_A A_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sl6_plus_sv3_a_1_w_minus
      ;
      (FRS (S9_Su Su1), FRS (S9_Su Su1_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su1_bar_a_1_z_1
      ;
      (FRS (S9_Su Su2), FRS (S9_Su Su2_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su2_bar_a_1_z_1
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su3_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su3_bar_a_1_z_1
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su6_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su6_bar_a_1_z_1
      ;
      (FRS (S9_Su Su4), FRS (S9_Su Su4_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su4_bar_a_1_z_1
      ;
      (FRS (S9_Su Su5), FRS (S9_Su Su5_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su5_bar_a_1_z_1
      ;
      (FRS (S9_Su Su3_bar), FRS (S9_Su Su6), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_bar_su6_a_1_z_1
      ;
      (FRS (S9_Su Su6), FRS (S9_Su Su6_bar), FRV (V1_A A_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su6_bar_a_1_z_1
      ;
      (FRS (S10_Sd Sd1), FRS (S10_Sd Sd1_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd1_sd1_bar_w_plus_w_minus
      ;
      (FRS (S10_Sd Sd2), FRS (S10_Sd Sd2_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd2_sd2_bar_w_plus_w_minus
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd3_sd3_bar_w_plus_w_minus
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd3_sd6_bar_w_plus_w_minus
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd3_bar_sd6_w_plus_w_minus
      ;
      (FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd6_sd6_bar_w_plus_w_minus
      ;
      (FRS (S10_Sd Sd1), FRS (S10_Sd Sd1_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1_bar_z_1_z_1
      ;
      (FRS (S10_Sd Sd2), FRS (S10_Sd Sd2_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd2_bar_z_1_z_1
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd3_bar_z_1_z_1
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd6_bar_z_1_z_1
      ;
      (FRS (S10_Sd Sd4), FRS (S10_Sd Sd4_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd4_bar_z_1_z_1
      ;
      (FRS (S10_Sd Sd5), FRS (S10_Sd Sd5_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd5_bar_z_1_z_1
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_bar_sd6_z_1_z_1
      ;
      (FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd6_bar_z_1_z_1
      ;
      (FRS (S10_Sd Sd1), FRS (S9_Su Su1_bar), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_su1_bar_w_plus_z_1
      ;
      (FRS (S10_Sd Sd2), FRS (S9_Su Su2_bar), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_su2_bar_w_plus_z_1
      ;
      (FRS (S10_Sd Sd3), FRS (S9_Su Su3_bar), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_su3_bar_w_plus_z_1
      ;
      (FRS (S10_Sd Sd3), FRS (S9_Su Su6_bar), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_su6_bar_w_plus_z_1
      ;
      (FRS (S10_Sd Sd6), FRS (S9_Su Su3_bar), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_su3_bar_w_plus_z_1
      ;
      (FRS (S10_Sd Sd6), FRS (S9_Su Su6_bar), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_su6_bar_w_plus_z_1
      ;
      (FRS (S10_Sd Sd1_bar), FRS (S9_Su Su1), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_bar_su1_w_minus_z_1
      ;
      (FRS (S10_Sd Sd2_bar), FRS (S9_Su Su2), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_bar_su2_w_minus_z_1
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S9_Su Su3), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_bar_su3_w_minus_z_1
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S9_Su Su6), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_bar_su6_w_minus_z_1
      ;
      (FRS (S10_Sd Sd6_bar), FRS (S9_Su Su3), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_bar_su3_w_minus_z_1
      ;
      (FRS (S10_Sd Sd6_bar), FRS (S9_Su Su6), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_bar_su6_w_minus_z_1
      ;
      (FRS (S8_Sl Sl1_minus), FRS (S8_Sl Sl1_plus), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sl1_minus_sl1_plus_w_plus_w_minus
      ;
      (FRS (S8_Sl Sl2_minus), FRS (S8_Sl Sl2_plus), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sl2_minus_sl2_plus_w_plus_w_minus
      ;
      (FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl3_plus), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sl3_minus_sl3_plus_w_plus_w_minus
      ;
      (FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl6_plus), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sl3_minus_sl6_plus_w_plus_w_minus
      ;
      (FRS (S8_Sl Sl3_plus), FRS (S8_Sl Sl6_minus), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sl3_plus_sl6_minus_w_plus_w_minus
      ;
      (FRS (S8_Sl Sl6_minus), FRS (S8_Sl Sl6_plus), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sl6_minus_sl6_plus_w_plus_w_minus
      ;
      (FRS (S8_Sl Sl1_minus), FRS (S8_Sl Sl1_plus), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl1_minus_sl1_plus_z_1_z_1
      ;
      (FRS (S8_Sl Sl2_minus), FRS (S8_Sl Sl2_plus), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl2_minus_sl2_plus_z_1_z_1
      ;
      (FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl3_plus), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl3_minus_sl3_plus_z_1_z_1
      ;
      (FRS (S8_Sl Sl3_minus), FRS (S8_Sl Sl6_plus), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl3_minus_sl6_plus_z_1_z_1
      ;
      (FRS (S8_Sl Sl4_minus), FRS (S8_Sl Sl4_plus), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl4_minus_sl4_plus_z_1_z_1
      ;
      (FRS (S8_Sl Sl5_minus), FRS (S8_Sl Sl5_plus), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl5_minus_sl5_plus_z_1_z_1
      ;
      (FRS (S8_Sl Sl3_plus), FRS (S8_Sl Sl6_minus), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl3_plus_sl6_minus_z_1_z_1
      ;
      (FRS (S8_Sl Sl6_minus), FRS (S8_Sl Sl6_plus), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl6_minus_sl6_plus_z_1_z_1
      ;
      (FRS (S8_Sl Sl1_minus), FRS (S7_Sn Sv1_bar), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl1_minus_sv1_bar_w_plus_z_1
      ;
      (FRS (S8_Sl Sl2_minus), FRS (S7_Sn Sv2_bar), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl2_minus_sv2_bar_w_plus_z_1
      ;
      (FRS (S8_Sl Sl3_minus), FRS (S7_Sn Sv3_bar), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl3_minus_sv3_bar_w_plus_z_1
      ;
      (FRS (S8_Sl Sl6_minus), FRS (S7_Sn Sv3_bar), FRV (V3_W W_plus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl6_minus_sv3_bar_w_plus_z_1
      ;
      (FRS (S8_Sl Sl1_plus), FRS (S7_Sn Sv1), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl1_plus_sv1_w_minus_z_1
      ;
      (FRS (S8_Sl Sl2_plus), FRS (S7_Sn Sv2), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl2_plus_sv2_w_minus_z_1
      ;
      (FRS (S8_Sl Sl3_plus), FRS (S7_Sn Sv3), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl3_plus_sv3_w_minus_z_1
      ;
      (FRS (S8_Sl Sl6_plus), FRS (S7_Sn Sv3), FRV (V3_W W_minus), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sl6_plus_sv3_w_minus_z_1
      ;
      (FRS (S7_Sn Sv1), FRS (S7_Sn Sv1_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sv1_sv1_bar_w_plus_w_minus
      ;
      (FRS (S7_Sn Sv2), FRS (S7_Sn Sv2_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sv1_sv1_bar_w_plus_w_minus
      ;
      (FRS (S7_Sn Sv3), FRS (S7_Sn Sv3_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sv1_sv1_bar_w_plus_w_minus
      ;
      (FRS (S7_Sn Sv1), FRS (S7_Sn Sv1_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv1_sv1_bar_z_1_z_1
      ;
      (FRS (S7_Sn Sv2), FRS (S7_Sn Sv2_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv1_sv1_bar_z_1_z_1
      ;
      (FRS (S7_Sn Sv3), FRS (S7_Sn Sv3_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sv1_sv1_bar_z_1_z_1
      ;
      (FRS (S9_Su Su1), FRS (S9_Su Su1_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_su1_su1_bar_w_plus_w_minus
      ;
      (FRS (S9_Su Su2), FRS (S9_Su Su2_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_su2_su2_bar_w_plus_w_minus
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su3_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_su3_su3_bar_w_plus_w_minus
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su6_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_su3_su6_bar_w_plus_w_minus
      ;
      (FRS (S9_Su Su3_bar), FRS (S9_Su Su6), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_su3_bar_su6_w_plus_w_minus
      ;
      (FRS (S9_Su Su6), FRS (S9_Su Su6_bar), FRV (V3_W W_plus), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_su6_su6_bar_w_plus_w_minus
      ;
      (FRS (S9_Su Su1), FRS (S9_Su Su1_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su1_bar_z_1_z_1
      ;
      (FRS (S9_Su Su2), FRS (S9_Su Su2_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su2_bar_z_1_z_1
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su3_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su3_bar_z_1_z_1
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su6_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su6_bar_z_1_z_1
      ;
      (FRS (S9_Su Su4), FRS (S9_Su Su4_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su4_bar_z_1_z_1
      ;
      (FRS (S9_Su Su5), FRS (S9_Su Su5_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su5_bar_z_1_z_1
      ;
      (FRS (S9_Su Su3_bar), FRS (S9_Su Su6), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_bar_su6_z_1_z_1
      ;
      (FRS (S9_Su Su6), FRS (S9_Su Su6_bar), FRV (V2_Z Z_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su6_bar_z_1_z_1
   ]

   let vertices_4_qcd = [
      (FRV (V4_G G_1), FRV (V4_G G_1), FRV (V4_G G_1), FRV (V4_G G_1)),
       Vector4 [1, Coupling.C_12_34; -2, Coupling.C_13_42; 1, Coupling.C_14_23],
       G_g_1_g_1_g_1_g_1
      ;
      (FRS (S10_Sd Sd1), FRS (S10_Sd Sd1_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1_bar_a_1_g_1
      ;
      (FRS (S10_Sd Sd2), FRS (S10_Sd Sd2_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd2_sd2_bar_a_1_g_1
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd3_sd3_bar_a_1_g_1
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd3_sd6_bar_a_1_g_1
      ;
      (FRS (S10_Sd Sd4), FRS (S10_Sd Sd4_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd4_sd4_bar_a_1_g_1
      ;
      (FRS (S10_Sd Sd5), FRS (S10_Sd Sd5_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd5_sd5_bar_a_1_g_1
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd3_bar_sd6_a_1_g_1
      ;
      (FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd6_sd6_bar_a_1_g_1
      ;
      (FRS (S9_Su Su1), FRS (S9_Su Su1_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su1_su1_bar_a_1_g_1
      ;
      (FRS (S9_Su Su2), FRS (S9_Su Su2_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su2_su2_bar_a_1_g_1
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su3_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su3_su3_bar_a_1_g_1
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su6_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su3_su6_bar_a_1_g_1
      ;
      (FRS (S9_Su Su4), FRS (S9_Su Su4_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su4_su4_bar_a_1_g_1
      ;
      (FRS (S9_Su Su5), FRS (S9_Su Su5_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su5_su5_bar_a_1_g_1
      ;
      (FRS (S9_Su Su3_bar), FRS (S9_Su Su6), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su3_bar_su6_a_1_g_1
      ;
      (FRS (S9_Su Su6), FRS (S9_Su Su6_bar), FRV (V1_A A_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su6_su6_bar_a_1_g_1
      ;
      (FRS (S10_Sd Sd1), FRS (S10_Sd Sd1_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1_bar_g_1_g_1
      ;
      (FRS (S10_Sd Sd2), FRS (S10_Sd Sd2_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd2_sd2_bar_g_1_g_1
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd3_sd3_bar_g_1_g_1
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd3_sd6_bar_g_1_g_1
      ;
      (FRS (S10_Sd Sd4), FRS (S10_Sd Sd4_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd4_sd4_bar_g_1_g_1
      ;
      (FRS (S10_Sd Sd5), FRS (S10_Sd Sd5_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd5_sd5_bar_g_1_g_1
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd3_bar_sd6_g_1_g_1
      ;
      (FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_sd6_sd6_bar_g_1_g_1
      ;
      (FRS (S9_Su Su1), FRS (S9_Su Su1_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su1_su1_bar_g_1_g_1
      ;
      (FRS (S9_Su Su2), FRS (S9_Su Su2_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su2_su2_bar_g_1_g_1
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su3_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su3_su3_bar_g_1_g_1
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su6_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su3_su6_bar_g_1_g_1
      ;
      (FRS (S9_Su Su4), FRS (S9_Su Su4_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su4_su4_bar_g_1_g_1
      ;
      (FRS (S9_Su Su5), FRS (S9_Su Su5_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su5_su5_bar_g_1_g_1
      ;
      (FRS (S9_Su Su3_bar), FRS (S9_Su Su6), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su3_bar_su6_g_1_g_1
      ;
      (FRS (S9_Su Su6), FRS (S9_Su Su6_bar), FRV (V4_G G_1), FRV (V4_G G_1)),
       Scalar2_Vector2 1,
       G_su6_su6_bar_g_1_g_1
      ;
      (FRS (S10_Sd Sd1), FRS (S10_Sd Sd1_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd1_sd1_bar_g_1_z_1
      ;
      (FRS (S10_Sd Sd2), FRS (S10_Sd Sd2_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd2_sd2_bar_g_1_z_1
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd3_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd3_bar_g_1_z_1
      ;
      (FRS (S10_Sd Sd3), FRS (S10_Sd Sd6_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_sd6_bar_g_1_z_1
      ;
      (FRS (S10_Sd Sd4), FRS (S10_Sd Sd4_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd4_sd4_bar_g_1_z_1
      ;
      (FRS (S10_Sd Sd5), FRS (S10_Sd Sd5_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd5_sd5_bar_g_1_z_1
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S10_Sd Sd6), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd3_bar_sd6_g_1_z_1
      ;
      (FRS (S10_Sd Sd6), FRS (S10_Sd Sd6_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_sd6_sd6_bar_g_1_z_1
      ;
      (FRS (S10_Sd Sd1), FRS (S9_Su Su1_bar), FRV (V4_G G_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sd1_su1_bar_g_1_w_plus
      ;
      (FRS (S10_Sd Sd2), FRS (S9_Su Su2_bar), FRV (V4_G G_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sd2_su2_bar_g_1_w_plus
      ;
      (FRS (S10_Sd Sd3), FRS (S9_Su Su3_bar), FRV (V4_G G_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sd3_su3_bar_g_1_w_plus
      ;
      (FRS (S10_Sd Sd3), FRS (S9_Su Su6_bar), FRV (V4_G G_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sd3_su6_bar_g_1_w_plus
      ;
      (FRS (S10_Sd Sd6), FRS (S9_Su Su3_bar), FRV (V4_G G_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sd6_su3_bar_g_1_w_plus
      ;
      (FRS (S10_Sd Sd6), FRS (S9_Su Su6_bar), FRV (V4_G G_1), FRV (V3_W W_plus)),
       Scalar2_Vector2 1,
       G_sd6_su6_bar_g_1_w_plus
      ;
      (FRS (S10_Sd Sd1_bar), FRS (S9_Su Su1), FRV (V4_G G_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd1_bar_su1_g_1_w_minus
      ;
      (FRS (S10_Sd Sd2_bar), FRS (S9_Su Su2), FRV (V4_G G_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd2_bar_su2_g_1_w_minus
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S9_Su Su3), FRV (V4_G G_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd3_bar_su3_g_1_w_minus
      ;
      (FRS (S10_Sd Sd3_bar), FRS (S9_Su Su6), FRV (V4_G G_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd3_bar_su6_g_1_w_minus
      ;
      (FRS (S10_Sd Sd6_bar), FRS (S9_Su Su3), FRV (V4_G G_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd6_bar_su3_g_1_w_minus
      ;
      (FRS (S10_Sd Sd6_bar), FRS (S9_Su Su6), FRV (V4_G G_1), FRV (V3_W W_minus)),
       Scalar2_Vector2 1,
       G_sd6_bar_su6_g_1_w_minus
      ;
      (FRS (S9_Su Su1), FRS (S9_Su Su1_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su1_su1_bar_g_1_z_1
      ;
      (FRS (S9_Su Su2), FRS (S9_Su Su2_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su2_su2_bar_g_1_z_1
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su3_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su3_bar_g_1_z_1
      ;
      (FRS (S9_Su Su3), FRS (S9_Su Su6_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_su6_bar_g_1_z_1
      ;
      (FRS (S9_Su Su4), FRS (S9_Su Su4_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su4_su4_bar_g_1_z_1
      ;
      (FRS (S9_Su Su5), FRS (S9_Su Su5_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su5_su5_bar_g_1_z_1
      ;
      (FRS (S9_Su Su3_bar), FRS (S9_Su Su6), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su3_bar_su6_g_1_z_1
      ;
      (FRS (S9_Su Su6), FRS (S9_Su Su6_bar), FRV (V4_G G_1), FRV (V2_Z Z_1)),
       Scalar2_Vector2 1,
       G_su6_su6_bar_g_1_z_1
   ]

   let vertices_n = []

   let vertices_n_qcd = []

   let vertices () = (
      vertices_3 @ (match Opts.color with true -> vertices_3_qcd | false -> []),
      vertices_4 @ (match Opts.color with true -> vertices_4_qcd | false -> []),
      vertices_n @ (match Opts.color with true -> vertices_n_qcd | false -> [])
   )

   module F = Modeltools.Fusions (struct
      type f = flavor
      type c = constant
      let compare = compare
      let conjugate = conjugate
   end)

   let table = F.of_vertices (vertices ())
   let fuse2 = F.fuse2 table
   let fuse3 = F.fuse3 table
   let fuse = F.fuse table

   (* Charge (stubbed) *)

   module Ch = Charges.Null
   let charges _ = ()

   (* Misc. infrastructure *)

   let options = Options.empty

   let rcs = RCS.parse "fr_mssm" ["automatically generated model"] {
      RCS.revision = "Revision: Noop";
      RCS.date = "Date: Noop";
      RCS.author = "Author: Mathematica automaton";
      RCS.source = "Source: Noop"
   }

   type flavor_sans_color = flavor
   let flavor_sans_color x = x
   let conjugate_sans_color = conjugate
   let flavor_sans_color_of_string = flavor_of_string
   let flavor_sans_color_to_string = flavor_to_string
   let flavor_sans_color_to_TeX = flavor_to_TeX
   let flavor_sans_color_symbol = flavor_symbol

end
